package ghmessen.adapter;

import ghmessen.components.JTransparentToggleButton;
import ghmessen.groesse.Messgroesse;

import java.awt.Rectangle;

import javax.swing.Action;

public abstract class EingangMehrereGroessen extends Eingang {

	protected IMesskanal[] messKanal;

	public EingangMehrereGroessen(IAdapter adapter, int input) {
		super(adapter, input);
		auswahl = 0;
		messKanal = null;
	}

	private static final boolean DEBUG = false;

	protected int auswahl = 0;

	@Override
	public int getAuswahl() {
		return auswahl;
	}

	@Override
	public void setAuswahl(int auswahl) {
		if (DEBUG)
			System.out.println("[EingangMehrereGroessen] - setAuswahl: alt("
					+ this.auswahl + ") neu(" + auswahl + ")");
		int alt = this.auswahl;
		this.auswahl = auswahl;
		if (alt != auswahl) {
			messKanal = null;
			aktualisiereMessbereiche();
		}
	}

	@Override
	public void setAuswahl(Messgroesse m) {
		if (m == null || m.equals(getMessgroesse(0)))
			return;
		for (int i = 0; i < getMessgroessenAnzahl(0); i++)
			if (m.equals(messGroesse.get(i))) {
				setAuswahl(i);
			}
	}

	@Override
	public JTransparentToggleButton createToggleButton(Rectangle bounds,
			Action a) {
		auswahl = 0;
		auswahlB = 0;
		aktualisiereMessbereiche();
		return new GroessenToggleButton(bounds, a, getMessgroessen());
	}

	@Override
	public int getMessgroessenAnzahl(int kanal) {
		return messGroesse == null ? super.getMessgroessenAnzahl(kanal)
				: messGroesse.size();
	}

	protected abstract void aktualisiereMessbereiche();

	@Override
	public String getKanalsymbol(int kanal) {
		return Character.toString((char) ('1' + kanal));
	}

	@Override
	public String getKanalsymbol(int auswahl, int kanal) {
		if (kanaele == null || kanaele.length <= auswahl
				|| kanaele[auswahl] <= kanal)
			return "";
		else
			return getKanalsymbol(kanal);
	}

	@Override
	public int getKanaele() {
		return kanaele == null || kanaele.length <= auswahl ? 1
				: kanaele[auswahl];
	}

	@Override
	public String erzeugeSymbol(int index, int input) {
		if (messGroesse == null || messGroesse.size() <= index)
			return super.erzeugeSymbol(index, input);
		else
			return messGroesse.get(index).getSymbol() + "_"
					+ getInputString(input);
	}

	@Override
	public String erzeugeSymbol(int index, int input, int kanal) {
		if (kanaele == null || kanaele.length <= kanal || index < 0
				|| index >= getMessgroessenAnzahl(kanal))
			return erzeugeSymbol(index, input);
		else if (messGroesse == null || messGroesse.size() <= index)
			return erzeugeSymbol(0, input);
		else
			return messGroesse.get(index).getSymbol() + "_"
					+ getInputString(input) + getKanalsymbol(index, kanal);
	}

	@Override
	public String[] getGroessenStringList(int kanal) {
		if (messGroesse == null || messGroesse.isEmpty())
			return super.getGroessenStringList(kanal);
		else {
			String[] resultat = new String[messGroesse.size()];
			for (int i = 0; i < messGroesse.size(); i++) {
				resultat[i] = (prefix == null || prefix.length <= i
						|| prefix[i] == null ? "" : prefix[i] + " ")
						+ (messGroesse.get(i).getName() == null ? ""
						: messGroesse.get(i).getName() + " ")
						+ erzeugeSymbol(i, input, kanal)
						+ (suffix == null || suffix.length <= i
								|| suffix[i] == null ? "" : " " + suffix[i]);
			}
			return resultat;
		}
	}

	@Override
	public String[] getNamen(int kanal) {
		if (messGroesse == null || messGroesse.size() <= 1)
			return super.getNamen(kanal);
		else
			return Messgroesse.getNamen(messGroesse
					.toArray(new Messgroesse[] {}));
	}

	@Override
	public Messgroesse getMessgroesse(int kanal) {
		if (messGroesse == null || messGroesse.size() <= auswahl)
			return super.getMessgroesse(kanal);
		else
			return messGroesse.get(auswahl);
	}

	@Override
	public int getMessgroesseIndex(int kanal) {
		if (messGroesse == null || messGroesse.size() <= auswahl)
			return super.getMessgroesseIndex(kanal);
		else
			return auswahl;
	}

	public Messgroesse[] getMessgroessen() {
		return messGroesse == null ? new Messgroesse[] {} : messGroesse
				.toArray(new Messgroesse[] {});
	}

	@Override
	public void korrigiereNullpunkt(int kanal) {
		if (messKanal == null || messKanal.length <= kanal
				|| messKanal[kanal] == null)
			return;
		else
			messKanal[kanal].korrigiereNullpunkt();
	}

	public boolean hatKorrektur(int kanal) {
		if (messKanal == null || messKanal.length <= kanal
				|| messKanal[kanal] == null)
			return false;
		else
			return messKanal[kanal].hatKorrektur();
	}
}
