/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.adapter;

import ghmessen.components.JTransparentToggleButton;
import ghmessen.groesse.Messgroesse;

import java.awt.Rectangle;

import javax.swing.ActionMap;
import javax.swing.JMenuItem;

import org.jdesktop.application.Action;
import org.jdesktop.application.Application;

public class GroessenToggleButton extends JTransparentToggleButton {

	private static final long serialVersionUID = 3143132878733506191L;
	private static final boolean DEBUG = false;
	private static final int NSYMBOLEMAX = 27;
	private ActionMap actionMap;

	public GroessenToggleButton(Rectangle bounds, javax.swing.Action a,
			Messgroesse[] messgroessen) {
		this(bounds, a, messgroessen, null, null);
	}
	
	public GroessenToggleButton(Rectangle bounds, javax.swing.Action a,
			Messgroesse[] messgroessen, String[] namen, String[] suffixe){
		super(bounds, a);
		if(DEBUG)
			System.out.println("[GroessenToggleButton] - Konstruktor:");
		actionMap = Application.getInstance().getContext()
				.getActionMap(GroessenToggleButton.class, this);
		if (messgroessen != null) {
			nSymbole = messgroessen.length;
			symbole = new String[nSymbole];
			popup = new GroessenPopupMenu();
			for (int index = 0; index < Math.min(NSYMBOLEMAX,nSymbole); index++) {
				symbole[index] = messgroessen[index].getSymbol();
				JMenuItem groesse = new JMenuItem();
				groesse.setAction(actionMap.get("groesse" + index));
				String menueText;
				if(namen == null || namen.length <= index || namen[index] == null)
					menueText = (messgroessen[index].getName() == null ?
										messgroessen[index].getSymbol()
										: messgroessen[index].getName());
				else
					menueText = namen[index];
				if(suffixe != null && index < suffixe.length && suffixe[index] != null)
					menueText = menueText + suffixe[index];
				groesse.setText(menueText);
				groesse.setToolTipText("Messgröße "+groesse.getText()+" auswählen.");
				popup.add(groesse);
			}
			if (nSymbole > NSYMBOLEMAX)
				System.err.println("[GroessenToggleButton] - Es gibt "+nSymbole
						+" im Menü, es können aber nur "+NSYMBOLEMAX+" verarbeitet werden.");
			if (DEBUG)
				System.out.println("\t"+nSymbole+" Symbole("+symbole+")");
		}
	}

	@Action
	public void groesse0() {
		((GroessenPopupMenu)popup).auswaehlen(0);
	}

	@Action
	public void groesse1() {
		((GroessenPopupMenu)popup).auswaehlen(1);
	}

	@Action
	public void groesse2() {
		((GroessenPopupMenu)popup).auswaehlen(2);
	}

	@Action
	public void groesse3() {
		((GroessenPopupMenu)popup).auswaehlen(3);
	}

	@Action
	public void groesse4() {
		((GroessenPopupMenu)popup).auswaehlen(4);
	}

	@Action
	public void groesse5() {
		((GroessenPopupMenu)popup).auswaehlen(5);
	}

	@Action
	public void groesse6() {
		((GroessenPopupMenu)popup).auswaehlen(6);
	}

	@Action
	public void groesse7() {
		((GroessenPopupMenu)popup).auswaehlen(7);
	}

	@Action
	public void groesse8() {
		((GroessenPopupMenu)popup).auswaehlen(8);
	}

	@Action
	public void groesse9() {
		((GroessenPopupMenu)popup).auswaehlen(9);
	}

	@Action
	public void groesse10() {
		((GroessenPopupMenu)popup).auswaehlen(10);
	}

	@Action
	public void groesse11() {
		((GroessenPopupMenu)popup).auswaehlen(11);
	}

	@Action
	public void groesse12() {
		((GroessenPopupMenu)popup).auswaehlen(12);
	}

	@Action
	public void groesse13() {
		((GroessenPopupMenu)popup).auswaehlen(13);
	}

	@Action
	public void groesse14() {
		((GroessenPopupMenu)popup).auswaehlen(14);
	}

	@Action
	public void groesse15() {
		((GroessenPopupMenu)popup).auswaehlen(15);
	}

	@Action
	public void groesse16() {
		((GroessenPopupMenu)popup).auswaehlen(16);
	}

	@Action
	public void groesse17() {
		((GroessenPopupMenu)popup).auswaehlen(17);
	}

	@Action
	public void groesse18() {
		((GroessenPopupMenu)popup).auswaehlen(18);
	}

	@Action
	public void groesse19() {
		((GroessenPopupMenu)popup).auswaehlen(19);
	}

	@Action
	public void groesse20() {
		((GroessenPopupMenu)popup).auswaehlen(20);
	}

	@Action
	public void groesse21() {
		((GroessenPopupMenu)popup).auswaehlen(21);
	}

	@Action
	public void groesse22() {
		((GroessenPopupMenu)popup).auswaehlen(22);
	}

	@Action
	public void groesse23() {
		((GroessenPopupMenu)popup).auswaehlen(23);
	}

	@Action
	public void groesse24() {
		((GroessenPopupMenu)popup).auswaehlen(24);
	}

	@Action
	public void groesse25() {
		((GroessenPopupMenu)popup).auswaehlen(25);
	}

	@Action
	public void groesse26() {
		((GroessenPopupMenu)popup).auswaehlen(26);
	}

}
