/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.adapter;

import ghmessen.groesse.Groesse;

import java.awt.Point;
import java.util.concurrent.ScheduledThreadPoolExecutor;

import javax.swing.JPopupMenu;

public interface IEingang {
	public String getName();
	public void close();
	public double getIntervallStandard();
	public int getWiederholungStandard();
	public double getIntervallMinimum();
	public boolean hatOszilloskop(int kanal);
	public boolean hatKorrektur(int kanal);
	public void korrigiereNullpunkt(int kanal);
	public boolean hatVorzeichenWechsel(int kanal);
	public boolean contains(Point p);
	public JPopupMenu getPopupMenu();
	
	/*************************************************
	 * IAdapter
	 *************************************************/
	public IAdapter getAdapter();
	public IMesskanal getMesskanal(Groesse g, ScheduledThreadPoolExecutor timer, boolean autocreate);
	public int getKanaele();
	public boolean hatTimer();
}
