/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.adapter;


import java.util.concurrent.ScheduledThreadPoolExecutor;

import javax.swing.JFrame;

import ghmessen.groesse.Groesse;
import ghmessen.groesse.Messbereich;
import ghmessen.instrumente.Messgeraet;
import ghmessen.instrumente.SensorPanel.SensorBoxPanel;

public interface IMesskanal {
	public double einlesen() throws MesskanalException;
	public double einlesenZeit() throws MesskanalException;
	public double leseLetztenWert() throws MesskanalException;
	public int fuellePuffer(int bisher, int neu) throws InterruptedException, EAdapterException;
	public double lesePufferWert(int index) throws InterruptedException, EAdapterException;
	public double lesePufferZeit(int index) throws InterruptedException, EAdapterException;
	public Groesse getGroesse();
	public boolean istGueltig();
	public boolean istUeberschritten();
	public boolean istUnterschritten();
	public boolean istKanalOffen();
	public boolean istOszilloskopKanal();
	public boolean istOszilloskopZeitKanal();
	public boolean istLangsamerZeitKanal();
	public boolean istTriggerKanal();
	public IEingang getEingang();
	public boolean hatKorrektur();
	public void korrigiereNullpunkt();
	public boolean hatVorzeichenWechsel();
	public void wechseleVorzeichen();
	public Messbereich[] getMessbereiche();
	public String[] getMessbereicheStringArray();
	public Messbereich getMessbereich();
	public int getMessbereichIndex();
	public void setMessbereich(int index);
	public void setMessbereich(Messbereich messbereich);
	public void start() throws MesskanalException;
	public void stop() throws MesskanalException;
	public void setAbstand(double abstand) throws MesskanalException;
	public double getAbstand() throws MesskanalException;
	public Messgeraet createMessgeraet(JFrame parent, IMesskanal messkanal, ScheduledThreadPoolExecutor timer);
	public SensorBoxPanel getPanel(IMesskanal messkanal);
}
