package ghmessen.adapter.arduino;

import java.util.Vector;
import java.util.concurrent.ScheduledThreadPoolExecutor;

import javax.swing.JFrame;

import udev.UdevDevice;
import ghmessen.adapter.Eingang;
import ghmessen.adapter.IAdapter;
import ghmessen.adapter.IMesskanal;
import ghmessen.adapter.seriell.SerialAdapter;
import ghmessen.groesse.Groesse;
import ghmessen.groesse.Messgroesse;
import ghmessen.instrumente.Messgeraet;
import ghmessen.instrumente.MessgeraetStandard;

import static ghmessen.groesse.Messgroesse.Weg;

public class EingangArduino extends Eingang {

	private static final boolean DEBUG = false;
	
	private SerialAdapter arduino;
	private static final int BAUDRATE = 9600;
		
	public EingangArduino(IAdapter adapter, UdevDevice device, int input) {
		super(adapter, input);
		if(DEBUG)
			System.out.println("[EingangArduino] - Konstruktur...");
		hatOszilloskop = false;
		arduino = new SerialAdapter(device, BAUDRATE);
		messGroesse = new Vector<Messgroesse>();
		messGroesse.add(Weg);
	}

	@Override
	public Messgeraet getMessgeraet(JFrame parent, Groesse g,
			ScheduledThreadPoolExecutor hauptTimer) {
		return new MessgeraetStandard(parent, getMesskanal(g, hauptTimer, true), adapter, g, hauptTimer);
	}

	@Override
	public IMesskanal getMesskanal(Groesse g, ScheduledThreadPoolExecutor timer, boolean autocreate) {
		if(messKanal == null)
			return (messKanal = new MesskanalArduino(this, g, arduino));
		else
			return messKanal;
	}
	
	@Override
	public void close() {
		if(arduino != null)
			arduino.close();
		arduino = null;
	}
	
}
