/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.adapter.cassy;

import static ghmessen.groesse.Messgroesse.Rate;
import static ghmessen.groesse.wertetabelle.XAchseTyp.BETA;
import ghmessen.adapter.Adapter;
import ghmessen.adapter.Eingang;
import ghmessen.adapter.IMesskanal;
import ghmessen.groesse.Groesse;
import ghmessen.groesse.Messgroesse;

import java.util.Vector;
import java.util.concurrent.ScheduledThreadPoolExecutor;

public class EingangXRay extends Eingang {

	@SuppressWarnings("unused")
	private static final boolean DEBUG = false;

	public EingangXRay(Adapter adapter, int input) {
		super(adapter, input);
		hatOszilloskop = false;
		messGroesse = new Vector<Messgroesse>() {
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			{
				add(Rate);
			}
		};
	}

	@Override
	public IMesskanal getMesskanal(Groesse g,
			ScheduledThreadPoolExecutor timer, boolean autocreate) {
		if (messKanal == null && autocreate)
			messKanal = new MesskanalXRay(this, g);
		return messKanal;
	}

	@Override
	public String erzeugeSymbol(int index, int input) {
		return "R_" + (adapter == null ? -1 : adapter.getNr());
	}

	@Override
	public void setzeStandardWerte(Groesse g) {
		super.setzeStandardWerte(g);
		g.setBis(500);
		g.setZeitraum(1.0);
		g.setStellen(1);
		g.setXAchse(BETA);
	}

}
