package ghmessen.adapter.efm;

import java.util.Vector;
import java.util.concurrent.ScheduledThreadPoolExecutor;

import udev.UdevDevice;
import ghmessen.adapter.Eingang;
import ghmessen.adapter.IAdapter;
import ghmessen.adapter.IMesskanal;
import ghmessen.adapter.seriell.SerialAdapter;
import ghmessen.groesse.Groesse;
import ghmessen.groesse.Messgroesse;

import static ghmessen.groesse.Messgroesse.ElektrischeFeldstärke;

public class EingangEFM extends Eingang {

	private static final boolean DEBUG = false;
	
	private SerialAdapter efm;
	private static final int BAUDRATE = 9600;
		
	public EingangEFM(IAdapter adapter, UdevDevice device, int input) {
		super(adapter, input);
		intervallMinimum = 0.1; //Werte werden im Abstand von 100ms geliefert
		if(DEBUG)
			System.out.println("[EingangEFM] - Konstruktur...");
		hatOszilloskop = false;
		efm = new SerialAdapter(device, BAUDRATE);
		efm.setDTR(false);
		messGroesse = new Vector<Messgroesse>();
		messGroesse.add(ElektrischeFeldstärke);
	}
	
	@Override
	public IMesskanal getMesskanal(Groesse g, ScheduledThreadPoolExecutor timer, boolean autocreate) {
		if(messKanal == null)
			return (messKanal = new MesskanalEFM(this, g, efm));
		else
			return messKanal;
	}
	
	@Override
	public void close() {
		if(efm != null)
			efm.close();
		efm = null;
	}
	
}
