/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.adapter.event;

import ghmessen.adapter.IAdapter;
import ghmessen.adapter.IEingang;

import java.util.EventObject;

public class AdapterChangedEvent extends EventObject {
	private static final long serialVersionUID = 1510678392353989512L;
	public IAdapter adapter;
	public int nr;
	public int ab;
	public IEingang alt;
	public IEingang neu;
	public int sensorAlt;
	public int sensorNeu;

	public AdapterChangedEvent(Object source, IAdapter adapter, int nr,int ab, IEingang alt, IEingang neu, int sensorAlt, int sensorNeu){
		super(source);
		this.adapter = adapter;
		this.nr = nr;
		this.ab = ab;
		this.alt = alt;
		this.neu = neu;
		this.sensorAlt = sensorAlt;
		this.sensorNeu = sensorNeu;
	}
	
	public AdapterChangedEvent(Object source, IAdapter adapter, int nr,int ab, int alt, int neu){
		this(source, adapter, nr, ab, null, null, alt, neu);
	}
	
	public AdapterChangedEvent(Object source) { 
		this(source, null, 0, 0, null, null, 0, 0); 
	}
}
