/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.components;

import ghmessen.util.Util;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.Action;
import javax.swing.JToggleButton;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;

public class AchseToggleButton extends JToggleButton {

	private static final boolean DEBUG = false;
	private static final int idealeBreite = 35;
	private String symbol;
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2588232167967752038L;

	public AchseToggleButton(Action action, Color farbe, String symbol, boolean set){
		super(action);
		this.symbol = symbol;
		if(DEBUG)
			System.out.println("[AchseToggleButton] - Konstruktor("+symbol+")");
		setSelected(set);
		setBorder(new BevelBorder(BevelBorder.RAISED));
		setFont(new Font("Dialog", Font.BOLD, 12));
		setForeground(farbe);
		setHorizontalAlignment(SwingConstants.CENTER);
		setText(Util.htmlSub(symbol));
	}
	
	public String getSymbol(){
		return symbol;
	}
	
	public void setSymbol(String symbol){
		this.symbol = symbol;
		setText(Util.htmlSub(symbol));
	}

	@Override
	public Dimension getPreferredSize() {
		return new Dimension(idealeBreite, idealeBreite);
	}

	@Override
	public Dimension getMaximumSize() {
		return new Dimension(idealeBreite, idealeBreite);
	}

	@Override
	public Dimension getMinimumSize() {
		return new Dimension(idealeBreite, idealeBreite);
	}
	
	@Override
	public String toString() {
		return "Knopf("+symbol+"|"+(isSelected()?"An)":"Aus)");
	}
	
}
