/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.components;

import static ghmessen.Konstanten.FARBE_GRAPHEN;

import java.awt.Component;
import java.awt.Dimension;

import javax.swing.JTable;

import ghmessen.util.DefaultTableHeaderCellRenderer;

public class ColorTableHeaderCellRenderer extends
		DefaultTableHeaderCellRenderer {

	private static final long serialVersionUID = 1L;
	private static final boolean DEBUG = false;

	public ColorTableHeaderCellRenderer() {
		super();
		if (DEBUG)
			System.out.println("[ColorTableHeaderCellRenderer] - Konstruktor.");
		setHorizontalAlignment(CENTER);
		setHorizontalTextPosition(LEFT);
		setVerticalAlignment(CENTER);
		setOpaque(false);
	}

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int rowIndex, int vColIndex) {
		Component result = super.getTableCellRendererComponent(table, value,
				isSelected, hasFocus, rowIndex, vColIndex);
		result.setPreferredSize(new Dimension(0,(int)(1.5*getFontMetrics(getFont()).getHeight())));
		if(vColIndex > 0)
			result.setForeground(FARBE_GRAPHEN.get(vColIndex-1));
		return result;
	}

}
