/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.components;

import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.text.ParseException;

import javax.swing.JFormattedTextField;
import javax.swing.text.Document;

public abstract class DoubleFieldFocusAdapter implements FocusListener {

	private static final boolean DEBUG = false;

	Object prop;
	JFormattedTextField feld;
	Document doc;
	int nummer = 0;

	@Override
	public void focusGained(FocusEvent e) {
		return;
	}

	@Override
	public void focusLost(FocusEvent e) {
		prop = e.getSource();
		feld = (JFormattedTextField) (prop instanceof JFormattedTextField ? prop
				: null);
		doc = feld.getDocument();
		if (feld != null) {
			try {
				feld.commitEdit();
				double wert = (Double) feld.getValue();
				prop = doc.getProperty("minimum");
				double min = prop instanceof Double ? (Double) prop : 0.0;
				prop = doc.getProperty("maximum");
				double max = prop instanceof Double ? (Double) prop : 1000.0;
				if (wert < min) {
					feld.setText(Double.toString(min));
					feld.commitEdit();
				} else if (wert > max) {
					feld.setText(Double.toString(max));
					feld.commitEdit();
				}
				prop = doc.getProperty("nummer");
				schreiben((Double) feld.getValue());
			} catch (ParseException e1) {
				if (DEBUG)
					e1.printStackTrace();
			} catch(ClassCastException e2){
				if(DEBUG)
					e2.printStackTrace();
			}
		}
	}

	public abstract void schreiben(double d);

}
