package ghmessen.components;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;

public class ImageTransferHandler implements Transferable {
	private Image image;

	public static void copyImageToClipboard(Image image) {
		ImageTransferHandler transfer = new ImageTransferHandler(image);
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		toolkit.getSystemClipboard().setContents(transfer, null);
	}

	public ImageTransferHandler(Image image) {
		this.image = image;
	}

	public Object getTransferData(DataFlavor flavor)
			throws UnsupportedFlavorException {
		if (flavor.equals(DataFlavor.imageFlavor) == false) {
			throw new UnsupportedFlavorException(flavor);
		}
		return image;
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return flavor.equals(DataFlavor.imageFlavor);
	}

	public DataFlavor[] getTransferDataFlavors() {
		return new DataFlavor[] { DataFlavor.imageFlavor };
	}
}
