/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.components;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

public class JImagePanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -5868829902143047001L;
	private Image img;
	private Image saveImg;

	public JImagePanel() {
		super();
		this.img = new ImageIcon(
				JImagePanel.class.getResource("resources/jimagepanel.jpg"))
				.getImage();
		this.saveImg = this.img;
		Dimension size = new Dimension(this.img.getWidth(null),
				this.img.getHeight(null));
		setPreferredSize(size);
		setMinimumSize(size);
		setMaximumSize(size);
		setSize(size);
		setLayout(null);
	}

	public JImagePanel(String img) {
		super();
		this.img = new ImageIcon(this.getClass().getResource(img)).getImage();
		Dimension size = new Dimension(this.img.getWidth(null),
				this.img.getHeight(null));
		this.saveImg = this.img;
		setPreferredSize(size);
		setMinimumSize(size);
		setMaximumSize(size);
		setSize(size);
		setLayout(null);
	}

	public JImagePanel(ImageIcon img) {
		super();
		this.img = img.getImage();
		Dimension size = new Dimension(this.img.getWidth(null),
				this.img.getHeight(null));
		this.saveImg = this.img;
		setPreferredSize(size);
		setMinimumSize(size);
		setMaximumSize(size);
		setSize(size);
		setLayout(null);
	}

	public void paintComponent(Graphics g) {
		g.setColor(getBackground());
		g.fillRect(0, 0, getWidth(), getHeight());
		g.setColor(getForeground());
		g.drawImage(img, 0, 0, null);
	}

	public Image getImage() {
		return this.img;
	}

	public void setImage(Image img) {
		this.img = img;
		repaint();
	}

	public void resetImage() {
		this.img = this.saveImg;
		repaint();
	}
}
