package ghmessen.components.plotcanvas;

import ghmessen.util.Util;

import java.io.PrintWriter;
import java.io.Serializable;
import java.lang.reflect.Field;

import javax.xml.transform.sax.TransformerHandler;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.AttributesImpl;

public class GraphBereich implements Serializable {

	private static final long serialVersionUID = -2490344458027643078L;
	private static final boolean DEBUG = false;
	private int col;
	private int row1;
	private int row2;

	public static void createDTD(PrintWriter out) {
		out.println("<!ELEMENT GraphBereich EMPTY>");
		out.println("<!ATTLIST GraphBereich col (INT) #REQUIRED row1 (INT) #REQUIRED row2 (INT) #REQUIRED>");
	}

	public void writeToXml(TransformerHandler hd) throws SAXException {
		if (hd == null)
			throw new SAXException(
					"[GraphBereich] Objekt ist nicht initialisiert.");
		AttributesImpl atts = new AttributesImpl();
		atts.addAttribute("", "", "col", "INT", Integer.toString(col));
		atts.addAttribute("", "", "row1", "INT", Integer.toString(row1));
		atts.addAttribute("", "", "row2", "INT", Integer.toString(row2));
		hd.startElement("", "", "GraphBereich", atts);
		hd.endElement("", "", "GraphBereich");
	}

	public void startElement(String uri, String localName, String qName,
			Attributes attributes) throws SAXException {
		if (qName.equals("GraphBereich")) {
			for (int index = 0; index < attributes.getLength(); index++) {
				try {
					String name = attributes.getLocalName(index);
					String inhalt = attributes.getValue(index);
					Field field = getClass().getDeclaredField(name);
					if (DEBUG)
						System.out
								.println("[GraphBereich] - startElement: Feld("
										+ name + ") Typ(" + field.getType()
										+ ") Inhalt(" + inhalt + ")");
					Util.setFieldValue(this, field, inhalt);
				} catch (SecurityException e) {
					if (DEBUG)
						e.printStackTrace();
					throw new SAXException(e.getMessage());
				} catch (NoSuchFieldException e) {
					if (DEBUG)
						e.printStackTrace();
					throw new SAXException(e.getMessage());
				} catch (IllegalArgumentException e) {
					if (DEBUG)
						e.printStackTrace();
					throw new SAXException(e.getMessage());
				}
			}
		} else
			throw new SAXException("[GraphBereich] - Start(" + qName + ")");
	}

	public void endElement(String uri, String localName, String qName,
			String inhalt) throws SAXException {
		if (!qName.equals("GraphBereich")) {
			throw new SAXException("[GraphBereich] - Ende(" + qName + ")");
		}
	}

	public GraphBereich() {
		this(-1,-1,-1);
	}
	
	public GraphBereich(int col, int row1, int row2) {
		this.col = col;
		this.row1 = row1;
		this.row2 = row2;
	}

	public void setBezug(int col, int row1, int row2) {
		this.col = col;
		this.row1 = row1;
		this.row2 = row2;
	}

	public void setCol(int col) {
		this.col = col;
	}

	public int getCol() {
		return col;
	}

	public void setRow1(int row1) {
		this.row1 = row1;
	}

	public int getRow1() {
		return row1;
	}

	public void setRow2(int row2) {
		this.row2 = row2;
	}

	public int getRow2() {
		return row2;
	}

	public GraphBereich union(GraphBereich b) {
		if (b == null || col != b.col)
			return this;
		row1 = Math.min(row1, b.row1);
		row2 = Math.min(row2, b.row2);
		return this;
	}

	public boolean intersects(GraphBereich b) {
		return (b != null && col == b.col && !(row2 < b.row1 || b.row2 < row1));
	}

	public boolean contains(int col, int row) {
		return (this.col == col && contains(row));
	}

	public boolean contains(int row) {
		return row1 <= row && row <= row2;
	}
}
