/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.components.plotcanvas;

import java.awt.Point;
import java.awt.Rectangle;
import java.io.PrintWriter;

public class ZellAdresse extends Rectangle {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3345024033440389096L;

	public static void createDTD(PrintWriter out){
		out.println("<!ELEMENT ZellAdresse EMPTY>");
		out.println("<!ATTLIST ZellAdresse zeile (INT) #REQUIRED " + 
						"spalte (INT) #REQUIRED breite (INT) #REQUIRED>");
	}
	
	// Zeile : x
	// Spalte: y
	// Breite: 0 - 1 Punkt
	//         1 - 2 Punkte
	public ZellAdresse() {
		super();
	}

	public ZellAdresse(int spalte, int zeile) {
		super(zeile,spalte,0,0);
	}

	public ZellAdresse(int spalte, int zeile, int breite) {
		super(zeile, spalte, breite, 0);
	}
	
	public void setzeAdresse(int spalte, int zeile) {
		setLocation(zeile,spalte);
	}

	public void setzeAdresse(int spalte, int zeile, int breite) {
		setLocation(zeile, spalte);
		setSize(breite, 0);
	}
	
	public int getZeile() {
		return x;
	}

	public int getSpalte() {
		return y;
	}

	public int getBreite() {
		return width;
	}
	
	public void setSpalte(int spalte) {
		setLocation(x,spalte);
	}

	public void setZeile(int zeile) {
		setLocation(zeile,y);
	}

	public void setBreite(int breite) {
		setSize(breite, 0);
	}
	
	public Point toPoint() {
		return new Point(y, x);
	}
}

