/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.dialoge.eigenschaften;

import ghmessen.GHMessen;
import ghmessen.dialoge.eigenschaften.sensoren.SensorenVernier;

import java.awt.Component;

import javax.swing.JTabbedPane;

import org.jdesktop.application.ResourceMap;

@SuppressWarnings("serial")
public class BereichSensoren extends JTabbedPane implements BereichInterface {

	private static final boolean DEBUG = false;

	public static final int TABGOIOSENSOREN = 0;

	// private static ActionMap actionMap;
	private static ResourceMap resourceMap;

	public BereichSensoren() {
		// actionMap = org.jdesktop.application.Application
		// .getInstance(ghmessen.GHMessen.class).getContext()
		// .getActionMap(BereichSensoren.class, this);
		resourceMap = org.jdesktop.application.Application
				.getInstance(ghmessen.GHMessen.class).getContext()
				.getResourceMap(BereichSensoren.class);

		setTabLayoutPolicy(SCROLL_TAB_LAYOUT);
		if (GHMessen.getApplication() != null)
			addTab(resourceMap.getString("tabVernierSensoren.title"),
					new SensorenVernier(
							GHMessen.getApplication().vernierSensoren));
		else
			addTab("Vernier", new SensorenVernier());
		setSelectedIndex(TABGOIOSENSOREN);
	}

	public void initialisieren() {
		if (DEBUG)
			System.out
					.println("[BereichSensoren] - initialisieren aufgerufen...");
		for (Component c : getComponents()) {
			if (c instanceof BereichInterface)
				((BereichInterface) c).initialisieren();
		}
	}

	public void schreiben() {
		if (DEBUG)
			System.out.println("[BereichSensoren] - schreiben aufgerufen...");
		for (Component c : getComponents()) {
			if (c instanceof BereichInterface)
				((BereichInterface) c).schreiben();
		}
	}

}
