package ghmessen.filefilter;

import java.io.File;

import javax.swing.filechooser.FileFilter;

import org.jdesktop.application.Application;
import org.jdesktop.application.ResourceMap;

public class AlleFileFilter extends FileFilter {

	private static final CL4FileFilter cl4;
	private static final GHMFileFilter ghm;
	private static final GHMXFileFilter ghmx;
	public static enum FORMAT {
		GHM, GHMX, CL4, UNBEKANNT;
	};

	private static ResourceMap resourceMap;
	
	public AlleFileFilter(){
		super();
		resourceMap = Application.getInstance(ghmessen.GHMessen.class)
				.getContext().getResourceMap(AlleFileFilter.class);
	}
	
	public FORMAT getFormat(File f){
		if(f.isFile()){
			if(ghm.accept(f))
				return FORMAT.GHM;
			if(ghmx.accept(f))
				return FORMAT.GHMX;
			if(cl4.accept(f))
				return FORMAT.CL4;
		}
		return FORMAT.UNBEKANNT;
	}
	
	@Override
	public boolean accept(File f) {
		return ghm.accept(f) || ghmx.accept(f) || cl4.accept(f);
	}

	@Override
	public String getDescription() {
		return resourceMap.getString("alledescription.text");
	}

	static {
		cl4 = new CL4FileFilter();
		ghm = new GHMFileFilter();
		ghmx = new GHMXFileFilter();
	}
}
