package ghmessen.filefilter;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.filechooser.FileFilter;

import org.jdesktop.application.Application;
import org.jdesktop.application.ResourceMap;

public class CL4FileFilter extends FileFilter {
	
	public static final boolean DEBUG = false;

	private static ResourceMap resourceMap;
	
	public CL4FileFilter(){
		super();
		resourceMap = Application.getInstance(ghmessen.GHMessen.class)
				.getContext().getResourceMap(CL4FileFilter.class);
	}
	
	public String getEndung(){
		return ".lab";
	}
	
	@Override
	public boolean accept(File f) {
		if(f.isDirectory())
			return true;
		String ext = (f.getName().lastIndexOf(".")>-1? f.getName().substring(f.getName().lastIndexOf(".")+1) : "");
		ext = ext.toLowerCase();
		if("".equals(ext) || !"lab".equals(ext))
			return false;
		FileInputStream in = null;
		try {
			in = new FileInputStream(f);
			if(in.available()<3)
				return false;
			byte[] magic = new byte[3];
			in.read(magic);
			if('C' == magic[0] && 'L' == magic[1] && '4' == magic[2])
				return true;
		} catch (FileNotFoundException e) {
			if(DEBUG)
				e.printStackTrace();
		} catch (IOException e) {
			if(DEBUG)
				e.printStackTrace();
		} finally {
			if(in != null)
				try {
					in.close();
				} catch (IOException e) {
					if(DEBUG)
						e.printStackTrace();
				}
		}
		return false;
	}

	@Override
	public String getDescription() {
		return resourceMap.getString("cl4description.text");
	}
	
}
