package ghmessen.filefilter;

import java.io.File;

import javax.swing.filechooser.FileFilter;

import org.jdesktop.application.Application;
import org.jdesktop.application.ResourceMap;

public class GHMFileFilter extends FileFilter {

	public static final boolean DEBUG = false;

	private static ResourceMap resourceMap;
	
	public GHMFileFilter(){
		super();
		resourceMap = Application.getInstance(ghmessen.GHMessen.class)
				.getContext().getResourceMap(GHMFileFilter.class);
	}
	
	public String getEndung(){
		return ".ghm";
	}
	
	@Override
	public boolean accept(File f) {
		if(f.isDirectory())
			return true;
		String ext = (f.getName().lastIndexOf(".")>-1? f.getName().substring(f.getName().lastIndexOf(".")+1) : "");
		ext = ext.toLowerCase();
		if("".equals(ext) || !"ghm".equals(ext))
			return false;
		else
			return true;
	}

	@Override
	public String getDescription() {
		return resourceMap.getString("ghmdescription.text");
	}

}
