package ghmessen.filefilter;

import java.io.File;

import javax.swing.filechooser.FileFilter;

import org.jdesktop.application.Application;
import org.jdesktop.application.ResourceMap;

public class GHMXFileFilter extends FileFilter {

	public static final boolean DEBUG = false;

	private static ResourceMap resourceMap;

	public GHMXFileFilter() {
		super();
		resourceMap = Application.getInstance(ghmessen.GHMessen.class)
				.getContext().getResourceMap(GHMXFileFilter.class);
	}

	public String getEndung() {
		return ".ghmx";
	}

	@Override
	public boolean accept(File f) {
		if (f.isDirectory())
			return true;
		String ext = (f.getName().lastIndexOf(".") > -1 ? f.getName()
				.substring(f.getName().lastIndexOf(".") + 1) : "");
		ext = ext.toLowerCase();
		if ("".equals(ext) || !"ghmx".equals(ext))
			return false;
		else
			return true;
	}

	@Override
	public String getDescription() {
		return resourceMap.getString("ghmxdescription.text");
	}

}
