/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.groesse;

import java.util.Hashtable;


public enum Grundeinheit {
    METER("m"),SEKUNDE("s"),VOLT("V"),AMPERE("A"),CELSIUS("°C"),KELVIN("K"),NEWTON("N"),Keine(""),HERTZ("Hz"),_SEKUNDE("1/s"),
    METER_SEKUNDE("m/s"),METER_SEKUNDE2("m/s^2"),GRAD("°"),SIEMENS("S"),SIEMENS_METER("S/m"), WATT("W"), ELEKTRONENVOLT("eV"),
    COULOMB("C"),G("g"),KILOGRAMM("kg"),DEZIBEL("dB"),TESLA("T"),PASCAL("Pa"),LITER_SEKUNDE("l/s"),NEWTON_METER("N/m"),NEWTON_KILOGRAMM("N/kg"),
    PFUND("lb"), TORR("torr"), MMHG("mmHg"), BAR("bar"), PSI("psi"), INHG("INHG"), ATM("ATM"),FAHRENHEIT("F"),
    VOLT_METER("V/m");

    private String zeichen;

    private static Hashtable<String,Grundeinheit> tabelle;
    
    private Grundeinheit(String zeichen){
    	this.zeichen = zeichen;
    }

    @Override
    public String toString(){
    	return zeichen;
    }
    
    public static Grundeinheit toGrundeinheit(String s){
    	Grundeinheit result = valueOf(s);
    	if(result != null)
    		return result;
    	if(tabelle.contains(s))
    		return tabelle.get(s);
    	else
    		return Keine;
    }
    
    static {
    	tabelle = new Hashtable<String,Grundeinheit>();
    	for(Grundeinheit ge : values()){
    		if(ge.zeichen != null)
    			tabelle.put(ge.zeichen, ge);
    	}
    }
}
