/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.groesse;

import java.util.Hashtable;

public enum Vielfachheit {
	PICO("p", 0.000000001),NANO("n", 0.000001),MIKRO("μ", 0.000001),ZEHNTAUSENDSTEL("",0.0001),MILLI("m", 0.001),ZENTI("c", 0.01),ZEHNTEL("",0.1), EINS("", 1),
	SECHZIG("",60), SECHZIGSTEL("",1./60.), DREISECHSH("",3600),DREISECHSHSTEL("",1./3600), HEKTO("h",100),KILO("k", 1000),MEGA("M", 1000000),GIGA("G", 1000000000);
	
	private double faktor;
	private String zeichen;
	private static Hashtable<String, Vielfachheit> tabelle;
	
	private Vielfachheit(){
		faktor = 1;
		zeichen = "";
	}
	
	private Vielfachheit(double faktor){
		this.faktor = faktor;
		zeichen = "";
	}
	
	private Vielfachheit(String zeichen, double faktor){
		this.zeichen = zeichen;
		this.faktor = faktor;
	}
	
	public double getFaktor(){
		return faktor;
	}
	
	@Override
	public String toString(){
		return zeichen;
	}
	
	public static Vielfachheit toVielfachheit(String s){
		return tabelle.get(s);
	}
	
	static {
		tabelle = new Hashtable<String, Vielfachheit>();
		for(Vielfachheit v : values())
			tabelle.put(v.zeichen, v);
	}
}
