package ghmessen.groesse.darstellung;

import static ghmessen.groesse.darstellung.AnpassungEnum.Mittelwert;
import flanagan.analysis.Stat;
import ghmessen.components.plotcanvas.GraphBereich;
import ghmessen.util.Util;

import java.awt.Color;
import java.awt.geom.Path2D;
import java.io.PrintWriter;
import java.lang.reflect.Field;

import javax.xml.transform.sax.TransformerHandler;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.AttributesImpl;

public class AnpassungMittelwert extends Anpassung {

	/**
	 * 
	 */

	private static final boolean DEBUG = false;

	public static void createDTD(PrintWriter out) {
		out.println("<!ELEMENT AnpassungMittelwert (APX,APY,GraphBereich,TextAuswertung)>");
		out.println("<!ATTLIST AnpassungMittelwert typ (AnpassungEnum) #REQUIRED von (DOUBLE) #REQUIRED bis (DOUBLE) #REQUIRED n (INT) #REQUIRED");
		out.println("\tterm CDATA #REQUIRED htmlTerm CDATA #REQUIRED farbe CDATA #REQUIRED rsqr (DOUBLE) #REQUIRED autoZeichnung (BOOLEAN) #REQUIRED");
		out.println("\tautoAnpassung (BOOLEAN) #REQUIRED autoZeichnungVonBis (BOOLEAN) #REQUIRED y1 (DOUBLE) #REQUIRED manuell (BOOLEAN) #IMPLIED");
		out.println("\tsymbolX CDATA #REQUIRED symbolY CDATA #REQUIRED");
		out.println("\tstellenX (INT) #REQUIRED stellenY (INT) #REQUIRED einheitX CDATA #REQUIRED einheitY CDATA #REQUIRED>");
	}

	public void writeToXml(TransformerHandler hd) throws SAXException {
		if (hd == null)
			throw new SAXException(
					"[AnpassungMittelwert] Objekt ist nicht initialisiert.");
		AttributesImpl atts = new AttributesImpl();
		atts.addAttribute("", "", "typ", "AnpassungEnum", typ.toString());
		atts.addAttribute("", "", "von", "DOUBLE", Double.toString(von));
		atts.addAttribute("", "", "bis", "DOUBLE", Double.toString(bis));
		atts.addAttribute("", "", "symbolX", "CDATA", symbolX);
		atts.addAttribute("", "", "symbolY", "CDATA", symbolY);
		atts.addAttribute("", "", "stellenX", "INT", Integer.toString(stellenX));
		atts.addAttribute("", "", "stellenY", "INT", Integer.toString(stellenY));
		atts.addAttribute("", "", "einheitX", "CDATA", einheitX);
		atts.addAttribute("", "", "einheitY", "CDATA", einheitY);
		atts.addAttribute("", "", "n", "INT", Integer.toString(n));

		atts.addAttribute("", "", "term", "CDATA", term);
		atts.addAttribute("", "", "htmlTerm", "CDATA", htmlTerm);
		atts.addAttribute("", "", "farbe", "CDATA", Integer.toString(farbe.getRGB()));
		atts.addAttribute("", "", "rsqr", "DOUBLE", Double.toString(rsqr));
		atts.addAttribute("", "", "autoZeichnung", "BOOLEAN",
				Boolean.toString(autoZeichnung));
		atts.addAttribute("", "", "autoAnpassung", "BOOLEAN",
				Boolean.toString(autoAnpassung));
		atts.addAttribute("", "", "autoZeichnungVonBis", "BOOLEAN",
				Boolean.toString(autoZeichnungVonBis));
		atts.addAttribute("", "", "y1", "DOUBLE", Double.toString(y1));
		atts.addAttribute("", "", "manuell", "BOOLEAN",
				Boolean.toString(manuell));
		hd.startElement("", "", "AnpassungMittelwert", atts);
		String inhalt;
		hd.startElement("", "", "APX", null);
		inhalt = Util.writeDoublesToXml(x);
		hd.characters(inhalt.toCharArray(), 0, inhalt.length());
		hd.endElement("", "", "APX");
		hd.startElement("", "", "APY", null);
		inhalt = Util.writeDoublesToXml(y);
		hd.characters(inhalt.toCharArray(), 0, inhalt.length());
		hd.endElement("", "", "APY");
		bezug.writeToXml(hd);
		if (benennung != null)
			benennung.writeToXml(hd);
		hd.endElement("", "", "AnpassungMittelwert");
	}

	public void startElement(String uri, String localName, String qName,
			Attributes attributes) throws SAXException {
		if (qName.equals("AnpassungMittelwert")) {
			for (int index = 0; index < attributes.getLength(); index++) {
				try {
					String name = attributes.getLocalName(index);
					String inhalt = attributes.getValue(index);
					Field field = null;
					Class<?> c = this.getClass();
					while (field == null && c != null)
						try {
							field = c.getDeclaredField(name);
						} catch (NoSuchFieldException e) {
							if (c.getSuperclass() != null)
								c = c.getSuperclass();
							else
								c = null;
						}
					if (DEBUG)
						System.out
								.println("[AnpassungMittelwert] - startElement: Feld("
										+ name
										+ ") Typ("
										+ field.getType()
										+ ") Inhalt(" + inhalt + ")");
					if ("farbe".equals(name)){
						try {
							farbe = new Color(Integer.parseInt(inhalt));
						} catch(NumberFormatException e) {
							farbe = Color.black;
						}
					}
					else if (c != null)
						Util.setFieldValue(c.cast(this), field, inhalt);
					else
						throw new NoSuchFieldException(
								"[AnpassungMittelwert] - startElement: Feld("
										+ field.getName()
										+ ") existiert in keiner Superklasse.");
				} catch (SecurityException e) {
					if (DEBUG)
						e.printStackTrace();
					throw new SAXException(e.getMessage());
				} catch (NoSuchFieldException e) {
					if (DEBUG)
						e.printStackTrace();
					throw new SAXException(e.getMessage());
				} catch (IllegalArgumentException e) {
					if (DEBUG)
						e.printStackTrace();
					throw new SAXException(e.getMessage());
				}
			}
		} else if (qName.equals("APX") || qName.equals("APY")) {
			return;
		} else if (qName.equals("GraphBereich")) {
			bezug = new GraphBereich();
			bezug.startElement(uri, localName, qName, attributes);
		} else if (qName.equals("TextAuswertung")) {
			benennung = new TextAuswertung();
			benennung.startElement(uri, localName, qName, attributes);
		} else
			throw new SAXException("[AnpassungMittelwert] - Start(" + qName
					+ ")");
	}

	public void endElement(String uri, String localName, String qName,
			String inhalt) throws SAXException {
		if (qName.equals("AnpassungMittelwert")) {
			aktualisieren();
		} else if (qName.equals("APX")) {
			x = Util.prdoubleAFromXml(inhalt);
		} else if (qName.equals("APY")) {
			y = Util.prdoubleAFromXml(inhalt);
		} else if (qName.equals("GraphBereich")
				|| qName.equals("TextAuswertung")) {
			return;
		} else
			throw new SAXException("[AnpassungMittelwert] - Start(" + qName
					+ ")");
	}

	public AnpassungMittelwert() {
		super();
	}

	public AnpassungMittelwert(Double[] x, Double[] y) {
		this(x, y, 0, 0, x.length - 1, "y", 3, null, null);
	}

	public AnpassungMittelwert(Double[] x, Double[] y, int spalte, int zeile1,
			int zeile2, String symbolY, int stellenY, String einheitY,
			Color farbe) {
		super(Mittelwert, x, y, 0, 0, new GraphBereich(spalte, zeile1, zeile2),
				"t", symbolY, 2, stellenY, null, einheitY, "", "", 0.0, null,
				true, true, false, farbe);
		if (x != null && y != null && x.length > 0 && x.length == y.length) {
			setVonBis(x[zeile1], x[zeile2]);
		}
	}

	private static final long serialVersionUID = -3588093674955997018L;

	private double y1 = 0.0;

	@Override
	protected void anpassen() throws AnpassungException {
		if (x == null || y == null || x.length != y.length)
			throw new AnpassungException("Anpassung nicht durchführbar: x(" + x
					+ ") y(" + y + ")");
		y1 = Stat.mean(y);
	}

	@Override
	protected void zeichnen() throws AnpassungException {
		if (x == null)
			throw new AnpassungException(
					"Zeichnung der Anpassung nicht durchführbar: x(" + x
							+ ") y(" + y1 + ")");
		zeichnung = new Path2D.Double();
		zeichnung.moveTo(x[0], y1);
		zeichnung.lineTo(x[n - 1], y1);
	}

	public void setY1(double value) {
		this.y1 = value;
	}

	@Override
	protected double value(double x) throws AnpassungException {
		return y1;
	}

	@Override
	protected void zeichnen(double von, double bis) throws AnpassungException {
		zeichnungVonBis = new Path2D.Double();
		zeichnungVonBis.moveTo(von, value(von));
		zeichnungVonBis.lineTo(bis, value(bis));
	}

}
