/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.groesse.darstellung;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.geom.Point2D;

import javax.xml.transform.sax.TransformerHandler;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

public interface Auswertung {

	public Point2D getPos();

	public void setPos(Point2D pos);

	public void setLinienbreite(BasicStroke breite);

	public BasicStroke getLinienbreite();

	public void setTextgroesse(Font font);

	public Font getTextgroesse();

	public void setFarbe(Color farbe);

	public Color getFarbe();

	public Component getKomponente();

	public void setKomponente(Component komponente);

	public int getEndeZeile();

	public int getSpalte();

	public boolean enthaeltZeile(int zeile);

	public boolean hatKomponente();
	
	public boolean isManuell();
	
	public void setManuell(boolean an);

	public void updateXY();

	public void updateLocation();

	public void writeToXml(TransformerHandler hd) throws SAXException;

	public void startElement(String uri, String localName, String qName,
			Attributes attributes) throws SAXException;

	public void endElement(String uri, String localName, String qName,
			String inhalt) throws SAXException;
}
