package ghmessen.groesse.wertetabelle;

import java.text.NumberFormat;

import javax.swing.JLabel;
import javax.swing.table.DefaultTableCellRenderer;

public class StellenRenderer extends DefaultTableCellRenderer.UIResource {
	private static final long serialVersionUID = -4432997975082029575L;
	NumberFormat formatter;

	public StellenRenderer(int stellen) {
		this();
		if (stellen != 3) {
			formatter = NumberFormat.getInstance();
			formatter.setMaximumFractionDigits(stellen);
		}
	}

	public void setStellen(int stellen) {
		if (formatter != null)
			formatter.setMaximumFractionDigits(stellen);
		else if (stellen != 3) {
			formatter = NumberFormat.getInstance();
			formatter.setMaximumFractionDigits(stellen);
		}
	}

	public int getStellen() {
		if (formatter != null)
			return formatter.getMaximumFractionDigits();
		else
			return 3;
	}

	public StellenRenderer() {
		super();
		setHorizontalAlignment(JLabel.RIGHT);
	}

	public void setValue(Object value) {
		if (formatter == null) {
			formatter = NumberFormat.getInstance();
		}
		setText((value == null) ? "" : formatter.format(value));
	}

}

