package ghmessen.groesse.wertetabelle;

import ghmessen.groesse.wertetabelle.StellenRenderer;

import java.text.SimpleDateFormat;
import java.util.Date;

public class TimeRenderer extends StellenRenderer {
	private static final long serialVersionUID = 1L;
	SimpleDateFormat formatter;
	double maximum; /* s */

	public TimeRenderer(double maximum, int stellen) {
		this(maximum);
	}

	public TimeRenderer(double maximum) {
		super();
		this.maximum = maximum;
	}

	private void ensureFormatter() {
		if (formatter == null) {
			if (maximum > 24.0 * 3600.0)
				formatter = new SimpleDateFormat("D HH:mm");
			else if (maximum > 3600.0)
				formatter = new SimpleDateFormat("HH:mm");
			else if (maximum > 60.0)
				formatter = new SimpleDateFormat("mm:ss");
			else
				formatter = new SimpleDateFormat("ss:SSS");

		}
	}

	public void setStellen(int stellen) {
		ensureFormatter();
		super.setStellen(stellen);
	}

	public int getStellen() {
		ensureFormatter();
		return super.getStellen();
	}

	public void setValue(Object value) {
		ensureFormatter();
		setText((value == null) ? "" : formatter.format(new Date(Math
				.round(((Number) value).doubleValue() * 1000.0))));
	}

}
