package ghmessen.groesse.wertetabelle;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

import ld.api.ios.DefaultAxisMode;

public enum XAchseTyp {
	T(0, "t"), N(1, "n"), F(2, "f"), BETA(3, "β"), LAMBDA(4, "λ"), ENERGIE(5, "E"), GROESSE(6, "");

	public static final int UNABHAENGIG = 6;

	private int index;
	private String symbol;

	private XAchseTyp(int index, String symbol) {
		this.index = index;
		this.symbol = symbol;
	}

	public int getIndex() {
		return index;
	}

	public String getSymbol() {
		return symbol;
	}

	public static ArrayList<String> getAlleSymbole() {
		ArrayList<String> ret = new ArrayList<>();
		for (int i=0;i<UNABHAENGIG;i++)
				ret.add(values()[i].symbol);
		return ret;
	}

	public static XAchseTyp toXAchseTyp(DefaultAxisMode x) {
		switch (x) {
		case Index:
			return N;
		case Time:
			return T;
		default:
			return GROESSE;
		}
	}

	public static XAchseTyp toXAchseTyp(int i) {
		if (i < 0 || i > 6)
			return null;
		return values()[i];
	}

	/**
	 * XML-Format
	 */
	public static void createDTD(PrintWriter out) {
		out.print("<!ENTITY XAchseTyp \"");
		String s = "";
		for (XAchseTyp e : values())
			s += e.toString() + "|";
		out.println(s.substring(0, s.length() - 1) + "\">");
	}
}
