/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.instrumente;

import static ghmessen.Konstanten.FARBE_MESSGROESSE;
import ghmessen.adapter.cassy.AdapterCASSY;
import ghmessen.adapter.cassy.MesskanalCASSY;
import ghmessen.groesse.Groesse;
import ghmessen.groesse.Messbereich;
import ghmessen.groesse.Messgroesse;
import ghmessen.instrumente.komponenten.Zeigeranzeige;

import java.util.concurrent.ScheduledThreadPoolExecutor;

import javax.swing.JFrame;

public class MessgeraetLeistungPhase extends MessgeraetCASSY {

	private static final long serialVersionUID = 356301759783723555L;
	private static final boolean DEBUG = false;

	public MessgeraetLeistungPhase(JFrame parent, MesskanalCASSY messkanal, AdapterCASSY a, Groesse g,
			ScheduledThreadPoolExecutor hauptTimer) {
		super(parent, messkanal, a, g, hauptTimer);
		if (DEBUG)
			System.out.println("[MessgeraetLeistungPhase] - Konstruktor.");

	}

	@Override
	protected void initSkala() {
		Messbereich m = g.getMessbereich();
		skala = new Zeigeranzeige(g.getWert(), g.getNullpunkt(), m,
				g.getAufnahme(), FARBE_MESSGROESSE);
	}

	@Override
	public void showEinstellungenBox() {
		// Bei Phasenwinkel, CosPhi gibt es jeweils nur einen Messbereich und
		// keine weiteren Einstellungen.
		if (g.getMessGroesse() != Messgroesse.Leistung)
			return;
		super.showEinstellungenBox();
	}
}
