/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.instrumente;

import ghmessen.adapter.IAdapter;
import ghmessen.adapter.IMesskanal;
import ghmessen.groesse.Groesse;

import java.awt.Point;
import java.util.concurrent.ScheduledThreadPoolExecutor;

import javax.swing.JFrame;

public class MessgeraetRS extends MessgeraetLogik {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3501529264432959901L;
	private static final boolean DEBUG = false;

	public MessgeraetRS(JFrame parent, IMesskanal messkanal, IAdapter a, Groesse g,
			ScheduledThreadPoolExecutor hauptTimer) {
		super(parent, messkanal, a, g, hauptTimer);
		if (DEBUG)
			System.out.println("[MessgeraetRS] - Konstruktor.");
	}

	public void showEinstellungenBox() {
		if (eigenschaftenBox == null) {
			eigenschaftenBox = new MessgeraetRSEigenschaften(parent, true, a, messkanal, g);
			eigenschaftenBox.setLocationRelativeTo(parent);
			Point pos = eigenschaftenBox.getLocation();
			eigenschaftenBox.setLocation(pos.x + 100, pos.y + 50);
		}
		eigenschaftenBox.setVisible(true);
	}

}
