/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.instrumente.SensorPanel;

import ghmessen.adapter.IAdapter;
import ghmessen.adapter.IMesskanal;
import ghmessen.groesse.Groesse;

public class SensorBoxPanel extends javax.swing.JPanel {

	private static final long serialVersionUID = 8550735868857684693L;
	protected Groesse g;
	protected IAdapter a;
	protected IMesskanal messkanal;
	protected boolean firePC;

	public boolean hatGroessen() {
		return false;
	}

	public boolean hatBereiche() {
		return false;
	}

	public boolean hatMesswertAufnahme() {
		return false;
	}

	public boolean hatEffektivWert() {
		return false;
	}
	
	public boolean hatNullpunkt() {
		return false;
	}

	/** Creates new form SensorBoxPanel */
	public SensorBoxPanel(Groesse g, IAdapter a, IMesskanal messkanal) {
		this.g = g;
		this.a = a;
		this.messkanal = messkanal;
		initComponents();
	}

	protected void initComponents() {
		// init components but don't set initial values
		setMaximumSize(new java.awt.Dimension(323, 280));
		setMinimumSize(new java.awt.Dimension(323, 280));
		setPreferredSize(new java.awt.Dimension(323, 280));

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
		this.setLayout(layout);
		layout.setHorizontalGroup(layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addGap(0, 323,
				Short.MAX_VALUE));
		layout.setVerticalGroup(layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addGap(0, 280,
				Short.MAX_VALUE));
	}
}
