/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.instrumente.SensorPanel;

import ghmessen.adapter.IMesskanal;
import ghmessen.groesse.Groesse;
import ghmessen.groesse.Messgroesse;

import javax.swing.ActionMap;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import ld.api.ios.IMirror;
import ld.api.ios.ITimerPendulum;

import org.jdesktop.application.Action;
import org.jdesktop.application.Application;
import org.jdesktop.application.ResourceMap;

public class TimerBoxPanelOptionenStandard extends javax.swing.JPanel implements
		DocumentListener {

	private static final long serialVersionUID = 6735677292608127864L;
	protected Groesse g;
	protected IMesskanal messkanal;
	private boolean listen;

	private static ActionMap actionMap;
	private static ResourceMap resourceMap;

	/** Creates new form TimerBoxPanelOptionenStandard */
	public TimerBoxPanelOptionenStandard(Groesse g, IMesskanal messkanal) {
		this.g = g;
		this.messkanal = messkanal;
		listen = true;
		initComponents();
		leseWerte();
		adjustComponents();
	}

	public void leseWerte() {
		listen = false;
		messStart.setSelected(g.isStart1Flanke());
		messStopp.setSelected(g.isStoppFlanke());
		invertieren.setSelected(g.isInvertieren());
		pendel.setSelected(g.isPendel());
		ueberschreiben.setSelected(g.isUeberschreiben());
		listen = true;
	}

	public void initComponents() {

		actionMap = Application.getInstance(ghmessen.GHMessen.class)
				.getContext()
				.getActionMap(TimerBoxPanelOptionenStandard.class, this);

		resourceMap = Application.getInstance(ghmessen.GHMessen.class)
				.getContext()
				.getResourceMap(TimerBoxPanelOptionenStandard.class);
		
		jPanel1 = new javax.swing.JPanel();
		messStart = new javax.swing.JCheckBox();
		messStart.setAction(actionMap.get("start1flanke"));
		messStopp = new javax.swing.JCheckBox();
		messStopp.setAction(actionMap.get("stoppflanke"));
		flankeNr = new javax.swing.JFormattedTextField();
		flankeNr.getDocument().addDocumentListener(this);
		invertieren = new javax.swing.JCheckBox();
		invertieren.setAction(actionMap.get("invertieren"));
		pendel = new javax.swing.JCheckBox();
		pendel.setAction(actionMap.get("pendel"));
		ueberschreiben = new javax.swing.JCheckBox();
		ueberschreiben.setAction(actionMap.get("ueberschreiben"));

		jPanel1.setBorder(javax.swing.BorderFactory
				.createTitledBorder(resourceMap.getString("messparameter.text")));

		javax.swing.GroupLayout gl_jPanel1 = new javax.swing.GroupLayout(
				jPanel1);
		gl_jPanel1
				.setHorizontalGroup(gl_jPanel1
						.createParallelGroup(Alignment.LEADING)
						.addGroup(
								gl_jPanel1
										.createSequentialGroup()
										.addContainerGap()
										.addGroup(
												gl_jPanel1
														.createParallelGroup(
																Alignment.LEADING)
														.addComponent(messStart)
														.addGroup(
																gl_jPanel1
																		.createSequentialGroup()
																		.addComponent(
																				messStopp)
																		.addPreferredGap(
																				ComponentPlacement.RELATED)
																		.addComponent(
																				flankeNr,
																				GroupLayout.PREFERRED_SIZE,
																				79,
																				GroupLayout.PREFERRED_SIZE))
														.addComponent(
																invertieren)
														.addComponent(pendel)
														.addComponent(
																ueberschreiben))
										.addContainerGap(36, Short.MAX_VALUE)));
		gl_jPanel1
				.setVerticalGroup(gl_jPanel1
						.createParallelGroup(Alignment.LEADING)
						.addGroup(
								gl_jPanel1
										.createSequentialGroup()
										.addComponent(messStart)
										.addPreferredGap(
												ComponentPlacement.UNRELATED)
										.addGroup(
												gl_jPanel1
														.createParallelGroup(
																Alignment.BASELINE)
														.addComponent(messStopp)
														.addComponent(
																flankeNr,
																GroupLayout.PREFERRED_SIZE,
																GroupLayout.DEFAULT_SIZE,
																GroupLayout.PREFERRED_SIZE))
										.addPreferredGap(
												ComponentPlacement.UNRELATED)
										.addComponent(invertieren)
										.addPreferredGap(
												ComponentPlacement.UNRELATED)
										.addComponent(pendel)
										.addPreferredGap(
												ComponentPlacement.UNRELATED)
										.addComponent(ueberschreiben)
										.addContainerGap(
												GroupLayout.DEFAULT_SIZE,
												Short.MAX_VALUE)));
		jPanel1.setLayout(gl_jPanel1);

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
		this.setLayout(layout);
		layout.setHorizontalGroup(layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addGroup(
				layout.createSequentialGroup()
						.addContainerGap()
						.addComponent(jPanel1,
								javax.swing.GroupLayout.PREFERRED_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE,
								javax.swing.GroupLayout.PREFERRED_SIZE)
						.addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE,
								Short.MAX_VALUE)));
		layout.setVerticalGroup(layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addGroup(
				layout.createSequentialGroup()
						.addContainerGap()
						.addComponent(jPanel1,
								javax.swing.GroupLayout.PREFERRED_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE,
								javax.swing.GroupLayout.PREFERRED_SIZE)
						.addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE,
								Short.MAX_VALUE)));
	}// </editor-fold>//GEN-END:initComponents

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel1;
	private javax.swing.JCheckBox messStart;
	private javax.swing.JCheckBox messStopp;
	private javax.swing.JFormattedTextField flankeNr;
	private javax.swing.JCheckBox invertieren;
	private javax.swing.JCheckBox pendel;
	private javax.swing.JCheckBox ueberschreiben;

	// End of variables declaration//GEN-END:variables

	@Action
	public void start1flanke() {
		g.setStart1Flanke(messStart.isSelected());
	}

	@Action
	public void stoppflanke() {
		g.setStoppFlanke(messStopp.isSelected());
	}

	@Action
	public void invertieren() {
		g.setInvertieren(invertieren.isSelected());
		if(messkanal instanceof IMirror)
			((IMirror)messkanal).doMirror();
	}

	@Action
	public void pendel() {
		g.setPendel(pendel.isSelected());
		if(messkanal instanceof ITimerPendulum)
			((ITimerPendulum)messkanal).setTimerPendulum(g.isPendel());
	}

	@Action
	public void ueberschreiben() {
		g.setUeberschreiben(ueberschreiben.isSelected());
	}

	public void flankeNrSpeichern() {
		if (listen)
			g.setFlanke((Integer) flankeNr.getValue());
	}

	@Override
	public void insertUpdate(DocumentEvent e) {
		flankeNrSpeichern();
	}

	@Override
	public void removeUpdate(DocumentEvent e) {
		flankeNrSpeichern();
	}

	@Override
	public void changedUpdate(DocumentEvent e) {
		return;
	}

	public void adjustComponents() {
		Messgroesse gm = g.getMessGroesse();
		if(gm == Messgroesse.Ereignisse || gm == Messgroesse.Frequenz || gm == Messgroesse.Rate) {
			messStart.setEnabled(false);
			messStopp.setEnabled(false);
			flankeNr.setEnabled(false);
			invertieren.setEnabled(false);
			pendel.setEnabled(false);
			ueberschreiben.setEnabled(true);
		} else if(gm == Messgroesse.Periodendauer || gm == Messgroesse.Laufzeit) {
			messStart.setEnabled(false);
			messStopp.setEnabled(false);
			flankeNr.setEnabled(false);
			invertieren.setEnabled(true);
			pendel.setEnabled(g.getMessGroesse() == Messgroesse.Periodendauer);
			ueberschreiben.setEnabled(true);
		} else 		if(gm == Messgroesse.Verdunkelung || gm == Messgroesse.Dunkelzeit || gm == Messgroesse.Weg || gm == Messgroesse.Winkel) {
			messStart.setEnabled(true);
			messStopp.setEnabled(true);
			flankeNr.setEnabled(true);
			invertieren.setEnabled(true);
			pendel.setEnabled(false);
			ueberschreiben.setEnabled(false);
		} else {
			messStart.setEnabled(false);
			messStopp.setEnabled(false);
			flankeNr.setEnabled(false);
			invertieren.setEnabled(false);
			pendel.setEnabled(false);
			ueberschreiben.setEnabled(false);
		}
	}
}
