/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.instrumente.SensorPanel;

import ghmessen.adapter.IMesskanal;
import ghmessen.groesse.Groesse;

import java.util.Enumeration;
import java.util.Vector;

import javax.swing.AbstractButton;
import javax.swing.ButtonModel;

import org.jdesktop.application.Action;


public class TimerBoxPanelOptionenStoss extends TimerBoxPanelOptionenStandard {

	private static final long serialVersionUID = -4819113928172128894L;
	private Vector<ButtonModel> anordnungen;
	
	/** Creates new form TimerBoxPanelOptionenStandard */
	public TimerBoxPanelOptionenStoss(Groesse g, IMesskanal messkanal) {
		super(g, messkanal);
	}

	@Override
	public void leseWerte(){
		anordnung.setSelected(anordnungen.get(g.getAnordnung()),true);		
	}

	@Override
	public void initComponents() {

		javax.swing.ActionMap actionMap = org.jdesktop.application.Application
		.getInstance().getContext()
		.getActionMap(TimerBoxPanelOptionenStoss.class, this);

		anordnung = new javax.swing.ButtonGroup();
		jPanel1 = new javax.swing.JPanel();
		anordnung1EF2 = new javax.swing.JRadioButton();
		anordnungE1F2 = new javax.swing.JRadioButton();
		anordnung1E2F = new javax.swing.JRadioButton();
		anordnungE12F = new javax.swing.JRadioButton();

		jPanel1.setBorder(javax.swing.BorderFactory
				.createTitledBorder("Wagenanordnung vor dem Stoß"));
		jPanel1.setName("jPanel1"); // NOI18N

		anordnung.add(anordnung1EF2);
		anordnung1EF2.setAction(actionMap.get("setzeAnordnung"));
		anordnung1EF2.setText("1 E    F 2 (fahren aufeinander zu)");
		anordnung1EF2.setName("anordnung1EF2"); // NOI18N

		anordnung.add(anordnungE1F2);
		anordnungE1F2.setAction(actionMap.get("setzeAnordnung"));
		anordnungE1F2.setText("E 1    F 2 (Wagen 1 ruht)");
		anordnungE1F2.setName("anordnungE1F2"); // NOI18N

		anordnung.add(anordnung1E2F);
		anordnung1E2F.setAction(actionMap.get("setzeAnordnung"));
		anordnung1E2F.setText("1 E    2 F (Wagen 2 ruht)");
		anordnung1E2F.setName("anordnung1E2F"); // NOI18N

		anordnung.add(anordnungE12F);
		anordnungE12F.setAction(actionMap.get("setzeAnordnung"));
		anordnungE12F.setText("E 1    2 F (Explosion)");
		anordnungE12F.setName("anordnungE12F"); // NOI18N

		javax.swing.GroupLayout gl_jPanel1 = new javax.swing.GroupLayout(
				jPanel1);
		jPanel1.setLayout(gl_jPanel1);
		gl_jPanel1
				.setHorizontalGroup(gl_jPanel1
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								gl_jPanel1
										.createSequentialGroup()
										.addContainerGap()
										.addGroup(
												gl_jPanel1
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.LEADING)
														.addComponent(
																anordnung1EF2)
														.addComponent(
																anordnungE1F2)
														.addComponent(
																anordnung1E2F)
														.addComponent(
																anordnungE12F))
										.addContainerGap(
												javax.swing.GroupLayout.DEFAULT_SIZE,
												Short.MAX_VALUE)));
		gl_jPanel1
				.setVerticalGroup(gl_jPanel1
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								gl_jPanel1
										.createSequentialGroup()
										.addContainerGap()
										.addComponent(anordnung1EF2)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
										.addComponent(anordnungE1F2)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
										.addComponent(anordnung1E2F)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
										.addComponent(anordnungE12F)
										.addContainerGap(
												javax.swing.GroupLayout.DEFAULT_SIZE,
												Short.MAX_VALUE)));

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
		this.setLayout(layout);
		layout.setHorizontalGroup(layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addGroup(
				layout.createSequentialGroup()
						.addContainerGap()
						.addComponent(jPanel1,
								javax.swing.GroupLayout.PREFERRED_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE,
								javax.swing.GroupLayout.PREFERRED_SIZE)
						.addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE,
								Short.MAX_VALUE)));
		layout.setVerticalGroup(layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addGroup(
				layout.createSequentialGroup()
						.addContainerGap()
						.addComponent(jPanel1,
								javax.swing.GroupLayout.PREFERRED_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE,
								javax.swing.GroupLayout.PREFERRED_SIZE)
						.addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE,
								Short.MAX_VALUE)));
		anordnungen = new Vector<ButtonModel>();
		Enumeration<AbstractButton> temp = anordnung.getElements();
		while(temp.hasMoreElements())
			anordnungen.add(temp.nextElement().getModel());
		System.out.println("[TimerBoxPanelOptionenStoss] - initComponents: anordnungen("+anordnungen+")");
	}// </editor-fold>//GEN-END:initComponents

	@Override
	public void adjustComponents(){
		return;
	}
	
	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.ButtonGroup anordnung;
	protected javax.swing.JRadioButton anordnung1EF2;
	protected javax.swing.JRadioButton anordnungE1F2;
	protected javax.swing.JRadioButton anordnung1E2F;
	protected javax.swing.JRadioButton anordnungE12F;
	private javax.swing.JPanel jPanel1;
	// End of variables declaration//GEN-END:variables

	@Action
	public void setzeAnordnung(){
		g.setAnordnung(anordnungen.indexOf(anordnung.getSelection()));
	}
}
