package ghmessen.instrumente.komponenten;

import static ghmessen.groesse.Aufnahme.effektiv;
import static ghmessen.groesse.Aufnahme.gemittelt;
import static ghmessen.groesse.Aufnahme.momentan;
import ghmessen.groesse.Aufnahme;

import javax.swing.JLabel;

import org.jdesktop.application.ResourceMap;

public class ArtLabel extends JLabel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6461982908330268327L;
	private static final ResourceMap resourceMap = org.jdesktop.application.Application
			.getInstance(ghmessen.GHMessen.class).getContext()
			.getResourceMap(ArtLabel.class);

	public ArtLabel() {
		this(momentan);
	}

	public ArtLabel(Aufnahme aufnahme) {
		super(aufnahme == momentan ? "" : (aufnahme == gemittelt ? resourceMap
				.getString("gemittelt.text") : resourceMap
				.getString("effektiv.text")));
	}

	public void setAufnahme(Aufnahme aufnahme) {
		switch (aufnahme) {
		case momentan:
			setText("");
			break;
		case gemittelt:
			setText(resourceMap.getString("gemittelt.text"));
			break;
		case effektiv:
			setText(resourceMap.getString("effektiv.text"));
			break;
		}
	}

	public Aufnahme getAufnahme() {
		if ("".equals(getText()))
			return momentan;
		else if (resourceMap.getString("gemittelt.text").equals(getText()))
			return gemittelt;
		else
			return effektiv;
	}
}
