/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.instrumente.komponenten;

import java.awt.Color;
import java.awt.Graphics;

public class Zeiger extends javax.swing.JLabel {
	
	private static final long serialVersionUID = 1L;
	private static final boolean DEBUG = false;
	private int zeigerdreieckhoehe = 2;
	private static final int anzahlPunkte = 5;

	public Zeiger(Color farbe) {
		super();
		setForeground(farbe);
	}

	public void paint(Graphics g) {
		Graphics g1 = g.create();
		int height = getHeight();
		int width = getWidth();
		g1.fillPolygon(
				new int[] { width - 1, width - 1, width / 2, 0, 0 },
				new int[] { height - 1, height / 2,
						height / 2 - zeigerdreieckhoehe, height / 2, height - 1 },
				anzahlPunkte);
		g1.drawLine(width / 2, height, width / 2, 0);
		if (DEBUG) {
			g1.setColor(Color.BLACK);
			g1.drawRect(0, 0, width - 1, height - 1);
		}

	}

	public void setSize(int w, int h) {
		w = (w % 2) == 0 ? w + 1 : w;
		super.setSize(w, h);
		zeigerdreieckhoehe = (int) Math.max(2, Math.round(0.175 * h));
	}
}
