/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.parser;

import java.lang.reflect.InvocationTargetException;

import org.codehaus.janino.ExpressionEvaluator;


public class FreieFunktionParser extends FormelGenerator {
	@SuppressWarnings("unused")
	private static final long serialVersionUID = 5564039920610467536L;
	private static final boolean DEBUG = false;

	public FreieFunktionParser() {
		this("funktion", new String[] { "A", "B", "C", "D" });
		if(DEBUG);
	}

	public FreieFunktionParser(String name) {
		this(name, new String[] { "A", "B", "C", "D" });
	}

	public FreieFunktionParser(String name, String[] konstanten) {
		super(name, konstanten);
	}

	public static void main(String[] args) {
		FreieFunktionParser p = new FreieFunktionParser();
		p.setName("U_B1");
		String[] f = {
				"2*t+5",
				"-17.5E-13*(exp(-2*(sin(2*t-A*#pi)-#pi)*#e*(2-2*B)))+1.0*t^2*sqrt(2)-(-ln(#e)+log(#e))",
				"2*C+D/2+2*t^2" };
		ExpressionEvaluator[] ee = new ExpressionEvaluator[3];
		for (int i = 0; i < f.length; i++) {
			System.out.println("\n===============================\nTerm: "
					+ f[i] + "\n--------------");
			if (p.parsen(f[i]))
				ee[i] = p.getAusdruck(f[i]);
			else
				System.out.println("Das Parsen ist fehlgeschlagen.");
		}
		Object[] parameterValues = { new Double(1.0), new Double(2),
				new Double(3), new Double(4), new Double(5) };
		for (int i = 0; i < ee.length; i++) {
			try {
				System.out.println("Auswertung von Term " + i + ": "
						+ ee[i].evaluate(parameterValues));
			} catch (InvocationTargetException e) {
				e.printStackTrace();
			}
		}
	}

}
