package ghmessen.util;

import java.awt.Component;
import java.awt.event.MouseAdapter;

import javax.swing.JComponent;
import javax.swing.RootPaneContainer;
import javax.swing.SwingUtilities;

/** Basic CursorTk that swallows mouseclicks */
public class CursorTk implements Cursors {

	private static final boolean DEBUG = false;
	private final static MouseAdapter mouseAdapter = new MouseAdapter() {
	};

	private CursorTk() {
	}

	private static RootPaneContainer getRPC(Component component) {
		if (component instanceof RootPaneContainer)
			return (RootPaneContainer) component;
		else if (component instanceof JComponent)
			return (RootPaneContainer) ((JComponent) component)
					.getTopLevelAncestor();
		else
			return (RootPaneContainer) SwingUtilities.getRootPane(component);

	}

	public static void startWaitCursor(Component component) {
		try {
			RootPaneContainer root = getRPC(component);
			root.getGlassPane().setCursor(WAIT_CURSOR);
			root.getGlassPane().addMouseListener(mouseAdapter);
			root.getGlassPane().setVisible(true);
		} catch (NullPointerException e) {
			if (DEBUG)
				System.out
						.println("[CursorTk] - startWaitCursor: Komponente kann nicht verarbeitet werden.");
		} catch (IllegalStateException e) {
			if (DEBUG)
				System.out
						.println("[CursorTk] - startWaitCursor: Komponente kann nicht verarbeitet werden.");
		}
	}

	public static void stopWaitCursor(Component component) {
		try {
			RootPaneContainer root = getRPC(component);
			root.getGlassPane().setCursor(DEFAULT_CURSOR);
			root.getGlassPane().removeMouseListener(mouseAdapter);
			root.getGlassPane().setVisible(false);
		} catch (NullPointerException e) {
			if (DEBUG)
				System.out
						.println("[CursorTk] - stopWaitCursor: Komponente kann nicht verarbeitet werden.");
		} catch (IllegalStateException e) {
			if (DEBUG)
				System.out
						.println("[CursorTk] - stopWaitCursor: Komponente kann nicht verarbeitet werden.");
		}
	}

}
