/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.util;

public class HTML {

	public static String symbolZuHTML(String symbol){
		return symbol == null ? null : _tosubsub(symbol);		
	}
	public static String symbolZuHTML(String symbol, boolean mitBegrenzung){
		if(mitBegrenzung)
			return umgebeMitHTML(symbolZuHTML(symbol));
		else
			return symbolZuHTML(symbol);
	}
	
	private static String _tosubsub(String s) {
		if(s.indexOf("__") > -1)
			s = s.replace("__", "<sub>") + "</sub>";
		if(s.indexOf("_") > -1)
			s = s.replace("_", "<sub>") + "</sub>";
		return s;
	}
	
	private static String _fromsubsub(String s) {
		if (s.indexOf("<sub>") > -1) {
			s = s.replace("<sub>", "_");
			if (s.indexOf("<sub>") > -1) {
				//sub sub
				s = s.replace("<sub>", "__");
			}
			s = s.replaceAll("\\<.*?\\>", "");
		}
		return s;
	}
	
	public static String htmlZuSymbol(String html){
		return html == null ? null : _fromsubsub(html);
	}
	
	public static String[] htmlZuSymbole(String html){
		if(html == null)
			return null;
		String[] htmls = html.split(" ");
		for(int i=0;i<htmls.length;i++)
			htmls[i] = _fromsubsub(htmls[i]);
		return htmls;
	}
	
	public static boolean enthaeltHTML(String text){
		return text == null ? false : text.matches("\\<.*?\\>");
	}
	
	public static String umgebeMitHTML(String text){
		return "<html>"+text+"</html>";
	}
	
	public static boolean istMitHTMLUmgeben(String text){
		return text == null ? false : text.startsWith("<html>") && text.endsWith("</html>");
	}
	
}
