/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package ghmessen.util;

import java.awt.Image;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;


public class ImageSelection  implements Transferable {
  // the Image object which will be housed by the ImageSelection
  private Image image;

  public ImageSelection(Image image) {
    this.image = image;
  }

  // Returns the supported flavors of our implementation
  public DataFlavor[] getTransferDataFlavors() 
  {
    return new DataFlavor[] {DataFlavor.imageFlavor};
  }
  
  // Returns true if flavor is supported
  public boolean isDataFlavorSupported(DataFlavor flavor) 
  {
    return DataFlavor.imageFlavor.equals(flavor);
  }

  // Returns Image object housed by Transferable object
  public Object getTransferData(DataFlavor flavor)
    throws UnsupportedFlavorException,IOException 
  {
    if (!DataFlavor.imageFlavor.equals(flavor)) 
    {
      throw new UnsupportedFlavorException(flavor);
    }
    // else return the payload
    return image;
  }
}
