package ghmessen.util;

import ghmessen.groesse.Einheit;

public class ZeitUtil {

	public static double getZeitWert(String s) {
		double zahl = Double.parseDouble(s.substring(0, s.indexOf(" ")));
		s = s.substring(s.indexOf(" ") + 1, s.length());
		Einheit e = Einheit.toEinheit(s);
		return zahl * e.getFaktor();
	}

	public static Einheit getZeitEinheit(double messzeit) {
		if (messzeit < 0.001)
			return Einheit.μs;
		else if (messzeit < 1)
			return Einheit.ms;
		else if (messzeit < 60)
			return Einheit.s;
		else if (messzeit < 3600)
			return Einheit.min;
		else
			return Einheit.h;
	}

	public static double getZeitWert(double messzeit) {
		Einheit e;
		if (messzeit < 0.001)
			e = Einheit.μs;
		else if (messzeit < 1)
			e = Einheit.ms;
		else if (messzeit < 60)
			e = Einheit.s;
		else if (messzeit < 3600)
			e = Einheit.min;
		else
			e = Einheit.h;
		return (messzeit / e.getFaktor());
	}

	public static String getZeitString(double intervall) {
		Einheit e;
		if (intervall < 0.001)
			e = Einheit.μs;
		else if (intervall < 1)
			e = Einheit.ms;
		else if (intervall < 60)
			e = Einheit.s;
		else if (intervall < 3600)
			e = Einheit.min;
		else
			e = Einheit.h;
		return java.lang.Math.round(intervall / e.getFaktor()) + " " + e.toString();
	}


}
