package libGoIO;
import java.util.Collections;
import java.util.Iterator;
import org.bridj.BridJ;
import org.bridj.CRuntime;
import org.bridj.FlagSet;
import org.bridj.IntValuedEnum;
import org.bridj.Pointer;
import org.bridj.ann.Library;
import org.bridj.ann.Name;
import org.bridj.ann.Ptr;
import org.bridj.ann.Runtime;
/**
 * Wrapper for library <b>GoIO</b><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("GoIO") 
@Runtime(CRuntime.class) 
public class GoIOLibrary {
	static {
		BridJ.register();
	}
	/**
	 * enum values<br>
	 * <i>native declaration : include/GSkipCommExt.h:30</i>
	 */
	public enum ELEDSettings implements IntValuedEnum<ELEDSettings > {
		kLEDSettings_Off(0),
		kLEDSettings_Red(1),
		kLEDSettings_Green(2),
		kLEDSettings_Orange(3);
		ELEDSettings(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<ELEDSettings > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<ELEDSettings > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : include/GSensorDDSMem.h:6</i>
	 */
	public enum ESensorIdNumber implements IntValuedEnum<ESensorIdNumber > {
		kSensorIdNumber_Unknown(0),
		kSensorIdNumber_Voltage10(2),
		kSensorIdNumber_FirstSmartSensor(20),
		kSensorIdNumber_GoTemp(60),
		kSensorIdNumber_GoMotion(69);
		ESensorIdNumber(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<ESensorIdNumber > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<ESensorIdNumber > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : include/GSensorDDSMem.h:37</i>
	 */
	public enum EEquationType implements IntValuedEnum<EEquationType > {
		kEquationType_None(0),
		/** linear, y = bx + a */
		kEquationType_Linear(1),
		/** y = cx^2 + bx + a */
		kEquationType_Quadratic(2),
		/** y = a * x^b */
		kEquationType_Power(3),
		/** y = a * b^x */
		kEquationType_ModifiedPower(4),
		/** y = a + b * ln(x) */
		kEquationType_Logarithmic(5),
		/** y = a + b * ln(1/x) */
		kEquationType_ModifiedLogarithmic(6),
		/** y = a * e^(b * x) */
		kEquationType_Exponential(7),
		/** y = a * e^(b / x) */
		kEquationType_ModifiedExponential(8),
		/** y = a * x^(b * x) */
		kEquationType_Geometric(9),
		/** y = a * x^(b / x) */
		kEquationType_ModifiedGeometric(10),
		/** y = 1 / (a + b * ln(c * x)) */
		kEquationType_ReciprocalLog(11),
		/** y = 1 / (a + b * ln(1000*x) + c * (ln(1000*x)^3) ) */
		kEquationType_SteinhartHart(12),
		kEquationType_Motion(13),
		kEquationType_Rotary(14),
		kEquationType_HeatPulser(15),
		kEquationType_DropCounter(16);
		EEquationType(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<EEquationType > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<EEquationType > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : include/GSensorDDSMem.h:55</i>
	 */
	public enum EProbeType implements IntValuedEnum<EProbeType > {
		kProbeTypeNoProbe(0),
		kProbeTypeTime(1),
		/** Skip supports this! */
		kProbeTypeAnalog5V(2),
		/** Skip supports this! */
		kProbeTypeAnalog10V(3),
		kProbeTypeHeatPulser(4),
		kProbeTypeAnalogOut(5),
		kProbeTypeMD(6),
		kProbeTypePhotoGate(7),
		/** kProbeTypePhotoGatePulsePeriod, no longer allowed (never used) */
		kProbeTypeDigitalCount(10),
		kProbeTypeRotary(11),
		kProbeTypeDigitalOut(12),
		kProbeTypeLabquestAudio(13),
		kNumProbeTypes(14);
		EProbeType(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<EProbeType > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<EProbeType > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	public static final int VERNIER_DEFAULT_VENDOR_ID = 0x08F7;
	public static final int LABPRO_DEFAULT_PRODUCT_ID = 0x0001;
	/** aka GoTemp */
	public static final int USB_DIRECT_TEMP_DEFAULT_PRODUCT_ID = 0x0002;
	/** aka GoLink */
	public static final int SKIP_DEFAULT_PRODUCT_ID = 0x0003;
	/** aka GoMotion */
	public static final int CYCLOPS_DEFAULT_PRODUCT_ID = 0x0004;
	/** aka LabQuest */
	public static final int NGI_DEFAULT_PRODUCT_ID = 0x0005;
	/** aka SpectroVis */
	public static final int LOWCOST_SPEC_DEFAULT_PRODUCT_ID = 0x0006;
	/** aka Vernier Mini Gas Chromatograph */
	public static final int MINI_GC_DEFAULT_PRODUCT_ID = 0x0007;
	/** aka LabQuest Mini */
	public static final int STANDALONE_DAQ_DEFAULT_PRODUCT_ID = 0x0008;
	/** aka SpectroVis Plus */
	public static final int LOWCOST_SPEC2_DEFAULT_PRODUCT_ID = 0x0009;
	public static final int FTDI_GENERIC_VENDOR_ID = 0x0403;
	public static final int FTDI_GENERIC_PRODUCT_ID = 0x6001;
	public static final int OCEAN_OPTICS_DEFAULT_VENDOR_ID = 0x2457;
	public static final int OCEAN_OPTICS_DEFAULT_PRODUCT_ID = 0x1002;
	public static final int OCEAN_OPTICS_USB325_PRODUCT_ID = 0x1024;
	public static final int OCEAN_OPTICS_USB650_PRODUCT_ID = 0x1014;
	public static final int OCEAN_OPTICS_USB2000_PRODUCT_ID = 0x1002;
	public static final int OCEAN_OPTICS_HR4000_PRODUCT_ID = 0x1012;
	public static final int OCEAN_OPTICS_USB4000_PRODUCT_ID = 0x1022;
	public static final int NATIONAL_INSTRUMENTS_DEFAULT_VENDOR_ID = 0x3923;
	public static final int SENSORDAQ_DEFAULT_PRODUCT_ID = 0x72CC;
	public static final byte kLEDOff = (byte)0xC0;
	public static final byte kLEDRed = 0x40;
	public static final byte kLEDGreen = (byte)0x80;
	public static final byte kLEDOrange = 0;
	public static final byte kSkipMaxLedBrightness = 0x10;
	public static final byte kSkipOrangeLedBrightness = 4;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_LED_COLOR_BLACK = (int)0xC0;
	/** <i>native declaration : include/GSensorDDSMem.h</i> */
	public static final int MAX_CALIBRATION_UNITS_CHARS_ON_SENSOR = (int)7;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_LOCAL_NV_MEM_1BYTE = (int)0x11;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_ANALOG_INPUT_CHANNEL_VIN_LOW = (int)2;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_BATTERY_STATE_MISSING = (int)0X0C;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_GET_STATUS = (int)0x10;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_GET_SENSOR_ID = (int)0x28;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_GET_VIN_OFFSET_DAC = (int)0x2B;
	/** <i>native declaration : include/GoIO_DLL_interface.h</i> */
	public static final int GOIO_TRACE_SEVERITY_MEDIUM = (int)50;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int FIRST_SKIP_CMD_ID = (int)0x10;
	/** <i>native declaration : include/GMiniGCDDSMem.h</i> */
	public static final String MINIGC_CMD_GETRDY = (String)"GETRDY";
	/** <i>native declaration : include/GMiniGCDDSMem.h</i> */
	public static final String MINIGC_CMD_STOP = (String)"STOP";
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_REMOTE_NV_MEM_6BYTES = (int)0x26;
	/** <i>native declaration : include/GMiniGCDDSMem.h</i> */
	public static final String MINIGC_CMD_RUN = (String)"RUN";
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_LOCAL_NV_MEM_6BYTES = (int)0x16;
	/** <i>native declaration : include/GoIO_DLL_interface.h</i> */
	public static final int GOIO_TRACE_SEVERITY_HIGH = (int)100;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_SLAVE_POWERUP_INIT = (int)0x40;
	/** <i>native declaration : include/GMiniGCDDSMem.h</i> */
	public static final String MINIGC_STATE_READY = (String)"READY";
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_LOCAL_NV_MEM_4BYTES = (int)0x14;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_INVALID_PARAMETER = (int)0x36;
	/** <i>native declaration : include/GMiniGCDDSMem.h</i> */
	public static final String MINIGC_STATE_RUN = (String)"RUN";
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_SUCCESS = (int)0;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_ERROR_MEAS_PACKET_LOST = (int)8;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_REMOTE_NV_MEM_4BYTES = (int)0x24;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_CANNOT_CHANGE_PERIOD_WHILE_COLLECTING = (int)0x34;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_CMD_NOT_SUPPORTED = (int)0x31;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_TIMEOUT_MS_CMD_ID_INIT_WITH_BUSY_STATUS = (int)400;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_GET_SERIAL_NUMBER = (int)0x20;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_ERROR_CMD_NOT_RECOGNIZED = (int)1;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_BATTERY_STATE_LOW_ALWAYS = (int)8;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_CANNOT_READ_NV_MEM_BLK_WHILE_COLLECTING_FAST = (int)0x35;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_COMMUNICATION = (int)0xF0;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_START_MEASUREMENTS = (int)0x18;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_ERROR_MASTER_INVALID_MEAS_COUNTER = (int)0X20;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_SPARE4 = (int)0x2F;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int LAST_SKIP_CMD_ID = (int)0x2F;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_SPARE1 = (int)0x2C;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_SPARE3 = (int)0x2E;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_SPARE2 = (int)0x2D;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_OP_BLOCKED_WHILE_COLLECTING = (int)0x39;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_SET_ANALOG_INPUT_CHANNEL = (int)0x29;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_ERROR_MASTER_FIFO_OVERFLOW = (int)0X40;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_REMOTE_NV_MEM_1BYTE = (int)0x21;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_REMOTE_NV_MEM_2BYTES = (int)0x22;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_SET_LED_STATE = (int)0x1D;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_LED_BRIGHTNESS_MIN = (int)0;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_ERROR_MEAS_CONVERSION_LOST = (int)0X80;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_TIMEOUT_MS_CMD_ID_INIT_WO_BUSY_STATUS = (int)6000;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_SET_VIN_OFFSET_DAC = (int)0x1F;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_LOCAL_NV_MEM_2BYTES = (int)0x12;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_GET_LED_STATE = (int)0x1E;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_NOT_READY_FOR_NEW_CMD = (int)0x30;
	/** <i>native declaration : include/GoIO_DLL_interface.h</i> */
	public static final int GOIO_MAX_SIZE_DEVICE_NAME = (int)260;
	/** <i>native declaration : include/GMiniGCDDSMem.h</i> */
	public static final String MINIGC_STATE_NOTRDY = (String)"NOTRDY";
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_INIT = (int)0x1A;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_REMOTE_NV_MEM_3BYTES = (int)0x23;
	/** <i>native declaration : include/GMiniGCDDSMem.h</i> */
	public static final String MINIGC_STATE_ERR_PREFIX = (String)"ERR";
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_LOCAL_NV_MEM_3BYTES = (int)0x13;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_STOP_MEASUREMENTS = (int)0x19;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_BATTERY_STATE = (int)0X0C;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_SLAVE_POWERRESTORE_INIT = (int)0x41;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_LED_COLOR_RED_GREEN = (int)0;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_READ_LOCAL_NV_MEM = (int)0x17;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_ERROR_MASTER_INVALID_SPI_PACKET = (int)0X10;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_ANALOG_INPUT_CHANNEL_VIN = (int)1;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_LED_BRIGHTNESS_MAX = (int)0x10;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_GET_MEASUREMENT_PERIOD = (int)0x1C;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_ANALOG_INPUT_CHANNEL_VID = (int)3;
	/** <i>native declaration : include/GMiniGCDDSMem.h</i> */
	public static final String MINIGC_STATE_STOP = (String)"STOP";
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_LED_COLOR_GREEN = (int)0x80;
	/** <i>native declaration : include/GoIO_DLL_interface.h</i> */
	public static final int SKIP_TIMEOUT_MS_READ_DDSMEMBLOCK = (int)2000;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_ERROR_PACKET_OVERRUN = (int)4;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_LOCAL_NV_MEM_5BYTES = (int)0x15;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_READ_REMOTE_NV_MEM = (int)0x27;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_BATTERY_STATE_GOOD = (int)0;
	/** <i>native declaration : include/GoIO_DLL_interface.h</i> */
	public static final int SKIP_TIMEOUT_MS_DEFAULT = (int)1000;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_CANNOT_WRITE_FLASH_WHILE_COLLECTING = (int)0x37;
	/** <i>native declaration : include/GoIO_DLL_interface.h</i> */
	public static final int GOIO_TRACE_SEVERITY_LOW = (int)10;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_ANALOG_INPUT_CHANNEL_VOFF = (int)0;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_BATTERY_STATE_LOW_WHILE_SAMPLING = (int)4;
	/** <i>native declaration : include/GoIO_DLL_interface.h</i> */
	public static final int SKIP_TIMEOUT_MS_WRITE_DDSMEMBLOCK = (int)4000;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_LED_COLOR_RED = (int)0x40;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_GET_ANALOG_INPUT_CHANNEL = (int)0x2A;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_CALCULATOR_CANNOT_MEASURE_WITH_NO_BATTERIES = (int)0x3A;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_INTERNAL_ERROR1 = (int)0x32;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_SET_MEASUREMENT_PERIOD = (int)0x1B;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_INTERNAL_ERROR2 = (int)0x33;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_CMD_ID_WRITE_REMOTE_NV_MEM_5BYTES = (int)0x25;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_MASK_STATUS_ERROR_CMD_IGNORED = (int)2;
	/** <i>native declaration : include/GoIO_DLL_interface.h</i> */
	public static final int GOIO_TRACE_SEVERITY_LOWEST = (int)1;
	/** <i>native declaration : include/GSkipCommExt.h</i> */
	public static final int SKIP_STATUS_ERROR_CANNOT_WRITE_FLASH_WHILE_HOST_FIFO_BUSY = (int)0x38;
	/**
	 * Function Name: GoIO_Init()
<br>
	 * Purpose:	Call GoIO_Init() once before making any other GoIO function calls.
<br>
	 * GoIO_Init() and GoIO_Uninit() should be called from the same thread.
<br>
	 * This routine attempts to grab the mutex that controls access to Vernier
<br>
	 * sensors. If Logger Pro, Logger Lite, or another GoIO application is currently
<br>
	 * running, then this routine will fail to grab the device control mutex, so it
<br>
	 * will return -1. Subsequent calls to GoIO functions will also fail until
<br>
	 * the application is able to run GoIO_Init() successfully.
<br>
	 * Return:		0 iff successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Init()</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:23</i>
	 */
	@Name("GoIO_Init") 
	public static native int goIOInit();
	/**
	 * Function Name: GoIO_Uninit()
<br>
	 * Purpose:	Call GoIO_Uninit() once to 'undo' GoIO_Init().
<br>
	 * GoIO_Init() and GoIO_Uninit() should be called from the same thread.
<br>
	 * Return:		0 iff successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Uninit()</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:32</i>
	 */
	@Name("GoIO_Uninit") 
	public static native int goIOUninit();
	/**
	 * Original signature : <code>gtype_int32 GoIO_Diags_SetDebugTraceThreshold(gtype_int32)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:34</i>
	 */
	@Name("GoIO_Diags_SetDebugTraceThreshold") 
	public static native int goIODiagsSetDebugTraceThreshold(int threshold);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Diags_GetDebugTraceThreshold(gtype_int32*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:36</i>
	 */
	@Name("GoIO_Diags_GetDebugTraceThreshold") 
	public static int goIODiagsGetDebugTraceThreshold(Pointer<Integer > pThreshold) {
		return goIODiagsGetDebugTraceThreshold(Pointer.getPeer(pThreshold));
	}
	@Name("GoIO_Diags_GetDebugTraceThreshold") 
	protected native static int goIODiagsGetDebugTraceThreshold(@Ptr long pThreshold);
	/**
	 * Function Name: GoIO_GetDLLVersion()
<br>
	 * Added in version 2.00.
<br>
	 * Purpose:	This routine returns the major and minor version numbers for the instance of GoIO_DLL that is
<br>
	 * currently running.
<br>
	 * If a function is not guaranteed to be present in all supported versions of GoIO_DLL, then the line
<br>
	 * "Added in version 'major.minor'" will appear in the function description in this file.
<br>
	 * It is our intention that all versions of GoIO_DLL created subsequent to a given version, will be
<br>
	 * backwards compatible with the older version. You should be able to replace an old version of GoIO_DLL
<br>
	 * with a newer version and everything should still work without rebuilding your application.
<br>
	 * Note that version major2.minor2 is later than version major1.minor1 
<br>
	 * iff. ((major2 > major1) || ((major2 == major1) && (minor2 > minor1))).
<br>
	 * Backwards compatibility is definitely our intention, but we do not absolutely guarantee it. If you think
<br>
	 * that you have detected a backwards compatibility bug, then please report it to Vernier Software & Technology.
<br>
	 * Calling GoIO_GetVersion() from your application is a way to identify precisely which version of
<br>
	 * GoIO_DLL you are actually using.
<br>
	 * Return:		0 iff successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_GetDLLVersion(gtype_uint16*, gtype_uint16*)</code><br>
	 * @param pMajorVersion [o]<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:58</i>
	 */
	@Name("GoIO_GetDLLVersion") 
	public static int goIOGetDLLVersion(Pointer<Short > pMajorVersion, Pointer<Short > pMinorVersion) {
		return goIOGetDLLVersion(Pointer.getPeer(pMajorVersion), Pointer.getPeer(pMinorVersion));
	}
	@Name("GoIO_GetDLLVersion") 
	protected native static int goIOGetDLLVersion(@Ptr long pMajorVersion, @Ptr long pMinorVersion);
	/**
	 * Function Name: GoIO_UpdateListOfAvailableDevices()
<br>
	 * Purpose:	This routine queries the operating system to build a list of available devices
<br>
	 * that have the specified USB vendor id and product id. Only Go! Link, Go! Temp, Go! Motion, and Vernier Mini GC
<br>
	 * vendor and product id's are supported.
<br>
	 * Return:		number of devices found.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_UpdateListOfAvailableDevices(gtype_int32, gtype_int32)</code><br>
	 * @param vendorId [in]<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:69</i>
	 */
	@Name("GoIO_UpdateListOfAvailableDevices") 
	public static native int goIOUpdateListOfAvailableDevices(int vendorId, int productId);
	/**
	 * Function Name: GoIO_GetNthAvailableDeviceName()
<br>
	 * Purpose:	Get a unique device name string for the n'th device in the list of known devices with a specified
<br>
	 * USB vendor id and product id. This routine will only succeed if GoIO_UpdateListOfAvailableDevices()
<br>
	 * has been called previously.
<br>
	 * Return:		0 iff successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_GetNthAvailableDeviceName(char*, gtype_int32, gtype_int32, gtype_int32, gtype_int32)</code><br>
	 * @param pBuf [out] ptr to buffer to store device name string.<br>
	 * @param bufSize [in] number of bytes in buffer pointed to by pBuf. Strlen(pBuf) < bufSize, because the string is NULL terminated.<br>
	 * @param vendorId [in] USB vendor id<br>
	 * @param productId [in] USB product id<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:83</i>
	 */
	@Name("GoIO_GetNthAvailableDeviceName") 
	public static int goIOGetNthAvailableDeviceName(Pointer<Byte > pBuf, int bufSize, int vendorId, int productId, int N) {
		return goIOGetNthAvailableDeviceName(Pointer.getPeer(pBuf), bufSize, vendorId, productId, N);
	}
	@Name("GoIO_GetNthAvailableDeviceName") 
	protected native static int goIOGetNthAvailableDeviceName(@Ptr long pBuf, int bufSize, int vendorId, int productId, int N);
	/**
	 * Function Name: GoIO_Sensor_Open()
<br>
	 * Purpose:	Open a specified Go! device and the attached sensor.. 
<br>
	 * If the device is already open, then this routine will fail.
<br>
	 * In addition to establishing basic communication with the device, this routine will initialize the
<br>
	 * device. Each GOIO_SENSOR_HANDLE sensor object has an associated DDS memory record. If the physical 
<br>
	 * sensor being opened is a 'smart' sensor with its own physical DDS memory, then this routine will copy
<br>
	 * the contents of the memory on the device to the sensor object's DDS memory record. If the physical 
<br>
	 * sensor does not have DDS memory, then the associated DDS memory record is set to default values.
<br>
	 * The following commands are sent to Go! Temp devices:
<br>
	 * SKIP_CMD_ID_INIT,
<br>
	 * SKIP_CMD_ID_READ_LOCAL_NV_MEM. - read DDS record
<br>
	 * The following commands are sent to Go! Link and Vernier Mini GC devices:
<br>
	 * SKIP_CMD_ID_INIT,
<br>
	 * SKIP_CMD_ID_GET_SENSOR_ID,
<br>
	 * SKIP_CMD_ID_READ_REMOTE_NV_MEM, - read DDS record if this is a 'smart' sensor
<br>
	 * SKIP_CMD_ID_SET_ANALOG_INPUT_CHANNEL. - based on sensor EProbeType
<br>
	 * SKIP_CMD_ID_GET_SENSOR_ID is superfluous when sent to the Mini GC, but the Mini GC is implemented internally
<br>
	 * as a Go! Link with a fixed sensor plugged in.
<br>
	 * Only SKIP_CMD_ID_INIT is sent to Go! Motion. Go! Motion does not contain DDS memory, but this routine
<br>
	 * initializes the sensor's associated DDS memory record with calibrations for both meters and feet.
<br>
	 * Since the device stops sending measurements in response to SKIP_CMD_ID_INIT, an application must send
<br>
	 * SKIP_CMD_ID_START_MEASUREMENTS to the device in order to receive measurements.
<br>
	 * At any given time, a sensor is 'owned' by only one thread. The thread that calls this routine is the
<br>
	 * initial owner of the sensor. If a GoIO() call is made from a thread that does not own the sensor object
<br>
	 * that is passed in, then the call will generally fail. To allow another thread to access a sensor,
<br>
	 * the owning thread should call GoIO_Sensor_Unlock(), and then the new thread must call GoIO_Sensor_Lock().
<br>
	 * Return:		handle to open sensor device if successful, else NULL.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>GOIO_SENSOR_HANDLE GoIO_Sensor_Open(const char*, gtype_int32, gtype_int32, gtype_int32)</code><br>
	 * @param pDeviceName [in] NULL terminated string that uniquely identifies the device. See GoIO_GetNthAvailableDeviceName().<br>
	 * @param vendorId [in] USB vendor id<br>
	 * @param productId [in] USB product id<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:118</i>
	 */
	@Name("GoIO_Sensor_Open") 
	public static Pointer<? > goIOSensorOpen(Pointer<Byte > pDeviceName, int vendorId, int productId, int strictDDSValidationFlag) {
		return Pointer.pointerToAddress(goIOSensorOpen(Pointer.getPeer(pDeviceName), vendorId, productId, strictDDSValidationFlag));
	}
	@Name("GoIO_Sensor_Open") 
	@Ptr 
	protected native static long goIOSensorOpen(@Ptr long pDeviceName, int vendorId, int productId, int strictDDSValidationFlag);
	/**
	 * Function Name: GoIO_Sensor_Close()
<br>
	 * Purpose:	Close a specified sensor. After this routine runs the hSensor handle is no longer valid.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_Close(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:126</i>
	 */
	@Name("GoIO_Sensor_Close") 
	public static int goIOSensorClose(Pointer<? > hSensor) {
		return goIOSensorClose(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_Close") 
	protected native static int goIOSensorClose(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_GetOpenDeviceName()
<br>
	 * Purpose:	Get the unique device name string and USB id's for a specified open device.
<br>
	 * Return:		0 iff successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_GetOpenDeviceName(GOIO_SENSOR_HANDLE, char*, gtype_int32, gtype_int32*, gtype_int32*)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pBuf [out] ptr to buffer to store device name string.<br>
	 * @param bufSize [in] number of bytes in buffer pointed to by pBuf. Strlen(pBuf) < bufSize, because the string is NULL terminated.<br>
	 * @param pVendorId [out]<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:138</i>
	 */
	@Name("GoIO_Sensor_GetOpenDeviceName") 
	public static int goIOSensorGetOpenDeviceName(Pointer<? > hSensor, Pointer<Byte > pBuf, int bufSize, Pointer<Integer > pVendorId, Pointer<Integer > pProductId) {
		return goIOSensorGetOpenDeviceName(Pointer.getPeer(hSensor), Pointer.getPeer(pBuf), bufSize, Pointer.getPeer(pVendorId), Pointer.getPeer(pProductId));
	}
	@Name("GoIO_Sensor_GetOpenDeviceName") 
	protected native static int goIOSensorGetOpenDeviceName(@Ptr long hSensor, @Ptr long pBuf, int bufSize, @Ptr long pVendorId, @Ptr long pProductId);
	/**
	 * Function Name: GoIO_Sensor_Lock()
<br>
	 * Purpose:	Lock a specified sensor so that no other thread can access it. This routine will fail if the sensor
<br>
	 * is currently locked by another thread.
<br>
	 * GoIO_Sensor_Lock() increments the lock count for the specified sensor by 1. In order for a second
<br>
	 * thread to acquire access to the sensor, the first thread must call GoIO_Sensor_Unlock() until the lock
<br>
	 * count reaches 0. Note that the lock count is set to 1 by GoIO_Sensor_Open().
<br>
	 * It is ok for the lock count to be greater than 1 when GoIO_Sensor_Close() is called.
<br>
	 * This is an advanced routine that most users should not use. It is only necessary if an application
<br>
	 * needs to access a single sensor from multiple threads.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_Lock(GOIO_SENSOR_HANDLE, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:154</i>
	 */
	@Name("GoIO_Sensor_Lock") 
	public static int goIOSensorLock(Pointer<? > hSensor, int timeoutMs) {
		return goIOSensorLock(Pointer.getPeer(hSensor), timeoutMs);
	}
	@Name("GoIO_Sensor_Lock") 
	protected native static int goIOSensorLock(@Ptr long hSensor, int timeoutMs);
	/**
	 * Function Name: GoIO_Sensor_Unlock()
<br>
	 * Purpose:	Decrement the lock count for the specified sensor by 1. This routine will fail if the sensor
<br>
	 * is not currently locked by the calling thread.
<br>
	 * In order for a second thread to acquire access to the sensor, the first thread must call 
<br>
	 * GoIO_Sensor_Unlock() until the lock count reaches 0. Note that the lock count is set to 1 by 
<br>
	 * GoIO_Sensor_Open().
<br>
	 * If the lock count reaches zero, it is important to make a call to GoIO_Sensor_Lock() to lock the
<br>
	 * device. This will prevent multiple threads from simultaneously accessing the device, which can cause
<br>
	 * unpredictable results.
<br>
	 * It is ok for the lock count to be greater than 1 when GoIO_Sensor_Close() is called.
<br>
	 * This is an advanced routine that most users should not use. It is only necessary if an application
<br>
	 * needs to access a single sensor from multiple threads.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_Unlock(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:172</i>
	 */
	@Name("GoIO_Sensor_Unlock") 
	public static int goIOSensorUnlock(Pointer<? > hSensor) {
		return goIOSensorUnlock(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_Unlock") 
	protected native static int goIOSensorUnlock(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_ClearIO()
<br>
	 * Purpose:	Clear the input/output communication buffers for a specified sensor. 
<br>
	 * This also expties the GoIO Measurement Buffer, which holds measurements that have been retrieved from 
<br>
	 * the sensor.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_ClearIO(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:182</i>
	 */
	@Name("GoIO_Sensor_ClearIO") 
	public static int goIOSensorClearIO(Pointer<? > hSensor) {
		return goIOSensorClearIO(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_ClearIO") 
	protected native static int goIOSensorClearIO(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_SendCmdAndGetResponse()
<br>
	 * Purpose:	Send a command to the specified Go! device hardware and wait for a response. 
<br>
	 * Note that GoIO_Sensor_SendCmdAndGetResponse() will ASSERT if you send a SKIP_CMD_ID_START_MEASUREMENTS
<br>
	 * while GoIO_Sensor_GetNumMeasurementsAvailable() says measurements are available. 
<br>
	 * This will not occur the first time SKIP_CMD_ID_START_MEASUREMENTS is sent after GoIO_Sensor_Open()
<br>
	 * because GoIO_Sensor_Open() automatically calls GoIO_Sensor_ClearIO().
<br>
	 * So...if you are restarting measurements, you should clear any old measurements in the GoIO Measurement 
<br>
	 * Buffer first by reading in the measurements until the Buffer is empty, or you should call 
<br>
	 * GoIO_Sensor_ClearIO().
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_SendCmdAndGetResponse(GOIO_SENSOR_HANDLE, unsigned char, void*, gtype_int32, void*, gtype_int32*, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param cmd [in] command code. See SKIP_CMD_ID_* in GSkipCommExt.h.<br>
	 * @param pParams [in] ptr to cmd specific parameter block, may be NULL. See GSkipCommExt.h.<br>
	 * @param nParamBytes [in] # of bytes in (*pParams).<br>
	 * @param pRespBuf [out] ptr to destination buffer, may be NULL. See GSkipCommExt.h.<br>
	 * @param pnRespBytes [in, out] ptr to size of of pRespBuf buffer on input, size of response on output, may be NULL if pRespBuf is NULL.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:203</i>
	 */
	@Name("GoIO_Sensor_SendCmdAndGetResponse") 
	public static int goIOSensorSendCmdAndGetResponse(Pointer<? > hSensor, byte cmd, Pointer<? > pParams, int nParamBytes, Pointer<? > pRespBuf, Pointer<Integer > pnRespBytes, int timeoutMs) {
		return goIOSensorSendCmdAndGetResponse(Pointer.getPeer(hSensor), cmd, Pointer.getPeer(pParams), nParamBytes, Pointer.getPeer(pRespBuf), Pointer.getPeer(pnRespBytes), timeoutMs);
	}
	@Name("GoIO_Sensor_SendCmdAndGetResponse") 
	protected native static int goIOSensorSendCmdAndGetResponse(@Ptr long hSensor, byte cmd, @Ptr long pParams, int nParamBytes, @Ptr long pRespBuf, @Ptr long pnRespBytes, int timeoutMs);
	/**
	 * Function Name: GoIO_Sensor_GetLastCmdResponseStatus()
<br>
	 * Purpose:	Get error information for the device. 
<br>
	 * In principle, any command sent to the device can result in an error. 
<br>
	 * If GoIO_Sensor_SendCmdAndGetResponse() ever fails and returns a non-zero return code,
<br>
	 * you can gather additional info about what went wrong by calling GoIO_Sensor_GetLastCmdResponseStatus().
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_GetLastCmdResponseStatus(GOIO_SENSOR_HANDLE, unsigned char*, unsigned char*, unsigned char*, unsigned char*)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pLastCmd [out] last cmd sent to the sensor<br>
	 * @param pLastCmdStatus [out] status of last command sent to the sensor.<br>
	 * @param pLastCmdWithErrorRespSentOvertheWire [out] last cmd sent that caused the device to report back an error.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:218</i>
	 */
	@Name("GoIO_Sensor_GetLastCmdResponseStatus") 
	public static int goIOSensorGetLastCmdResponseStatus(Pointer<? > hSensor, Pointer<Byte > pLastCmd, Pointer<Byte > pLastCmdStatus, Pointer<Byte > pLastCmdWithErrorRespSentOvertheWire, Pointer<Byte > pLastErrorSentOvertheWire) {
		return goIOSensorGetLastCmdResponseStatus(Pointer.getPeer(hSensor), Pointer.getPeer(pLastCmd), Pointer.getPeer(pLastCmdStatus), Pointer.getPeer(pLastCmdWithErrorRespSentOvertheWire), Pointer.getPeer(pLastErrorSentOvertheWire));
	}
	@Name("GoIO_Sensor_GetLastCmdResponseStatus") 
	protected native static int goIOSensorGetLastCmdResponseStatus(@Ptr long hSensor, @Ptr long pLastCmd, @Ptr long pLastCmdStatus, @Ptr long pLastCmdWithErrorRespSentOvertheWire, @Ptr long pLastErrorSentOvertheWire);
	/**
	 * Function Name: GoIO_Sensor_SendCmd()
<br>
	 * Purpose:	GoIO_Sensor_SendCmd() is an advanced function. You should usually use 
<br>
	 * GoIO_Sensor_SendCmdAndGetResponse() instead. After calling GoIO_Sensor_SendCmd(), you must call
<br>
	 * GoIO_Sensor_GetNextResponse() before sending any more commands to the device.
<br>
	 * The main reason that GoIO_Sensor_SendCmd() is made available to the user is to allow a program to send
<br>
	 * SKIP_CMD_ID_START_MEASUREMENTS commands to several different devices as close together as possible so that
<br>
	 * measurements start at about the same time on separate devices.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_SendCmd(GOIO_SENSOR_HANDLE, unsigned char, void*, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param cmd [in] command code<br>
	 * @param pParams [in] ptr to cmd specific parameter block, may be NULL. See GSkipCommExt.h.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:234</i>
	 */
	@Name("GoIO_Sensor_SendCmd") 
	public static int goIOSensorSendCmd(Pointer<? > hSensor, byte cmd, Pointer<? > pParams, int nParamBytes) {
		return goIOSensorSendCmd(Pointer.getPeer(hSensor), cmd, Pointer.getPeer(pParams), nParamBytes);
	}
	@Name("GoIO_Sensor_SendCmd") 
	protected native static int goIOSensorSendCmd(@Ptr long hSensor, byte cmd, @Ptr long pParams, int nParamBytes);
	/**
	 * Function Name: GoIO_Sensor_GetNextResponse()
<br>
	 * Purpose:	GoIO_Sensor_GetNextResponse() is an advanced function. You should usually use 
<br>
	 * GoIO_Sensor_SendCmdAndGetResponse() instead. After calling GoIO_Sensor_SendCmd(), you must call
<br>
	 * GoIO_Sensor_GetNextResponse() before sending any more commands to the device.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_GetNextResponse(GOIO_SENSOR_HANDLE, void*, gtype_int32*, unsigned char*, gtype_int32*, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pRespBuf [out] ptr to destination buffer, may be NULL. See GSkipCommExt.h.<br>
	 * @param pnRespBytes [in, out] ptr to size of of pRespBuf buffer on input, size of response on output, may be NULL if pRespBuf is NULL.<br>
	 * @param pCmd [out] identifies which command this response is for. Ptr must NOT be NULL!<br>
	 * @param pErrRespFlag [out] flag(1 or 0) indicating that the response contains error info. Ptr must NOT be NULL!<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:249</i>
	 */
	@Name("GoIO_Sensor_GetNextResponse") 
	public static int goIOSensorGetNextResponse(Pointer<? > hSensor, Pointer<? > pRespBuf, Pointer<Integer > pnRespBytes, Pointer<Byte > pCmd, Pointer<Integer > pErrRespFlag, int nTimeoutMs) {
		return goIOSensorGetNextResponse(Pointer.getPeer(hSensor), Pointer.getPeer(pRespBuf), Pointer.getPeer(pnRespBytes), Pointer.getPeer(pCmd), Pointer.getPeer(pErrRespFlag), nTimeoutMs);
	}
	@Name("GoIO_Sensor_GetNextResponse") 
	protected native static int goIOSensorGetNextResponse(@Ptr long hSensor, @Ptr long pRespBuf, @Ptr long pnRespBytes, @Ptr long pCmd, @Ptr long pErrRespFlag, int nTimeoutMs);
	/**
	 * Function Name: GoIO_Sensor_GetMeasurementTickInSeconds()
<br>
	 * Purpose:	The measurement period for Go! devices is specified in discrete 'ticks', so the actual time between 
<br>
	 * measurements is an integer multiple of the tick time. The length of time between ticks is different 
<br>
	 * for Go! Link versus Go! Temp. 
<br>
	 * Return:		If hSensor is not valid, then this routine returns -1.0, else the return value = the length of time
<br>
	 * in seconds between ticks.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_real64 GoIO_Sensor_GetMeasurementTickInSeconds(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:260</i>
	 */
	@Name("GoIO_Sensor_GetMeasurementTickInSeconds") 
	public static double goIOSensorGetMeasurementTickInSeconds(Pointer<? > hSensor) {
		return goIOSensorGetMeasurementTickInSeconds(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_GetMeasurementTickInSeconds") 
	protected native static double goIOSensorGetMeasurementTickInSeconds(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_GetMinimumMeasurementPeriod()
<br>
	 * Return:		If hSensor is not valid, then this routine returns -1.0, else the return value = minimum measurement
<br>
	 * period in seconds that is supported by the device.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_real64 GoIO_Sensor_GetMinimumMeasurementPeriod(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:268</i>
	 */
	@Name("GoIO_Sensor_GetMinimumMeasurementPeriod") 
	public static double goIOSensorGetMinimumMeasurementPeriod(Pointer<? > hSensor) {
		return goIOSensorGetMinimumMeasurementPeriod(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_GetMinimumMeasurementPeriod") 
	protected native static double goIOSensorGetMinimumMeasurementPeriod(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_GetMaximumMeasurementPeriod()
<br>
	 * Return:		If hSensor is not valid, then this routine returns -1.0, else the return value = maximum measurement
<br>
	 * period in seconds that is supported by the device.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_real64 GoIO_Sensor_GetMaximumMeasurementPeriod(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:276</i>
	 */
	@Name("GoIO_Sensor_GetMaximumMeasurementPeriod") 
	public static double goIOSensorGetMaximumMeasurementPeriod(Pointer<? > hSensor) {
		return goIOSensorGetMaximumMeasurementPeriod(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_GetMaximumMeasurementPeriod") 
	protected native static double goIOSensorGetMaximumMeasurementPeriod(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_SetMeasurementPeriod()
<br>
	 * Purpose:	Set the measurement period to a specified number of seconds. The Go! sensor will report measurements
<br>
	 * to the computer at the measurement period interval once measurements have been started. These 
<br>
	 * measurements are held in the GoIO Measurement Buffer. 
<br>
	 * See documentation for GoIO_Sensor_GetNumMeasurementsAvailable().
<br>
	 * This routine sends SKIP_CMD_ID_SET_MEASUREMENT_PERIOD to the sensor with the parameter block configured 
<br>
	 * for the desiredPeriod.
<br>
	 * Because the measurement period is constrained to be a multiple of the tick returned by
<br>
	 * GoIO_Sensor_GetMeasurementTickInSeconds(), and because it must be 
<br>
	 * >= GoIO_Sensor_GetMinimumMeasurementPeriod(), and
<br>
	 * <= GoIO_Sensor_GetMaximumMeasurementPeriod(), 
<br>
	 * the actual period is different than the desiredPeriod.
<br>
	 * You can determine the actual period by calling GoIO_Sensor_GetMeasurementPeriod().
<br>
	 * This routine will fail if we are currently collecting measurements from the sensor. Note that collection
<br>
	 * is started by sending SKIP_CMD_ID_START_MEASUREMENTS to the sensor, and stopped by sending 
<br>
	 * SKIP_CMD_ID_STOP_MEASUREMENTS.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_SetMeasurementPeriod(GOIO_SENSOR_HANDLE, gtype_real64, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param desiredPeriod [in] desired measurement period in seconds.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:300</i>
	 */
	@Name("GoIO_Sensor_SetMeasurementPeriod") 
	public static int goIOSensorSetMeasurementPeriod(Pointer<? > hSensor, double desiredPeriod, int timeoutMs) {
		return goIOSensorSetMeasurementPeriod(Pointer.getPeer(hSensor), desiredPeriod, timeoutMs);
	}
	@Name("GoIO_Sensor_SetMeasurementPeriod") 
	protected native static int goIOSensorSetMeasurementPeriod(@Ptr long hSensor, double desiredPeriod, int timeoutMs);
	/**
	 * Function Name: GoIO_Sensor_GetMeasurementPeriod()
<br>
	 * Purpose:	This routine sends SKIP_CMD_ID_GET_MEASUREMENT_PERIOD to the sensor.
<br>
	 * Return:		1000000.0 if not successful, else the measurement period in seconds.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_real64 GoIO_Sensor_GetMeasurementPeriod(GOIO_SENSOR_HANDLE, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:309</i>
	 */
	@Name("GoIO_Sensor_GetMeasurementPeriod") 
	public static double goIOSensorGetMeasurementPeriod(Pointer<? > hSensor, int timeoutMs) {
		return goIOSensorGetMeasurementPeriod(Pointer.getPeer(hSensor), timeoutMs);
	}
	@Name("GoIO_Sensor_GetMeasurementPeriod") 
	protected native static double goIOSensorGetMeasurementPeriod(@Ptr long hSensor, int timeoutMs);
	/**
	 * Function Name: GoIO_Sensor_GetNumMeasurementsAvailable()
<br>
	 * Purpose:	Report the number of measurements currently stored in the GoIO Measurement Buffer. 
<br>
	 * After SKIP_CMD_ID_START_MEASUREMENTS has been sent to the sensor, the sensor starts
<br>
	 * sending measurements to the host computer. These measurements are stored in the 
<br>
	 * GoIO Measurement Buffer. A separate GoIO Measurement Buffer is maintained for each
<br>
	 * open sensor.
<br>
	 * The delay between sending SKIP_CMD_ID_START_MEASUREMENTS and the appearance of the first
<br>
	 * measurement in the GoIO Measurement Buffer varies according to the type of Go! device.
<br>
	 * Go! device type	                Delay before first measurement
<br>
	 * -----------------               --------------------------------
<br>
	 * Go! Temp                        ~510 milliseconds
<br>
	 * Go! Link                        ~10 milliseconds
<br>
	 * Mini GC                         ~10 milliseconds
<br>
	 * Go! Motion                      ~ measurement period + 10 milliseconds
<br>
	 * The 10 millisecond delay specifed for Go! Link is just the approximate delay required for the
<br>
	 * data to come back from the device via USB. Go! Link actually performs the first measurement
<br>
	 * immediately.
<br>
	 * Subsequent measurements are sent at the currently configured measurement period interval. 
<br>
	 * See GoIO_Sensor_SetMeasurementPeriod().
<br>
	 * Call GoIO_Sensor_ReadRawMeasurements() to retrieve measurements from the
<br>
	 * GoIO Measurement Buffer. The GoIO Measurement Buffer is guaranteed to hold at least 1200
<br>
	 * measurements. The buffer is circular, so if you do not service it often enough, the
<br>
	 * oldest measurements in the buffer are lost. If you wish to capture all the 
<br>
	 * measurements coming from the sensor, you must call GoIO_Sensor_ReadRawMeasurements()
<br>
	 * often enough so that the GoIO_Sensor_GetNumMeasurementsAvailable() does not reach 1200.
<br>
	 * On the other hand, we reserve the right to make the Measurement Buffer > 1200 measurements, so
<br>
	 * do not assume that you can empty the buffer simply by reading in 1200 measurements.
<br>
	 * Each of the following actions clears the GoIO Measurement Buffer:
<br>
	 * 1) Call GoIO_Sensor_ReadRawMeasurements() with count set to GoIO_Sensor_GetNumMeasurementsAvailable(), or
<br>
	 * 2) Call GoIO_Sensor_GetLatestRawMeasurement(), or
<br>
	 * 3) Call GoIO_Sensor_ClearIO().
<br>
	 * The GoIO Measurement Buffer is empty after GoIO_Sensor_Open() is called. It does not
<br>
	 * start filling up until SKIP_CMD_ID_START_MEASUREMENTS is sent to the sensor.
<br>
	 * Note that the sensor stops sending measurements to the host computer after
<br>
	 * SKIP_CMD_ID_STOP_MEASUREMENTS or SKIP_CMD_ID_INIT is sent, but sending these commands
<br>
	 * does not clear the GoIO Measurement Buffer.
<br>
	 * Return:		number of measurements currently stored in the GoIO Measurement Buffer. 
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_GetNumMeasurementsAvailable(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:351</i>
	 */
	@Name("GoIO_Sensor_GetNumMeasurementsAvailable") 
	public static int goIOSensorGetNumMeasurementsAvailable(Pointer<? > hSensor) {
		return goIOSensorGetNumMeasurementsAvailable(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_GetNumMeasurementsAvailable") 
	protected native static int goIOSensorGetNumMeasurementsAvailable(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_ReadRawMeasurements()
<br>
	 * Purpose:	Retrieve measurements from the GoIO Measurement Buffer. The measurements reported
<br>
	 * by this routine are actually removed from the GoIO Measurement Buffer.
<br>
	 * After SKIP_CMD_ID_START_MEASUREMENTS has been sent to the sensor, the sensor starts
<br>
	 * sending measurements to the host computer. These measurements are stored in the 
<br>
	 * GoIO Measurement Buffer. A separate GoIO Measurement Buffer is maintained for each
<br>
	 * open sensor. See the description of GoIO_Sensor_GetNumMeasurementsAvailable().
<br>
	 * Note that for Go! Temp and Go! Link, raw measurements range from -32768 to 32767.
<br>
	 * Go! Motion raw measurements are in microns and can range into the millions.
<br>
	 * To convert a raw measurement to a voltage use GoIO_Sensor_ConvertToVoltage().
<br>
	 * To convert a voltage to a sensor specific calibrated unit, use GoIO_Sensor_CalibrateData().
<br>
	 * WARNING!!! IF YOU ARE COLLECTING MORE THAN 50 MEASUREMENTS A SECOND FROM GO! LINK,
<br>
	 * READ THIS: The GoIO Measurement Buffer is packet oriented. If you are collecting 50 or
<br>
	 * less measurements per second, then each packet contains only 1 measurement, and there is
<br>
	 * no problem.
<br>
	 * If you are collecting more than 50 measurements a second, then each packet may contain 2 
<br>
	 * or 3 measurements. Depending on the exact measurement period, all the packets will 
<br>
	 * contain 2, or all the packets will contain 3 measurements. IF THE LAST MEASUREMENT COPIED
<br>
	 * INTO pMeasurementsBuf IS NOT THE LAST MEASUREMENT IN ITS PACKET, THEN MEASUREMENTS MAY
<br>
	 * BE LOST.
<br>
	 * There are a couple of safe workarounds to this problem:
<br>
	 * 1) Always set the maxCount parameter to a multiple of 6, or
<br>
	 * 2) Always set the maxCount parameter to GoIO_Sensor_GetNumMeasurementsAvailable().
<br>
	 * Return:		number of measurements retrieved from the GoIO Measurement Buffer. This routine
<br>
	 * returns immediately, so the return value may be less than maxCount.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_ReadRawMeasurements(GOIO_SENSOR_HANDLE, gtype_int32*, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pMeasurementsBuf [out] ptr to loc to store measurements.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:383</i>
	 */
	@Name("GoIO_Sensor_ReadRawMeasurements") 
	public static int goIOSensorReadRawMeasurements(Pointer<? > hSensor, Pointer<Integer > pMeasurementsBuf, int maxCount) {
		return goIOSensorReadRawMeasurements(Pointer.getPeer(hSensor), Pointer.getPeer(pMeasurementsBuf), maxCount);
	}
	@Name("GoIO_Sensor_ReadRawMeasurements") 
	protected native static int goIOSensorReadRawMeasurements(@Ptr long hSensor, @Ptr long pMeasurementsBuf, int maxCount);
	/**
	 * Function Name: GoIO_Sensor_GetLatestRawMeasurement()
<br>
	 * Purpose:	Report the most recent measurement put in the GoIO Measurement Buffer. If no 
<br>
	 * measurements have been placed in the GoIO Measurement Buffer since it was
<br>
	 * created byGoIO_Sensor_Open(), then report a value of 0. 
<br>
	 * This routine also empties the GoIO Measurement Buffer, so GoIO_Sensor_GetNumMeasurementsAvailable()
<br>
	 * will report 0 after calling GoIO_Sensor_GetLatestRawMeasurement().
<br>
	 * After SKIP_CMD_ID_START_MEASUREMENTS has been sent to the sensor, the sensor starts
<br>
	 * sending measurements to the host computer. These measurements are stored in the 
<br>
	 * GoIO Measurement Buffer. A separate GoIO Measurement Buffer is maintained for each
<br>
	 * open sensor. See the description of GoIO_Sensor_GetNumMeasurementsAvailable().
<br>
	 * Note that for Go! Temp and Go! Link, raw measurements range from -32768 to 32767.
<br>
	 * Go! Motion raw measurements are in microns and can range into the millions.
<br>
	 * To convert a raw measurement to a voltage use GoIO_Sensor_ConvertToVoltage().
<br>
	 * To convert a voltage to a sensor specific calibrated unit, use GoIO_Sensor_CalibrateData().
<br>
	 * Return:		most recent measurement put in the GoIO Measurement Buffer. If no 
<br>
	 * measurements have been placed in the GoIO Measurement Buffer since it was
<br>
	 * created byGoIO_Sensor_Open(), then report a value of 0.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_GetLatestRawMeasurement(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:405</i>
	 */
	@Name("GoIO_Sensor_GetLatestRawMeasurement") 
	public static int goIOSensorGetLatestRawMeasurement(Pointer<? > hSensor) {
		return goIOSensorGetLatestRawMeasurement(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_GetLatestRawMeasurement") 
	protected native static int goIOSensorGetLatestRawMeasurement(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_ConvertToVoltage()
<br>
	 * Purpose:	Convert a raw measurement integer value into a real voltage value.
<br>
	 * Depending on the type of sensor(see GoIO_Sensor_GetProbeType()), the voltage
<br>
	 * may range from 0.0 to 5.0, or from -10.0 to 10.0 . For Go! Motion, voltage returned is simply distance
<br>
	 * in meters.
<br>
	 * Return:		voltage corresponding to a specified raw measurement value.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_real64 GoIO_Sensor_ConvertToVoltage(GOIO_SENSOR_HANDLE, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:417</i>
	 */
	@Name("GoIO_Sensor_ConvertToVoltage") 
	public static double goIOSensorConvertToVoltage(Pointer<? > hSensor, int rawMeasurement) {
		return goIOSensorConvertToVoltage(Pointer.getPeer(hSensor), rawMeasurement);
	}
	@Name("GoIO_Sensor_ConvertToVoltage") 
	protected native static double goIOSensorConvertToVoltage(@Ptr long hSensor, int rawMeasurement);
	/**
	 * Function Name: GoIO_Sensor_CalibrateData()
<br>
	 * Purpose:	Convert a voltage value into a sensor specific unit.
<br>
	 * What units this routine produces can be determined by calling
<br>
	 * GoIO_Sensor_DDSMem_GetCalPage(hSensor, GoIO_Sensor_DDSMem_GetActiveCalPage(),...) .
<br>
	 * Return:		value in sensor specific units corresponding to a specified voltage.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_real64 GoIO_Sensor_CalibrateData(GOIO_SENSOR_HANDLE, gtype_real64)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:428</i>
	 */
	@Name("GoIO_Sensor_CalibrateData") 
	public static double goIOSensorCalibrateData(Pointer<? > hSensor, double volts) {
		return goIOSensorCalibrateData(Pointer.getPeer(hSensor), volts);
	}
	@Name("GoIO_Sensor_CalibrateData") 
	protected native static double goIOSensorCalibrateData(@Ptr long hSensor, double volts);
	/**
	 * Function Name: GoIO_Sensor_GetProbeType()
<br>
	 * Purpose:	Find out the probe type. See EProbeType in GSensorDDSMem.h.
<br>
	 * For Go! Link devices, this attribute is dependent on the OperationType in the SensorDDSRecord. 
<br>
	 * See GoIO_Sensor_DDSMem_GetOperationType().
<br>
	 * If (2 == OperationType) then the sensor is kProbeTypeAnalog10V, else kProbeTypeAnalog5V.
<br>
	 * Note that for Go! Link devices, SKIP_CMD_ID_SET_ANALOG_INPUT_CHANNEL must be sent to the device with
<br>
	 * the analogInputChannel parameter set to SKIP_ANALOG_INPUT_CHANNEL_VIN_LOW for kProbeTypeAnalog5V,
<br>
	 * or set to SKIP_ANALOG_INPUT_CHANNEL_VIN for kProbeTypeAnalog10V devices. Generally, application
<br>
	 * programs do not have to deal with this, because GoIO_Sensor_Open() automatically sends
<br>
	 * SKIP_CMD_ID_SET_ANALOG_INPUT_CHANNEL to the device with the appropriate parameters.
<br>
	 * Go! Temp => kProbeTypeAnalog5V.
<br>
	 * Go! Motion => kProbeTypeMD.
<br>
	 * Return:		EProbeType.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_GetProbeType(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:446</i>
	 */
	@Name("GoIO_Sensor_GetProbeType") 
	public static int goIOSensorGetProbeType(Pointer<? > hSensor) {
		return goIOSensorGetProbeType(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_GetProbeType") 
	protected native static int goIOSensorGetProbeType(@Ptr long hSensor);
	/**
	 * Function Name: GoIO_Sensor_DDSMem_WriteRecord()
<br>
	 * Purpose:	Write the SensorDDSRecord into a smart sensor's DDS memory hardware. 
<br>
	 * Before the record is written to the sensor, SensorDDSRecord.Checksum is recalculated.
<br>
	 * Before the record is written to the sensor, a copy of the record is marshalled into little endian format,
<br>
	 * and then this copy is actually written to the sensor.
<br>
	 * This routine sends SKIP_CMD_ID_WRITE_LOCAL_NV_MEM_*(Go! Temp) or SKIP_CMD_ID_WRITE_REMOTE_NV_MEM_*(Go! Link)
<br>
	 * commands to the device. To alter DDS memory on the sensor, we recommend using 
<br>
	 * GoIO_Sensor_DDSMem_WriteRecord rather than the low level SKIP_CMD_ID_WRITE commands.
<br>
	 * WARNING: Be careful about using this routine. Changing a smart sensor's DDS memory can cause the sensor
<br>
	 * to stop working with Logger Pro.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_WriteRecord(GOIO_SENSOR_HANDLE, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:463</i>
	 */
	@Name("GoIO_Sensor_DDSMem_WriteRecord") 
	public static int goIOSensorDDSMemWriteRecord(Pointer<? > hSensor, int timeoutMs) {
		return goIOSensorDDSMemWriteRecord(Pointer.getPeer(hSensor), timeoutMs);
	}
	@Name("GoIO_Sensor_DDSMem_WriteRecord") 
	protected native static int goIOSensorDDSMemWriteRecord(@Ptr long hSensor, int timeoutMs);
	/**
	 * Function Name: GoIO_Sensor_DDSMem_ReadRecord()
<br>
	 * Purpose:	Read the SensorDDSRecord from a smart sensor's DDS memory hardware. 
<br>
	 * After the record is read from the sensor, it is unmarshalled from little endian format into processor
<br>
	 * specific format.
<br>
	 * This routine sends SKIP_CMD_ID_READ_LOCAL_NV_MEM(Go! Temp) or SKIP_CMD_ID_READ_REMOTE_NV_MEM(Go! Link)
<br>
	 * commands to the device. GoIO_Sensor_Open() automatically calls this routine, so you usually do not
<br>
	 * need to.
<br>
	 * Return:		0 if successful, 
<br>
	 * else if data validation fails then -2,
<br>
	 * else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_ReadRecord(GOIO_SENSOR_HANDLE, gtype_int32, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param strictDDSValidationFlag [in] insist on exactly valid checksum if 1, else use a more lax validation test.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:480</i>
	 */
	@Name("GoIO_Sensor_DDSMem_ReadRecord") 
	public static int goIOSensorDDSMemReadRecord(Pointer<? > hSensor, int strictDDSValidationFlag, int timeoutMs) {
		return goIOSensorDDSMemReadRecord(Pointer.getPeer(hSensor), strictDDSValidationFlag, timeoutMs);
	}
	@Name("GoIO_Sensor_DDSMem_ReadRecord") 
	protected native static int goIOSensorDDSMemReadRecord(@Ptr long hSensor, int strictDDSValidationFlag, int timeoutMs);
	/**
	 * Function Name: GoIO_Sensor_DDSMem_SetRecord()
<br>
	 * Purpose:	Update the SensorDDSRecord. 
<br>
	 * This routine does not send data to the sensor's DDS memory hardware - use GoIO_Sensor_DDSMem_WriteRecord for that.
<br>
	 * Return:		0 if hSensor is valid, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetRecord(GOIO_SENSOR_HANDLE, const GSensorDDSRec*)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:490</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetRecord") 
	public static int goIOSensorDDSMemSetRecord(Pointer<? > hSensor, Pointer<tagGSensorDDSRec > pRec) {
		return goIOSensorDDSMemSetRecord(Pointer.getPeer(hSensor), Pointer.getPeer(pRec));
	}
	@Name("GoIO_Sensor_DDSMem_SetRecord") 
	protected native static int goIOSensorDDSMemSetRecord(@Ptr long hSensor, @Ptr long pRec);
	/**
	 * Function Name: GoIO_Sensor_DDSMem_GetRecord()
<br>
	 * Purpose:	Get a copy of the SensorDDSRecord. 
<br>
	 * This routine does not read data from the sensor's DDS memory hardware - use GoIO_Sensor_DDSMem_ReadRecord for that.
<br>
	 * Return:		0 if hSensor is valid, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetRecord(GOIO_SENSOR_HANDLE, GSensorDDSRec*)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:500</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetRecord") 
	public static int goIOSensorDDSMemGetRecord(Pointer<? > hSensor, Pointer<tagGSensorDDSRec > pRec) {
		return goIOSensorDDSMemGetRecord(Pointer.getPeer(hSensor), Pointer.getPeer(pRec));
	}
	@Name("GoIO_Sensor_DDSMem_GetRecord") 
	protected native static int goIOSensorDDSMemGetRecord(@Ptr long hSensor, @Ptr long pRec);
	/**
	 * Function Name: GoIO_Sensor_DDSMem_CalculateChecksum()
<br>
	 * Return:		0 if hSensor is valid, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_CalculateChecksum(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:508</i>
	 */
	@Name("GoIO_Sensor_DDSMem_CalculateChecksum") 
	public static int goIOSensorDDSMemCalculateChecksum(Pointer<? > hSensor, Pointer<Byte > pChecksum) {
		return goIOSensorDDSMemCalculateChecksum(Pointer.getPeer(hSensor), Pointer.getPeer(pChecksum));
	}
	@Name("GoIO_Sensor_DDSMem_CalculateChecksum") 
	protected native static int goIOSensorDDSMemCalculateChecksum(@Ptr long hSensor, @Ptr long pChecksum);
	/**
	 * Function Name: GoIO_Sensor_DDSMem_ClearRecord()
<br>
	 * Purpose:	Clear the DDS record for the specified sensor. This puts default values in the record's fields.
<br>
	 * The sensor name fields are set to blank. The sensor id is set to 0, and a single linear calibration is
<br>
	 * set up with a gain of 1.0 and an offest of 0. The calibration units field is set to "volts".
<br>
	 * The OperationType is set to imply a probe type of kProbeTypeAnalog5V.
<br>
	 * Return:		0 if hSensor is valid, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_ClearRecord(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:519</i>
	 */
	@Name("GoIO_Sensor_DDSMem_ClearRecord") 
	public static int goIOSensorDDSMemClearRecord(Pointer<? > hSensor) {
		return goIOSensorDDSMemClearRecord(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Sensor_DDSMem_ClearRecord") 
	protected native static int goIOSensorDDSMemClearRecord(@Ptr long hSensor);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetMemMapVersion(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:521</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetMemMapVersion") 
	public static int goIOSensorDDSMemSetMemMapVersion(Pointer<? > hSensor, byte MemMapVersion) {
		return goIOSensorDDSMemSetMemMapVersion(Pointer.getPeer(hSensor), MemMapVersion);
	}
	@Name("GoIO_Sensor_DDSMem_SetMemMapVersion") 
	protected native static int goIOSensorDDSMemSetMemMapVersion(@Ptr long hSensor, byte MemMapVersion);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetMemMapVersion(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:523</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetMemMapVersion") 
	public static int goIOSensorDDSMemGetMemMapVersion(Pointer<? > hSensor, Pointer<Byte > pMemMapVersion) {
		return goIOSensorDDSMemGetMemMapVersion(Pointer.getPeer(hSensor), Pointer.getPeer(pMemMapVersion));
	}
	@Name("GoIO_Sensor_DDSMem_GetMemMapVersion") 
	protected native static int goIOSensorDDSMemGetMemMapVersion(@Ptr long hSensor, @Ptr long pMemMapVersion);
	/**
	 * Function Name: GoIO_Sensor_DDSMem_SetSensorNumber()
<br>
	 * Purpose:	Normally SensorDDSRecord.SensorNumber is automatically set inside GoIO_Sensor_Open().
<br>
	 * However, if the current sensor is a legacy version, then SensorDDSRecord.SensorNumber = 0, so
<br>
	 * you might want to use GoIO_Sensor_DDSMem_SetSensorNumber() to change it.
<br>
	 * SIDE EFFECTS:	
<br>
	 * If the new SensorDDSRecord.SensorNumber is set to an (id < kSensorIdNumber_FirstSmartSensor) and (id > 0),
<br>
	 * then the rest of the fields in the DDS record are  populated with default values appropriate for the
<br>
	 * new sensor id.
<br>
	 * If the GoIO_Sensor_DDSMem_SetSensorNumber() causes the probeType to change, then you should
<br>
	 * send a SKIP_CMD_ID_SET_ANALOG_INPUT_CHANNEL command to the sensor. See GoIO_Sensor_GetProbeType().
<br>
	 * Return:		0 if hSensor is valid and sensor is connected to a Go! Link, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetSensorNumber(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:540</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetSensorNumber") 
	public static int goIOSensorDDSMemSetSensorNumber(Pointer<? > hSensor, byte SensorNumber) {
		return goIOSensorDDSMemSetSensorNumber(Pointer.getPeer(hSensor), SensorNumber);
	}
	@Name("GoIO_Sensor_DDSMem_SetSensorNumber") 
	protected native static int goIOSensorDDSMemSetSensorNumber(@Ptr long hSensor, byte SensorNumber);
	/**
	 * Function Name: GoIO_Sensor_DDSMem_GetSensorNumber()
<br>
	 * Purpose:	Retrieve SensorDDSRecord.SensorNumber. 
<br>
	 * If sendQueryToHardwareflag != 0, then send a SKIP_CMD_ID_GET_SENSOR_ID to the sensor hardware, and then call
<br>
	 * GoIO_Sensor_DDSMem_SetSensorNumber(new sensor id).
<br>
	 * SendQueryToHardwareflag is ignored for Go! Temp.
<br>
	 * If the sensor hardware reports a new SensorNumber, then a user has probably changed what sensor is
<br>
	 * plugged into a Go! Link. The simplest course of action in this case is to call
<br>
	 * GoIO_Sensor_GetOpenDeviceName() to get the device id, call GoIO_Sensor_Close(), and then
<br>
	 * call GoIO_Sensor_Open() with the values obtained from GoIO_Sensor_GetOpenDeviceName() to reopen the
<br>
	 * device. This will cause the GoIO_Sensor object to be properly configured for the new sensor.
<br>
	 * Return:		0 if successful, else -1.
<br>
	 * **************************************************************************************************************************<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetSensorNumber(GOIO_SENSOR_HANDLE, unsigned char*, gtype_int32, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pSensorNumber [out] ptr to SensorNumber.<br>
	 * @param sendQueryToHardwareflag [in] If sendQueryToHardwareflag != 0, then send a SKIP_CMD_ID_GET_SENSOR_ID to the sensor hardware.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:559</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetSensorNumber") 
	public static int goIOSensorDDSMemGetSensorNumber(Pointer<? > hSensor, Pointer<Byte > pSensorNumber, int sendQueryToHardwareflag, int timeoutMs) {
		return goIOSensorDDSMemGetSensorNumber(Pointer.getPeer(hSensor), Pointer.getPeer(pSensorNumber), sendQueryToHardwareflag, timeoutMs);
	}
	@Name("GoIO_Sensor_DDSMem_GetSensorNumber") 
	protected native static int goIOSensorDDSMemGetSensorNumber(@Ptr long hSensor, @Ptr long pSensorNumber, int sendQueryToHardwareflag, int timeoutMs);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetSerialNumber(GOIO_SENSOR_HANDLE, unsigned char, unsigned char, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:561</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetSerialNumber") 
	public static int goIOSensorDDSMemSetSerialNumber(Pointer<? > hSensor, byte leastSigByte_SerialNumber, byte midSigByte_SerialNumber, byte mostSigByte_SerialNumber) {
		return goIOSensorDDSMemSetSerialNumber(Pointer.getPeer(hSensor), leastSigByte_SerialNumber, midSigByte_SerialNumber, mostSigByte_SerialNumber);
	}
	@Name("GoIO_Sensor_DDSMem_SetSerialNumber") 
	protected native static int goIOSensorDDSMemSetSerialNumber(@Ptr long hSensor, byte leastSigByte_SerialNumber, byte midSigByte_SerialNumber, byte mostSigByte_SerialNumber);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetSerialNumber(GOIO_SENSOR_HANDLE, unsigned char*, unsigned char*, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:563</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetSerialNumber") 
	public static int goIOSensorDDSMemGetSerialNumber(Pointer<? > hSensor, Pointer<Byte > pLeastSigByte_SerialNumber, Pointer<Byte > pMidSigByte_SerialNumber, Pointer<Byte > pMostSigByte_SerialNumber) {
		return goIOSensorDDSMemGetSerialNumber(Pointer.getPeer(hSensor), Pointer.getPeer(pLeastSigByte_SerialNumber), Pointer.getPeer(pMidSigByte_SerialNumber), Pointer.getPeer(pMostSigByte_SerialNumber));
	}
	@Name("GoIO_Sensor_DDSMem_GetSerialNumber") 
	protected native static int goIOSensorDDSMemGetSerialNumber(@Ptr long hSensor, @Ptr long pLeastSigByte_SerialNumber, @Ptr long pMidSigByte_SerialNumber, @Ptr long pMostSigByte_SerialNumber);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetLotCode(GOIO_SENSOR_HANDLE, unsigned char, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:565</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetLotCode") 
	public static int goIOSensorDDSMemSetLotCode(Pointer<? > hSensor, byte YY_BCD, byte WW_BCD) {
		return goIOSensorDDSMemSetLotCode(Pointer.getPeer(hSensor), YY_BCD, WW_BCD);
	}
	@Name("GoIO_Sensor_DDSMem_SetLotCode") 
	protected native static int goIOSensorDDSMemSetLotCode(@Ptr long hSensor, byte YY_BCD, byte WW_BCD);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetLotCode(GOIO_SENSOR_HANDLE, unsigned char*, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:567</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetLotCode") 
	public static int goIOSensorDDSMemGetLotCode(Pointer<? > hSensor, Pointer<Byte > pYY_BCD, Pointer<Byte > pWW_BCD) {
		return goIOSensorDDSMemGetLotCode(Pointer.getPeer(hSensor), Pointer.getPeer(pYY_BCD), Pointer.getPeer(pWW_BCD));
	}
	@Name("GoIO_Sensor_DDSMem_GetLotCode") 
	protected native static int goIOSensorDDSMemGetLotCode(@Ptr long hSensor, @Ptr long pYY_BCD, @Ptr long pWW_BCD);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetManufacturerID(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:569</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetManufacturerID") 
	public static int goIOSensorDDSMemSetManufacturerID(Pointer<? > hSensor, byte ManufacturerID) {
		return goIOSensorDDSMemSetManufacturerID(Pointer.getPeer(hSensor), ManufacturerID);
	}
	@Name("GoIO_Sensor_DDSMem_SetManufacturerID") 
	protected native static int goIOSensorDDSMemSetManufacturerID(@Ptr long hSensor, byte ManufacturerID);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetManufacturerID(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:571</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetManufacturerID") 
	public static int goIOSensorDDSMemGetManufacturerID(Pointer<? > hSensor, Pointer<Byte > pManufacturerID) {
		return goIOSensorDDSMemGetManufacturerID(Pointer.getPeer(hSensor), Pointer.getPeer(pManufacturerID));
	}
	@Name("GoIO_Sensor_DDSMem_GetManufacturerID") 
	protected native static int goIOSensorDDSMemGetManufacturerID(@Ptr long hSensor, @Ptr long pManufacturerID);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetLongName(GOIO_SENSOR_HANDLE, const char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:573</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetLongName") 
	public static int goIOSensorDDSMemSetLongName(Pointer<? > hSensor, Pointer<Byte > pLongName) {
		return goIOSensorDDSMemSetLongName(Pointer.getPeer(hSensor), Pointer.getPeer(pLongName));
	}
	@Name("GoIO_Sensor_DDSMem_SetLongName") 
	protected native static int goIOSensorDDSMemSetLongName(@Ptr long hSensor, @Ptr long pLongName);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetLongName(GOIO_SENSOR_HANDLE, char*, gtype_uint16)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pLongName [out] ptr to buffer for NULL terminated output string.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:579</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetLongName") 
	public static int goIOSensorDDSMemGetLongName(Pointer<? > hSensor, Pointer<Byte > pLongName, short maxNumBytesToCopy) {
		return goIOSensorDDSMemGetLongName(Pointer.getPeer(hSensor), Pointer.getPeer(pLongName), maxNumBytesToCopy);
	}
	@Name("GoIO_Sensor_DDSMem_GetLongName") 
	protected native static int goIOSensorDDSMemGetLongName(@Ptr long hSensor, @Ptr long pLongName, short maxNumBytesToCopy);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetShortName(GOIO_SENSOR_HANDLE, const char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:581</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetShortName") 
	public static int goIOSensorDDSMemSetShortName(Pointer<? > hSensor, Pointer<Byte > pShortName) {
		return goIOSensorDDSMemSetShortName(Pointer.getPeer(hSensor), Pointer.getPeer(pShortName));
	}
	@Name("GoIO_Sensor_DDSMem_SetShortName") 
	protected native static int goIOSensorDDSMemSetShortName(@Ptr long hSensor, @Ptr long pShortName);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetShortName(GOIO_SENSOR_HANDLE, char*, gtype_uint16)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pShortName [out] ptr to buffer for NULL terminated output string.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:587</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetShortName") 
	public static int goIOSensorDDSMemGetShortName(Pointer<? > hSensor, Pointer<Byte > pShortName, short maxNumBytesToCopy) {
		return goIOSensorDDSMemGetShortName(Pointer.getPeer(hSensor), Pointer.getPeer(pShortName), maxNumBytesToCopy);
	}
	@Name("GoIO_Sensor_DDSMem_GetShortName") 
	protected native static int goIOSensorDDSMemGetShortName(@Ptr long hSensor, @Ptr long pShortName, short maxNumBytesToCopy);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetUncertainty(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:589</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetUncertainty") 
	public static int goIOSensorDDSMemSetUncertainty(Pointer<? > hSensor, byte Uncertainty) {
		return goIOSensorDDSMemSetUncertainty(Pointer.getPeer(hSensor), Uncertainty);
	}
	@Name("GoIO_Sensor_DDSMem_SetUncertainty") 
	protected native static int goIOSensorDDSMemSetUncertainty(@Ptr long hSensor, byte Uncertainty);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetUncertainty(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:591</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetUncertainty") 
	public static int goIOSensorDDSMemGetUncertainty(Pointer<? > hSensor, Pointer<Byte > pUncertainty) {
		return goIOSensorDDSMemGetUncertainty(Pointer.getPeer(hSensor), Pointer.getPeer(pUncertainty));
	}
	@Name("GoIO_Sensor_DDSMem_GetUncertainty") 
	protected native static int goIOSensorDDSMemGetUncertainty(@Ptr long hSensor, @Ptr long pUncertainty);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetSignificantFigures(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:593</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetSignificantFigures") 
	public static int goIOSensorDDSMemSetSignificantFigures(Pointer<? > hSensor, byte SignificantFigures) {
		return goIOSensorDDSMemSetSignificantFigures(Pointer.getPeer(hSensor), SignificantFigures);
	}
	@Name("GoIO_Sensor_DDSMem_SetSignificantFigures") 
	protected native static int goIOSensorDDSMemSetSignificantFigures(@Ptr long hSensor, byte SignificantFigures);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetSignificantFigures(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:595</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetSignificantFigures") 
	public static int goIOSensorDDSMemGetSignificantFigures(Pointer<? > hSensor, Pointer<Byte > pSignificantFigures) {
		return goIOSensorDDSMemGetSignificantFigures(Pointer.getPeer(hSensor), Pointer.getPeer(pSignificantFigures));
	}
	@Name("GoIO_Sensor_DDSMem_GetSignificantFigures") 
	protected native static int goIOSensorDDSMemGetSignificantFigures(@Ptr long hSensor, @Ptr long pSignificantFigures);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetCurrentRequirement(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:597</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetCurrentRequirement") 
	public static int goIOSensorDDSMemSetCurrentRequirement(Pointer<? > hSensor, byte CurrentRequirement) {
		return goIOSensorDDSMemSetCurrentRequirement(Pointer.getPeer(hSensor), CurrentRequirement);
	}
	@Name("GoIO_Sensor_DDSMem_SetCurrentRequirement") 
	protected native static int goIOSensorDDSMemSetCurrentRequirement(@Ptr long hSensor, byte CurrentRequirement);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetCurrentRequirement(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:599</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetCurrentRequirement") 
	public static int goIOSensorDDSMemGetCurrentRequirement(Pointer<? > hSensor, Pointer<Byte > pCurrentRequirement) {
		return goIOSensorDDSMemGetCurrentRequirement(Pointer.getPeer(hSensor), Pointer.getPeer(pCurrentRequirement));
	}
	@Name("GoIO_Sensor_DDSMem_GetCurrentRequirement") 
	protected native static int goIOSensorDDSMemGetCurrentRequirement(@Ptr long hSensor, @Ptr long pCurrentRequirement);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetAveraging(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:601</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetAveraging") 
	public static int goIOSensorDDSMemSetAveraging(Pointer<? > hSensor, byte Averaging) {
		return goIOSensorDDSMemSetAveraging(Pointer.getPeer(hSensor), Averaging);
	}
	@Name("GoIO_Sensor_DDSMem_SetAveraging") 
	protected native static int goIOSensorDDSMemSetAveraging(@Ptr long hSensor, byte Averaging);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetAveraging(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:603</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetAveraging") 
	public static int goIOSensorDDSMemGetAveraging(Pointer<? > hSensor, Pointer<Byte > pAveraging) {
		return goIOSensorDDSMemGetAveraging(Pointer.getPeer(hSensor), Pointer.getPeer(pAveraging));
	}
	@Name("GoIO_Sensor_DDSMem_GetAveraging") 
	protected native static int goIOSensorDDSMemGetAveraging(@Ptr long hSensor, @Ptr long pAveraging);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetMinSamplePeriod(GOIO_SENSOR_HANDLE, gtype_real32)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:605</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetMinSamplePeriod") 
	public static int goIOSensorDDSMemSetMinSamplePeriod(Pointer<? > hSensor, float MinSamplePeriod) {
		return goIOSensorDDSMemSetMinSamplePeriod(Pointer.getPeer(hSensor), MinSamplePeriod);
	}
	@Name("GoIO_Sensor_DDSMem_SetMinSamplePeriod") 
	protected native static int goIOSensorDDSMemSetMinSamplePeriod(@Ptr long hSensor, float MinSamplePeriod);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetMinSamplePeriod(GOIO_SENSOR_HANDLE, gtype_real32*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:607</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetMinSamplePeriod") 
	public static int goIOSensorDDSMemGetMinSamplePeriod(Pointer<? > hSensor, Pointer<Float > pMinSamplePeriod) {
		return goIOSensorDDSMemGetMinSamplePeriod(Pointer.getPeer(hSensor), Pointer.getPeer(pMinSamplePeriod));
	}
	@Name("GoIO_Sensor_DDSMem_GetMinSamplePeriod") 
	protected native static int goIOSensorDDSMemGetMinSamplePeriod(@Ptr long hSensor, @Ptr long pMinSamplePeriod);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetTypSamplePeriod(GOIO_SENSOR_HANDLE, gtype_real32)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:609</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetTypSamplePeriod") 
	public static int goIOSensorDDSMemSetTypSamplePeriod(Pointer<? > hSensor, float TypSamplePeriod) {
		return goIOSensorDDSMemSetTypSamplePeriod(Pointer.getPeer(hSensor), TypSamplePeriod);
	}
	@Name("GoIO_Sensor_DDSMem_SetTypSamplePeriod") 
	protected native static int goIOSensorDDSMemSetTypSamplePeriod(@Ptr long hSensor, float TypSamplePeriod);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetTypSamplePeriod(GOIO_SENSOR_HANDLE, gtype_real32*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:611</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetTypSamplePeriod") 
	public static int goIOSensorDDSMemGetTypSamplePeriod(Pointer<? > hSensor, Pointer<Float > pTypSamplePeriod) {
		return goIOSensorDDSMemGetTypSamplePeriod(Pointer.getPeer(hSensor), Pointer.getPeer(pTypSamplePeriod));
	}
	@Name("GoIO_Sensor_DDSMem_GetTypSamplePeriod") 
	protected native static int goIOSensorDDSMemGetTypSamplePeriod(@Ptr long hSensor, @Ptr long pTypSamplePeriod);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetTypNumberofSamples(GOIO_SENSOR_HANDLE, gtype_uint16)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:613</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetTypNumberofSamples") 
	public static int goIOSensorDDSMemSetTypNumberofSamples(Pointer<? > hSensor, short TypNumberofSamples) {
		return goIOSensorDDSMemSetTypNumberofSamples(Pointer.getPeer(hSensor), TypNumberofSamples);
	}
	@Name("GoIO_Sensor_DDSMem_SetTypNumberofSamples") 
	protected native static int goIOSensorDDSMemSetTypNumberofSamples(@Ptr long hSensor, short TypNumberofSamples);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetTypNumberofSamples(GOIO_SENSOR_HANDLE, gtype_uint16*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:615</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetTypNumberofSamples") 
	public static int goIOSensorDDSMemGetTypNumberofSamples(Pointer<? > hSensor, Pointer<Short > pTypNumberofSamples) {
		return goIOSensorDDSMemGetTypNumberofSamples(Pointer.getPeer(hSensor), Pointer.getPeer(pTypNumberofSamples));
	}
	@Name("GoIO_Sensor_DDSMem_GetTypNumberofSamples") 
	protected native static int goIOSensorDDSMemGetTypNumberofSamples(@Ptr long hSensor, @Ptr long pTypNumberofSamples);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetWarmUpTime(GOIO_SENSOR_HANDLE, gtype_uint16)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:617</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetWarmUpTime") 
	public static int goIOSensorDDSMemSetWarmUpTime(Pointer<? > hSensor, short WarmUpTime) {
		return goIOSensorDDSMemSetWarmUpTime(Pointer.getPeer(hSensor), WarmUpTime);
	}
	@Name("GoIO_Sensor_DDSMem_SetWarmUpTime") 
	protected native static int goIOSensorDDSMemSetWarmUpTime(@Ptr long hSensor, short WarmUpTime);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetWarmUpTime(GOIO_SENSOR_HANDLE, gtype_uint16*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:619</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetWarmUpTime") 
	public static int goIOSensorDDSMemGetWarmUpTime(Pointer<? > hSensor, Pointer<Short > pWarmUpTime) {
		return goIOSensorDDSMemGetWarmUpTime(Pointer.getPeer(hSensor), Pointer.getPeer(pWarmUpTime));
	}
	@Name("GoIO_Sensor_DDSMem_GetWarmUpTime") 
	protected native static int goIOSensorDDSMemGetWarmUpTime(@Ptr long hSensor, @Ptr long pWarmUpTime);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetExperimentType(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:621</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetExperimentType") 
	public static int goIOSensorDDSMemSetExperimentType(Pointer<? > hSensor, byte ExperimentType) {
		return goIOSensorDDSMemSetExperimentType(Pointer.getPeer(hSensor), ExperimentType);
	}
	@Name("GoIO_Sensor_DDSMem_SetExperimentType") 
	protected native static int goIOSensorDDSMemSetExperimentType(@Ptr long hSensor, byte ExperimentType);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetExperimentType(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:623</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetExperimentType") 
	public static int goIOSensorDDSMemGetExperimentType(Pointer<? > hSensor, Pointer<Byte > pExperimentType) {
		return goIOSensorDDSMemGetExperimentType(Pointer.getPeer(hSensor), Pointer.getPeer(pExperimentType));
	}
	@Name("GoIO_Sensor_DDSMem_GetExperimentType") 
	protected native static int goIOSensorDDSMemGetExperimentType(@Ptr long hSensor, @Ptr long pExperimentType);
	/**
	 * GoIO_Sensor_DDSMem_SetOperationType() can change the probe type. See GoIO_Sensor_GetProbeType().<br>
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetOperationType(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:628</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetOperationType") 
	public static int goIOSensorDDSMemSetOperationType(Pointer<? > hSensor, byte OperationType) {
		return goIOSensorDDSMemSetOperationType(Pointer.getPeer(hSensor), OperationType);
	}
	@Name("GoIO_Sensor_DDSMem_SetOperationType") 
	protected native static int goIOSensorDDSMemSetOperationType(@Ptr long hSensor, byte OperationType);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetOperationType(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:630</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetOperationType") 
	public static int goIOSensorDDSMemGetOperationType(Pointer<? > hSensor, Pointer<Byte > pOperationType) {
		return goIOSensorDDSMemGetOperationType(Pointer.getPeer(hSensor), Pointer.getPeer(pOperationType));
	}
	@Name("GoIO_Sensor_DDSMem_GetOperationType") 
	protected native static int goIOSensorDDSMemGetOperationType(@Ptr long hSensor, @Ptr long pOperationType);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetCalibrationEquation(GOIO_SENSOR_HANDLE, char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:632</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetCalibrationEquation") 
	public static int goIOSensorDDSMemSetCalibrationEquation(Pointer<? > hSensor, byte CalibrationEquation) {
		return goIOSensorDDSMemSetCalibrationEquation(Pointer.getPeer(hSensor), CalibrationEquation);
	}
	@Name("GoIO_Sensor_DDSMem_SetCalibrationEquation") 
	protected native static int goIOSensorDDSMemSetCalibrationEquation(@Ptr long hSensor, byte CalibrationEquation);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetCalibrationEquation(GOIO_SENSOR_HANDLE, char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:634</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetCalibrationEquation") 
	public static int goIOSensorDDSMemGetCalibrationEquation(Pointer<? > hSensor, Pointer<Byte > pCalibrationEquation) {
		return goIOSensorDDSMemGetCalibrationEquation(Pointer.getPeer(hSensor), Pointer.getPeer(pCalibrationEquation));
	}
	@Name("GoIO_Sensor_DDSMem_GetCalibrationEquation") 
	protected native static int goIOSensorDDSMemGetCalibrationEquation(@Ptr long hSensor, @Ptr long pCalibrationEquation);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetYminValue(GOIO_SENSOR_HANDLE, gtype_real32)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:636</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetYminValue") 
	public static int goIOSensorDDSMemSetYminValue(Pointer<? > hSensor, float YminValue) {
		return goIOSensorDDSMemSetYminValue(Pointer.getPeer(hSensor), YminValue);
	}
	@Name("GoIO_Sensor_DDSMem_SetYminValue") 
	protected native static int goIOSensorDDSMemSetYminValue(@Ptr long hSensor, float YminValue);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetYminValue(GOIO_SENSOR_HANDLE, gtype_real32*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:638</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetYminValue") 
	public static int goIOSensorDDSMemGetYminValue(Pointer<? > hSensor, Pointer<Float > pYminValue) {
		return goIOSensorDDSMemGetYminValue(Pointer.getPeer(hSensor), Pointer.getPeer(pYminValue));
	}
	@Name("GoIO_Sensor_DDSMem_GetYminValue") 
	protected native static int goIOSensorDDSMemGetYminValue(@Ptr long hSensor, @Ptr long pYminValue);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetYmaxValue(GOIO_SENSOR_HANDLE, gtype_real32)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:640</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetYmaxValue") 
	public static int goIOSensorDDSMemSetYmaxValue(Pointer<? > hSensor, float YmaxValue) {
		return goIOSensorDDSMemSetYmaxValue(Pointer.getPeer(hSensor), YmaxValue);
	}
	@Name("GoIO_Sensor_DDSMem_SetYmaxValue") 
	protected native static int goIOSensorDDSMemSetYmaxValue(@Ptr long hSensor, float YmaxValue);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetYmaxValue(GOIO_SENSOR_HANDLE, gtype_real32*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:642</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetYmaxValue") 
	public static int goIOSensorDDSMemGetYmaxValue(Pointer<? > hSensor, Pointer<Float > pYmaxValue) {
		return goIOSensorDDSMemGetYmaxValue(Pointer.getPeer(hSensor), Pointer.getPeer(pYmaxValue));
	}
	@Name("GoIO_Sensor_DDSMem_GetYmaxValue") 
	protected native static int goIOSensorDDSMemGetYmaxValue(@Ptr long hSensor, @Ptr long pYmaxValue);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetYscale(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:644</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetYscale") 
	public static int goIOSensorDDSMemSetYscale(Pointer<? > hSensor, byte Yscale) {
		return goIOSensorDDSMemSetYscale(Pointer.getPeer(hSensor), Yscale);
	}
	@Name("GoIO_Sensor_DDSMem_SetYscale") 
	protected native static int goIOSensorDDSMemSetYscale(@Ptr long hSensor, byte Yscale);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetYscale(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:646</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetYscale") 
	public static int goIOSensorDDSMemGetYscale(Pointer<? > hSensor, Pointer<Byte > pYscale) {
		return goIOSensorDDSMemGetYscale(Pointer.getPeer(hSensor), Pointer.getPeer(pYscale));
	}
	@Name("GoIO_Sensor_DDSMem_GetYscale") 
	protected native static int goIOSensorDDSMemGetYscale(@Ptr long hSensor, @Ptr long pYscale);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetHighestValidCalPageIndex(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:648</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetHighestValidCalPageIndex") 
	public static int goIOSensorDDSMemSetHighestValidCalPageIndex(Pointer<? > hSensor, byte HighestValidCalPageIndex) {
		return goIOSensorDDSMemSetHighestValidCalPageIndex(Pointer.getPeer(hSensor), HighestValidCalPageIndex);
	}
	@Name("GoIO_Sensor_DDSMem_SetHighestValidCalPageIndex") 
	protected native static int goIOSensorDDSMemSetHighestValidCalPageIndex(@Ptr long hSensor, byte HighestValidCalPageIndex);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetHighestValidCalPageIndex(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:650</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetHighestValidCalPageIndex") 
	public static int goIOSensorDDSMemGetHighestValidCalPageIndex(Pointer<? > hSensor, Pointer<Byte > pHighestValidCalPageIndex) {
		return goIOSensorDDSMemGetHighestValidCalPageIndex(Pointer.getPeer(hSensor), Pointer.getPeer(pHighestValidCalPageIndex));
	}
	@Name("GoIO_Sensor_DDSMem_GetHighestValidCalPageIndex") 
	protected native static int goIOSensorDDSMemGetHighestValidCalPageIndex(@Ptr long hSensor, @Ptr long pHighestValidCalPageIndex);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetActiveCalPage(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:652</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetActiveCalPage") 
	public static int goIOSensorDDSMemSetActiveCalPage(Pointer<? > hSensor, byte ActiveCalPage) {
		return goIOSensorDDSMemSetActiveCalPage(Pointer.getPeer(hSensor), ActiveCalPage);
	}
	@Name("GoIO_Sensor_DDSMem_SetActiveCalPage") 
	protected native static int goIOSensorDDSMemSetActiveCalPage(@Ptr long hSensor, byte ActiveCalPage);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetActiveCalPage(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:654</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetActiveCalPage") 
	public static int goIOSensorDDSMemGetActiveCalPage(Pointer<? > hSensor, Pointer<Byte > pActiveCalPage) {
		return goIOSensorDDSMemGetActiveCalPage(Pointer.getPeer(hSensor), Pointer.getPeer(pActiveCalPage));
	}
	@Name("GoIO_Sensor_DDSMem_GetActiveCalPage") 
	protected native static int goIOSensorDDSMemGetActiveCalPage(@Ptr long hSensor, @Ptr long pActiveCalPage);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetCalPage(GOIO_SENSOR_HANDLE, unsigned char, gtype_real32, gtype_real32, gtype_real32, const char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:656</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetCalPage") 
	public static int goIOSensorDDSMemSetCalPage(Pointer<? > hSensor, byte CalPageIndex, float CalibrationCoefficientA, float CalibrationCoefficientB, float CalibrationCoefficientC, Pointer<Byte > pUnits) {
		return goIOSensorDDSMemSetCalPage(Pointer.getPeer(hSensor), CalPageIndex, CalibrationCoefficientA, CalibrationCoefficientB, CalibrationCoefficientC, Pointer.getPeer(pUnits));
	}
	@Name("GoIO_Sensor_DDSMem_SetCalPage") 
	protected native static int goIOSensorDDSMemSetCalPage(@Ptr long hSensor, byte CalPageIndex, float CalibrationCoefficientA, float CalibrationCoefficientB, float CalibrationCoefficientC, @Ptr long pUnits);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetCalPage(GOIO_SENSOR_HANDLE, unsigned char, gtype_real32*, gtype_real32*, gtype_real32*, char*, gtype_uint16)</code><br>
	 * @param pUnits [out] ptr to buffer for NULL terminated output string.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:661</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetCalPage") 
	public static int goIOSensorDDSMemGetCalPage(Pointer<? > hSensor, byte CalPageIndex, Pointer<Float > pCalibrationCoefficientA, Pointer<Float > pCalibrationCoefficientB, Pointer<Float > pCalibrationCoefficientC, Pointer<Byte > pUnits, short maxNumBytesToCopy) {
		return goIOSensorDDSMemGetCalPage(Pointer.getPeer(hSensor), CalPageIndex, Pointer.getPeer(pCalibrationCoefficientA), Pointer.getPeer(pCalibrationCoefficientB), Pointer.getPeer(pCalibrationCoefficientC), Pointer.getPeer(pUnits), maxNumBytesToCopy);
	}
	@Name("GoIO_Sensor_DDSMem_GetCalPage") 
	protected native static int goIOSensorDDSMemGetCalPage(@Ptr long hSensor, byte CalPageIndex, @Ptr long pCalibrationCoefficientA, @Ptr long pCalibrationCoefficientB, @Ptr long pCalibrationCoefficientC, @Ptr long pUnits, short maxNumBytesToCopy);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_SetChecksum(GOIO_SENSOR_HANDLE, unsigned char)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:663</i>
	 */
	@Name("GoIO_Sensor_DDSMem_SetChecksum") 
	public static int goIOSensorDDSMemSetChecksum(Pointer<? > hSensor, byte Checksum) {
		return goIOSensorDDSMemSetChecksum(Pointer.getPeer(hSensor), Checksum);
	}
	@Name("GoIO_Sensor_DDSMem_SetChecksum") 
	protected native static int goIOSensorDDSMemSetChecksum(@Ptr long hSensor, byte Checksum);
	/**
	 * Original signature : <code>gtype_int32 GoIO_Sensor_DDSMem_GetChecksum(GOIO_SENSOR_HANDLE, unsigned char*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:665</i>
	 */
	@Name("GoIO_Sensor_DDSMem_GetChecksum") 
	public static int goIOSensorDDSMemGetChecksum(Pointer<? > hSensor, Pointer<Byte > pChecksum) {
		return goIOSensorDDSMemGetChecksum(Pointer.getPeer(hSensor), Pointer.getPeer(pChecksum));
	}
	@Name("GoIO_Sensor_DDSMem_GetChecksum") 
	protected native static int goIOSensorDDSMemGetChecksum(@Ptr long hSensor, @Ptr long pChecksum);
	/**
	 * Advanced API's:<br>
	 * Original signature : <code>void GoIO_Diags_SetIOTraceEnableFlag(gtype_bool)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:670</i>
	 */
	@Name("GoIO_Diags_SetIOTraceEnableFlag") 
	public static native void goIODiagsSetIOTraceEnableFlag(byte flag);
	/**
	 * Original signature : <code>void GoIO_Diags_GetIOTraceEnableFlag(gtype_bool*)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:672</i>
	 */
	@Name("GoIO_Diags_GetIOTraceEnableFlag") 
	public static void goIODiagsGetIOTraceEnableFlag(Pointer<Byte > pFlag) {
		goIODiagsGetIOTraceEnableFlag(Pointer.getPeer(pFlag));
	}
	@Name("GoIO_Diags_GetIOTraceEnableFlag") 
	protected native static void goIODiagsGetIOTraceEnableFlag(@Ptr long pFlag);
	/**
	 * returns # of bytes available.<br>
	 * Original signature : <code>gtype_int32 GoIO_Diags_GetNumInputTraceBytesAvailable(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:677</i>
	 */
	@Name("GoIO_Diags_GetNumInputTraceBytesAvailable") 
	public static int goIODiagsGetNumInputTraceBytesAvailable(Pointer<? > hSensor) {
		return goIODiagsGetNumInputTraceBytesAvailable(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Diags_GetNumInputTraceBytesAvailable") 
	protected native static int goIODiagsGetNumInputTraceBytesAvailable(@Ptr long hSensor);
	/**
	 * returns # of bytes copied.<br>
	 * Original signature : <code>gtype_int32 GoIO_Diags_ReadInputTraceBytes(GOIO_SENSOR_HANDLE, unsigned char*, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pInputTraceBuf [out] ptr to loc to store trace info.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:684</i>
	 */
	@Name("GoIO_Diags_ReadInputTraceBytes") 
	public static int goIODiagsReadInputTraceBytes(Pointer<? > hSensor, Pointer<Byte > pInputTraceBuf, int maxCount) {
		return goIODiagsReadInputTraceBytes(Pointer.getPeer(hSensor), Pointer.getPeer(pInputTraceBuf), maxCount);
	}
	@Name("GoIO_Diags_ReadInputTraceBytes") 
	protected native static int goIODiagsReadInputTraceBytes(@Ptr long hSensor, @Ptr long pInputTraceBuf, int maxCount);
	/**
	 * returns # of bytes available.<br>
	 * Original signature : <code>gtype_int32 GoIO_Diags_GetNumOutputTraceBytesAvailable(GOIO_SENSOR_HANDLE)</code><br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:689</i>
	 */
	@Name("GoIO_Diags_GetNumOutputTraceBytesAvailable") 
	public static int goIODiagsGetNumOutputTraceBytesAvailable(Pointer<? > hSensor) {
		return goIODiagsGetNumOutputTraceBytesAvailable(Pointer.getPeer(hSensor));
	}
	@Name("GoIO_Diags_GetNumOutputTraceBytesAvailable") 
	protected native static int goIODiagsGetNumOutputTraceBytesAvailable(@Ptr long hSensor);
	/**
	 * returns # of bytes copied.<br>
	 * Original signature : <code>gtype_int32 GoIO_Diags_ReadOutputTraceBytes(GOIO_SENSOR_HANDLE, unsigned char*, gtype_int32)</code><br>
	 * @param hSensor [in] handle to open sensor.<br>
	 * @param pOutputTraceBuf [out] ptr to loc to store trace info.<br>
	 * <i>native declaration : include/GoIO_DLL_interface.h:696</i>
	 */
	@Name("GoIO_Diags_ReadOutputTraceBytes") 
	public static int goIODiagsReadOutputTraceBytes(Pointer<? > hSensor, Pointer<Byte > pOutputTraceBuf, int maxCount) {
		return goIODiagsReadOutputTraceBytes(Pointer.getPeer(hSensor), Pointer.getPeer(pOutputTraceBuf), maxCount);
	}
	@Name("GoIO_Diags_ReadOutputTraceBytes") 
	protected native static int goIODiagsReadOutputTraceBytes(@Ptr long hSensor, @Ptr long pOutputTraceBuf, int maxCount);
}
