/* 
 * GHMessen
 * --------
 * 
 * GHMessen is a measuring program to use in connection with a computer 
 * measuring interface. It's designed for school usage.
 * 
 * Copyright (C) 2010-2011  Frank Schütte - Gymnasium Himmelsthür
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; 
 * if not, see <http://www.gnu.org/licenses/>.
 * 
 * Frank Schütte fschuett AT gymnasium-himmelsthuer DOT de
 * 
 */

package libGoIO;

import ghmessen.GHMessen;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.ResourceMap.LookupException;

public class SensorMap {

	private static final boolean DEBUG = false;

	private static ResourceMap resourceMap;
	private static ResourceBundle resourceBundle;

	public SensorMap() {
		try {
			resourceMap = GHMessen.getInstance().getContext()
					.getResourceMap(SensorMap.class);
		} catch (IllegalStateException e) {
			resourceBundle = ResourceBundle.getBundle("libGoIO.resources.SensorMap");
		}

	}

	public String getString(String key) {
		String ret = key;
		key = key.replace(" ", "_");
		try {
			String temp = resourceMap != null ? resourceMap.getString(key)
					: resourceBundle.getString(key);
			return temp == null ? ret : temp;
		} catch (MissingResourceException e) {
			if(DEBUG)
				e.printStackTrace();
		} catch (IllegalArgumentException e) {
			if (DEBUG)
				e.printStackTrace();
		} catch (LookupException e) {
			if (DEBUG)
				e.printStackTrace();
		}
		return ret;
	}
}
