package libGoIO;
import org.bridj.BridJ;
import org.bridj.Pointer;
import org.bridj.StructObject;
import org.bridj.ann.Array;
import org.bridj.ann.Field;
import org.bridj.ann.Library;
/**
 * <i>native declaration : include/GSensorDDSMem.h:104</i><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("GoIO") 
public class tagGSensorDDSRec extends StructObject {
	static {
		BridJ.register();
	}
	@Field(0) 
	public byte MemMapVersion() {
		return this.io.getByteField(this, 0);
	}
	@Field(0) 
	public tagGSensorDDSRec MemMapVersion(byte MemMapVersion) {
		this.io.setByteField(this, 0, MemMapVersion);
		return this;
	}
	/** Identifies type of sensor; (SensorNumber >= 20) generally implies that */
	@Field(1) 
	public byte SensorNumber() {
		return this.io.getByteField(this, 1);
	}
	/** Identifies type of sensor; (SensorNumber >= 20) generally implies that */
	@Field(1) 
	public tagGSensorDDSRec SensorNumber(byte SensorNumber) {
		this.io.setByteField(this, 1, SensorNumber);
		return this;
	}
	/**
	 * GSensorDDSRec is stored on the sensor hardware. Such sensors are called 'smart'.<br>
	 * [0][1][2] - serial number as 3-byte integer, Little-Endian (LSB first).<br>
	 * C type : unsigned char[3]
	 */
	@Array({3}) 
	@Field(2) 
	public Pointer<Byte > SensorSerialNumber() {
		return this.io.getPointerField(this, 2);
	}
	/**
	 * Lot code as 2-byte BCD date, [0] = YY, [1] == WW.<br>
	 * C type : unsigned char[2]
	 */
	@Array({2}) 
	@Field(3) 
	public Pointer<Byte > SensorLotCode() {
		return this.io.getPointerField(this, 3);
	}
	@Field(4) 
	public byte ManufacturerID() {
		return this.io.getByteField(this, 4);
	}
	@Field(4) 
	public tagGSensorDDSRec ManufacturerID(byte ManufacturerID) {
		this.io.setByteField(this, 4, ManufacturerID);
		return this;
	}
	/** C type : char[20] */
	@Array({20}) 
	@Field(5) 
	public Pointer<Byte > SensorLongName() {
		return this.io.getPointerField(this, 5);
	}
	/** C type : char[12] */
	@Array({12}) 
	@Field(6) 
	public Pointer<Byte > SensorShortName() {
		return this.io.getPointerField(this, 6);
	}
	@Field(7) 
	public byte Uncertainty() {
		return this.io.getByteField(this, 7);
	}
	@Field(7) 
	public tagGSensorDDSRec Uncertainty(byte Uncertainty) {
		this.io.setByteField(this, 7, Uncertainty);
		return this;
	}
	/** Ignore this field - it is only properly understood by legacy TI calculators. */
	@Field(8) 
	public byte SignificantFigures() {
		return this.io.getByteField(this, 8);
	}
	/** Ignore this field - it is only properly understood by legacy TI calculators. */
	@Field(8) 
	public tagGSensorDDSRec SignificantFigures(byte SignificantFigures) {
		this.io.setByteField(this, 8, SignificantFigures);
		return this;
	}
	/**
	 * Note that almost all analog sensors are of type kProbeTypeAnalog5V.<br>
	 * Number of mA(average) required to power sensor.
	 */
	@Field(9) 
	public byte CurrentRequirement() {
		return this.io.getByteField(this, 9);
	}
	/**
	 * Note that almost all analog sensors are of type kProbeTypeAnalog5V.<br>
	 * Number of mA(average) required to power sensor.
	 */
	@Field(9) 
	public tagGSensorDDSRec CurrentRequirement(byte CurrentRequirement) {
		this.io.setByteField(this, 9, CurrentRequirement);
		return this;
	}
	@Field(10) 
	public byte Averaging() {
		return this.io.getByteField(this, 10);
	}
	@Field(10) 
	public tagGSensorDDSRec Averaging(byte Averaging) {
		this.io.setByteField(this, 10, Averaging);
		return this;
	}
	/** seconds */
	@Field(11) 
	public float MinSamplePeriod() {
		return this.io.getFloatField(this, 11);
	}
	/** seconds */
	@Field(11) 
	public tagGSensorDDSRec MinSamplePeriod(float MinSamplePeriod) {
		this.io.setFloatField(this, 11, MinSamplePeriod);
		return this;
	}
	/** seconds */
	@Field(12) 
	public float TypSamplePeriod() {
		return this.io.getFloatField(this, 12);
	}
	/** seconds */
	@Field(12) 
	public tagGSensorDDSRec TypSamplePeriod(float TypSamplePeriod) {
		this.io.setFloatField(this, 12, TypSamplePeriod);
		return this;
	}
	@Field(13) 
	public short TypNumberofSamples() {
		return this.io.getShortField(this, 13);
	}
	@Field(13) 
	public tagGSensorDDSRec TypNumberofSamples(short TypNumberofSamples) {
		this.io.setShortField(this, 13, TypNumberofSamples);
		return this;
	}
	/** Time (in seconds) required for the sensor to have power before reaching equilibrium. */
	@Field(14) 
	public short WarmUpTime() {
		return this.io.getShortField(this, 14);
	}
	/** Time (in seconds) required for the sensor to have power before reaching equilibrium. */
	@Field(14) 
	public tagGSensorDDSRec WarmUpTime(short WarmUpTime) {
		this.io.setShortField(this, 14, WarmUpTime);
		return this;
	}
	@Field(15) 
	public byte ExperimentType() {
		return this.io.getByteField(this, 15);
	}
	@Field(15) 
	public tagGSensorDDSRec ExperimentType(byte ExperimentType) {
		this.io.setByteField(this, 15, ExperimentType);
		return this;
	}
	/** This is a LabPro specific field. */
	@Field(16) 
	public byte OperationType() {
		return this.io.getByteField(this, 16);
	}
	/** This is a LabPro specific field. */
	@Field(16) 
	public tagGSensorDDSRec OperationType(byte OperationType) {
		this.io.setByteField(this, 16, OperationType);
		return this;
	}
	/**
	 * Go! devices use this field to infer probe type(5 volt or 10 volt). See EProbeType.<br>
	 * See EEquationType.
	 */
	@Field(17) 
	public byte CalibrationEquation() {
		return this.io.getByteField(this, 17);
	}
	/**
	 * Go! devices use this field to infer probe type(5 volt or 10 volt). See EProbeType.<br>
	 * See EEquationType.
	 */
	@Field(17) 
	public tagGSensorDDSRec CalibrationEquation(byte CalibrationEquation) {
		this.io.setByteField(this, 17, CalibrationEquation);
		return this;
	}
	@Field(18) 
	public float YminValue() {
		return this.io.getFloatField(this, 18);
	}
	@Field(18) 
	public tagGSensorDDSRec YminValue(float YminValue) {
		this.io.setFloatField(this, 18, YminValue);
		return this;
	}
	@Field(19) 
	public float YmaxValue() {
		return this.io.getFloatField(this, 19);
	}
	@Field(19) 
	public tagGSensorDDSRec YmaxValue(float YmaxValue) {
		this.io.setFloatField(this, 19, YmaxValue);
		return this;
	}
	@Field(20) 
	public byte Yscale() {
		return this.io.getByteField(this, 20);
	}
	@Field(20) 
	public tagGSensorDDSRec Yscale(byte Yscale) {
		this.io.setByteField(this, 20, Yscale);
		return this;
	}
	/** First index is 0. */
	@Field(21) 
	public byte HighestValidCalPageIndex() {
		return this.io.getByteField(this, 21);
	}
	/** First index is 0. */
	@Field(21) 
	public tagGSensorDDSRec HighestValidCalPageIndex(byte HighestValidCalPageIndex) {
		this.io.setByteField(this, 21, HighestValidCalPageIndex);
		return this;
	}
	@Field(22) 
	public byte ActiveCalPage() {
		return this.io.getByteField(this, 22);
	}
	@Field(22) 
	public tagGSensorDDSRec ActiveCalPage(byte ActiveCalPage) {
		this.io.setByteField(this, 22, ActiveCalPage);
		return this;
	}
	/** C type : GCalibrationPage[3] */
	@Array({3}) 
	@Field(23) 
	public Pointer<tagGCalibrationPage > CalibrationPage() {
		return this.io.getPointerField(this, 23);
	}
	/** Result of XORing bytes 0-126. */
	@Field(24) 
	public byte Checksum() {
		return this.io.getByteField(this, 24);
	}
	/** Result of XORing bytes 0-126. */
	@Field(24) 
	public tagGSensorDDSRec Checksum(byte Checksum) {
		this.io.setByteField(this, 24, Checksum);
		return this;
	}
	public tagGSensorDDSRec() {
		super();
	}
	public tagGSensorDDSRec(Pointer pointer) {
		super(pointer);
	}
}
