package test;

import ld.api.CASSYRanges;
import ld.api.CASSYs;
import ld.api.PowerCASSY;
import ld.api.RmsPower;
import ld.api.SensorCASSY;
import ld.api.Waveforms;
import ghmessen.adapter.EAdapterException;
import udev.UdevDevice;

public class Einzelmessungtest {
	public static void main(String[] args) throws InterruptedException,
			EAdapterException {
		UdevDevice d = new UdevDevice("ldusb0", "", "", "", "", "/dev/ldusb0",
				"", "", "");
		CASSYs cs = new CASSYs();
		cs.setCommPort(d.getName());
		if (cs.get(0) instanceof SensorCASSY && cs.get(1) instanceof PowerCASSY) {
			SensorCASSY c = (SensorCASSY) cs.get(0);
			PowerCASSY p = (PowerCASSY) cs.get(1);
			System.out.println("Sensor-Cassy/Power-Cassy gefunden.");
			c.setMeanTime(1.0);
			c.getInput(0, CASSYRanges.U10V.getValue());
			p.initFunctionGenerator(Waveforms.Sin, 1.0, 2000, 0, 50);
			p.startFunctionGenerator(false);
			RmsPower rmsa, rmsb;
			boolean aOK = false, bOK = false;
			do {
				rmsa = c.getRmsPowerInput(0, CASSYRanges.U10V,
						CASSYRanges.U10V);
				aOK = true;
				System.out.println("Messwert UA noch nicht fertig.");
				rmsb = p.getRmsPowerInput(0, CASSYRanges.U10V,
						CASSYRanges.U10V);
				bOK = true;
			} while (!aOK || !bOK);
			System.out.printf("UA_RMS = %2.2f V, U2_RMS = %2.2f V\n", rmsa.getRmsA(), rmsb.getRmsA());
		} else
			System.out.println("Kein Sensor-Cassy/Power-Cassy gefunden.");
		cs.close();
		System.exit(0);
	}
}
