package test;
import ghmessen.adapter.MessInterfaceReader;
import ghmessen.adapter.MessInterfaceWriter;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.channels.FileChannel;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

public class TestCassyIO {

	private String fileName = "/home/fschuett/test.bin";
	private File ioFile;
	private byte[] inBuffer = new byte[256];
	private byte[] outBuffer = new byte[256];

	public static void main(String[] args) throws IOException,
			InterruptedException, ExecutionException, TimeoutException {
		TestCassyIO io = new TestCassyIO();
		io.ioFile = new File(io.fileName);
		if (!io.ioFile.exists() || !io.ioFile.canRead()
				|| !io.ioFile.canWrite()) {
			System.out
					.println("[TestCassyIO] - Datei "
							+ io.fileName
							+ " existiert nicht oder kann nicht gelesen oder nicht geschrieben werden.");
			System.exit(1);
		}

		try (RandomAccessFile f = new RandomAccessFile(io.ioFile,"rwd")) {
			FileChannel ch = f.getChannel();
			MessInterfaceWriter out = new MessInterfaceWriter(ch);
			MessInterfaceReader in = new MessInterfaceReader(ch);
			// Get Hardware Version
			io.outBuffer[0] = (byte) 3;
			io.outBuffer[1] = (byte) 0x1b;
			io.outBuffer[2] = (byte) 0xff;
			io.outBuffer[3] = (byte) 1;
			out.write(io.outBuffer, 0, 4, 100, TimeUnit.MILLISECONDS);
			int gelesen = 0;
			int gesamt = 3;
			while (true) {
				try {
					int neu = in.read(io.inBuffer, gelesen, io.inBuffer.length, 100, TimeUnit.MILLISECONDS);
					if (neu > 0) {
						gelesen += neu;
	
						if (io.inBuffer[0] == 0) {
							System.out.println("[TestCassyIO] - read(" + gelesen
									+ " von " + gesamt + ") inBuffer[0] = 0");
							System.exit(3);
						}
						if (gelesen >= gesamt)
							break;
					}
				} catch (TimeoutException e) {
					break;
				}
			}
			if (gelesen >= gesamt) {
				System.out.println("[TestCassyIO] - Hardware-Version: CASSY("
						+ io.inBuffer[1] + ") Version("
						+ (char) (65 + io.inBuffer[2]) + ")");
			} else
				System.out.println("[TestCassyIO] - unbekannter Fehler: gelesen("+gelesen+") gesamt("+gesamt+")");
		}
	}

}
