package test;

import ghmessen.parser.FormelGenerator;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;

import org.antlr.runtime.RecognitionException;
import org.antlr.v4.runtime.tree.ParseTree;
import org.codehaus.janino.ExpressionEvaluator;


public class TestFormel {

	/**
	 * @param args
	 * @throws IOException
	 * @throws RecognitionException
	 */
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		FormelGenerator parser = new FormelGenerator("",new String[]{"U_A1","I_B1","φ_1"});
		while (true) {
			System.out.print("Ausdruck: ");
			String expr = in.readLine();
			if (expr == null || "".equals(expr))
				System.exit(0);
			System.out.println();
			// Parsen und Tree darstellen
				parser.setKonstanten(new String[]{"U_A1","I_B1","φ_1"});
				parser.parsen(expr, false);
				ParseTree t = parser.getTree();
				System.out.println("AST: "+t.toStringTree());
				System.out.println("Formel: "+parser.getFormel());
				ExpressionEvaluator ee = parser.getAusdruck();
				System.out.println("Generierter Ausdruck: "+ee.toString());
				double tt = 0.0;
				Double resultat = null;
				try {
					resultat = (Double) ee.evaluate(
							new Object[] { tt, 0.0, 0.0,
									0.0, 0.0,
									0.0,
									new Double(0.1), 0, 0, new Double[]{0.0,0.0,0.0}, null });
				} catch (InvocationTargetException e) {
					e.printStackTrace();
					resultat = Double.NaN;
				}
				System.out.println("Resultat (t="+tt+"): "+resultat);
		}
	}

}
