package test;

import ghmessen.util.AkimaInterpolation;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Path2D;
import java.awt.geom.Rectangle2D;

import javax.swing.JFrame;
import javax.swing.WindowConstants;

public class TestInterpolation extends Canvas {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	static double[] xval = { -1, -.75, -.5, -.25, 0, .25, .5, .75, 1 };
	static double[] yval = { 0, 0.4, 0.6, 3, 1, 0.8, 0.6, 0.4, 0 };
	static AkimaInterpolation csInit;
	static double faktor = 100.0;

	AkimaInterpolation cs;

	public TestInterpolation(AkimaInterpolation cs) {
		super();
		this.cs = csInit;
	}

	@Override
	public void paint(Graphics g) {
		Graphics2D g2d = (Graphics2D) g;
		g2d.translate(200.0, 200.0);
		Path2D p = new Path2D.Double(), pl = new Path2D.Double();
		p.moveTo(faktor * cs.getX(0), faktor * cs.getY(0));
		pl.moveTo(faktor * cs.getX(0), faktor * cs.getY(0));
		for (int i = 0; i < 3 * cs.getSegmente(); i += 3) {
			p.curveTo(faktor * cs.getX(i + 1), faktor * cs.getY(i + 1), faktor
					* cs.getX(i + 2), faktor * cs.getY(i + 2),
					faktor * cs.getX(i + 3), faktor * cs.getY(i + 3));
			pl.lineTo(faktor * cs.getX(i + 3), faktor * cs.getY(i + 3));
		}
		g2d.draw(p);
		g2d.setColor(Color.RED);
		g2d.draw(pl);
		g2d.setColor(Color.YELLOW);
		for (int i = 0; i < xval.length; i++)
			g2d.fill(new Rectangle2D.Double(faktor * xval[i], faktor * yval[i],
					2, 2));
	}

	/**
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		csInit = new AkimaInterpolation(xval, yval);
		JFrame jFrame = new JFrame();
		jFrame.add(new TestInterpolation(csInit));
		jFrame.setSize(800, 600);
		jFrame.setVisible(true);
		jFrame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
	}

}
