package test;

import ghmessen.adapter.EAdapterException;

import java.io.IOException;

import ld.api.CASSYRanges;
import ld.api.PowerCASSY;
import ld.api.Waveforms;

public class TestPowerCassy {
	public static void main(String[] args) throws InterruptedException, EAdapterException, IOException{
		PowerCASSY c = new PowerCASSY();
		c.open();
		if(c.getIsOpen()){
			System.out.println("Power-Cassy gefunden.");
			//c.setOutput(0, CASSYRanges.I1A, 0.5);
			//c.setOutput(0, CASSYRanges.U10V, 5.0);
			c.initFunctionGenerator(Waveforms.SqrAsym, 300, 2000, 0, 50);
			c.startFunctionGenerator(true);
			double ua;
			do {
				ua = c.getInput(0,CASSYRanges.U10V);
				System.out.printf("UA = %2.2f V\n",ua);
				Thread.sleep(500);
			} while (true);
		} else
			System.out.println("Kein Power-Cassy gefunden.");
		c.close();
		System.exit(0);
	}
}
