package test;

import ghmessen.groesse.Groesse;

import java.io.IOException;

import ld.api.PocketCASSY;
import ld.api.ios.Box524060;
import ld.api.ios.CASSYIOs;
import ld.api.ios.ICASSYQuantity;
import ld.api.ios.ITare;
import ld.api.ios.ScanMode;

public class TestSensor {

	public static void main(String[] args) throws IOException {
		try {
			PocketCASSY c = new PocketCASSY();
			Box524060 input = new Box524060(c, 0);
			c.open();
			try (CASSYIOs ios = new CASSYIOs()) {
				ios.add(input);
				ios.scan(ScanMode.ScanOnly);
				Groesse g = new Groesse("f_1");
				if (c.getIsOpen() && input.getSensorBoxValid()) {
					System.out
							.println("Pocket-Cassy mit Kraftsensor gefunden.");
					ICASSYQuantity q = input.getQuantityF();
					double wert;
					do {
						wert = q.getValue();
						((ITare) q).doTare();
						g.setWert(q.getValue());
						System.out
								.printf("Kraft vorher = %3.0f mN, nachher = %3.0f mN\n",
										wert, g.getWert());
						Thread.sleep(1000);
					} while (true);
				} else
					System.out
							.println("Kein Pocket-Cassy mit Kraft-Box gefunden.");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.exit(0);

	}
}
