package test;

import gnu.io.CommPortIdentifier;
import gnu.io.NoSuchPortException;
import gnu.io.PortInUseException;
import gnu.io.SerialPort;
import gnu.io.UnsupportedCommOperationException;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class TestSerialIO {
	public static final File INVALID_HANDLE_VALUE = null;

	public static void main(String[] args) {
		String devicePath = "/dev/ttyUSB0";
		SerialPort portHandle;
		int baudrate = 38400, 
		dataBits = SerialPort.DATABITS_8, 
		stopBits = SerialPort.STOPBITS_1, 
		parity = SerialPort.PARITY_NONE, 
		flowControl = SerialPort.FLOWCONTROL_NONE;
		OutputStream osWrite;
		InputStream osRead;
		CommPortIdentifier portId;
		try {
			portId = CommPortIdentifier.getPortIdentifier(devicePath);
		} catch (NoSuchPortException e1) {
			e1.printStackTrace();
			return;
		}
		if (portId == null) {
			System.err
					.println("[TestSerialIO] -  Could not find serial port("
							+ devicePath + ")");
			return;
		}
		try {
			portHandle = (SerialPort) portId.open("GHMessen", 10000);
		} catch (PortInUseException e) {
			System.err
					.println("[USBSerialInterface] - start: Port already in use("
							+ e.getMessage() + ")");
			return;
		}
		try {
			portHandle
					.setSerialPortParams(baudrate, dataBits, stopBits, parity);
			portHandle.setFlowControlMode(flowControl);
		} catch (UnsupportedCommOperationException e) {
			System.err.println("[USBSerialInterface] - start: Fehler("
					+ e.getMessage() + ")");
			return;
		}

		try {
			osRead = portHandle.getInputStream();
			osWrite = portHandle.getOutputStream();
		} catch (IOException e) {
			System.out.println("[USBSerialInterface] - start:" + e.getMessage()
					+ ")");
			return;
		}
		new File(devicePath);

		byte[] getCASSY = {27, -1, 1};
		byte[] antwort = new byte[100];
		try {
			osWrite.write(getCASSY);
			osRead.read(antwort,0,100);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
