package test;

import java.io.IOException;
import java.util.Scanner;

import ghmessen.adapter.EAdapterException;
import ghmessen.adapter.cassy.JustiereXRay;
import ld.api.CASSYException;
import ld.api.XRay;
import ld.api.XRayData;
import ld.api.XRayModes;
import ld.api.XRayPosition;

public class TestXRay {
	/**
	 * @param args
	 * @throws InterruptedException
	 * @throws IOException
	 * @throws EAdapterException 
	 */
	public static void main(String[] args) throws InterruptedException,
			IOException, EAdapterException {
		XRay xray = new XRay();
		xray.setCommPort("USB");
		if (!xray.open()) {
			System.out.println("XRay not found!");
			System.exit(1);
		}
		if (!xray.getMode().isAndEmpty(XRayModes.Scan)) // previous scan not
														// completed
		{
			xray.setMode(new XRayModes(XRayModes.Scan)); // stop scan
			Thread.sleep(4000); // wait for the door to be open before starting
								// the new scan
		}

		JustiereXRay justieren = new JustiereXRay(xray);
		try (Scanner in = new Scanner(System.in)) {
		
		// Motortest
//		xray.setMode(XRayModes.Coupled);
//		xray.setPosition(new XRayPosition(0.0,0.0));
//		justieren.waitForXRay(xray);
//		System.out.print("Bitte ENTER betätigen:");
//		in.nextLine();
//		xray.setPosition(new XRayPosition(10.0,20.0));
//		justieren.waitForXRay(xray);
//		System.out.print("Bitte ENTER betätigen:");
//		in.nextLine();
//		xray.setMode(XRayModes.Target);
//		xray.setPosition(new XRayPosition(20.0,0.0));
//		justieren.waitForXRay(xray);
//		System.out.print("Bitte ENTER betätigen:");
//		in.nextLine();
//		xray.setMode(XRayModes.Sensor);
//		xray.setPosition(new XRayPosition(20.0,20.0));
//		justieren.waitForXRay(xray);
//		System.out.print("Bitte ENTER betätigen:");
//		in.nextLine();
//		System.exit(0);
	
			// Justiere den Kristall
			justieren.justierenDurchfuehren();
			System.exit(0);
			
			// Justiere Nullpunkt des XRay
			justieren.nullSucheDurchfuehren();
			System.exit(0);
			
			// Testmessung
			xray.setMode(new XRayModes(XRayModes.Coupled)); // set scan parameters
			xray.setData(new XRayData(35.0, 1.0, -0.5, 0.5, 0.1, 1));
			xray.setPosition(new XRayPosition(2.5, 5.0)); // position is set
															// automatically during
															// the scan
	
			int i = 0;
			xray.setMode(new XRayModes(XRayModes.Scan)); // start scan
			while (!xray.getMode().isAndEmpty(XRayModes.Scan)) {
				try {
					XRayData data = xray.getMemory(i); // read current data
					System.out.println(String.format("b = %f°\tR = %f /s",
							data.getBeta(), data.getCounts() / data.getGateTime()));
					i++;
				} catch (CASSYException e) {
					Thread.sleep(100); // wait for next data
				}
			}
			xray.setMode(new XRayModes(XRayModes.Scan));
			XRayData data = xray.getMemory(10);
			System.out.println(String.format("b = %f°\tR = %f /s",
					data.getBeta(), data.getCounts() / data.getGateTime()));
		}
	}

}
