package test;

import libGoIO.GoIOSensor;
import libGoIO.GoIOSensorFactory;
import ghmessen.adapter.AdapterMonitor;
import ghmessen.adapter.EAdapterException;
import ghmessen.adapter.event.AdapterAddedEvent;
import ghmessen.adapter.event.AdapterChangedEvent;
import ghmessen.adapter.event.AdapterEventListener;
import ghmessen.adapter.event.AdapterRemovedEvent;
import ghmessen.adapter.goIO.AdapterGoIO;
import ghmessen.adapter.goIO.EingangGoIO;

public class TestgoIOMonitor implements AdapterEventListener {

	AdapterMonitor monitor;
	GoIOSensor sensor;
	EingangGoIO goIO;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TestgoIOMonitor m = new TestgoIOMonitor();
		m.sensor = GoIOSensor.readFromXml(GoIOSensorFactory.createSensorMap().get("Magnetfeldstärke(MG)"));
		m.monitor = new AdapterMonitor();
		m.monitor.registerAdapterClass(AdapterGoIO.class);
		m.monitor.addAdapterEventListener(m);
		m.monitor.start();
		while (true)
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {	}

	}

	@Override
	public void adapterAdded(AdapterAddedEvent evt) {
		try {
			goIO = new EingangGoIO(null, evt.getDevice(), 0);
			System.out.println("Adapter "+evt.getNummer() + " eingebunden...");
			
		} catch (EAdapterException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void adapterRemoved(AdapterRemovedEvent evt) {
		if(goIO != null)
			goIO.close();
		System.out.println("Adapter "+evt.getName()+" entfernt...");
		goIO = null;
		
	}

	@Override
	public void adapterChanged(AdapterChangedEvent evt) {
		System.out.println("[TestGoIOMonitor] - adapterChanged...");
	}
}
