package test;

import ghmessen.adapter.EAdapterException;

import java.io.IOException;

import ld.api.SensorCASSY;
import ld.api.TimerEdges;
import ld.api.TimerModes;
import ld.api.TimerRecord;
import ld.api.TimerRecorder;
import ld.api.ios.Box524070;
import ld.api.ios.CASSYTimerQuantity;
import ld.api.ios.IUltrasonic;

public class USBoxArray {
	public static void main(String[] args) throws InterruptedException,
			EAdapterException, IOException {
		SensorCASSY c = new SensorCASSY();
		c.open();
		Box524070 input = new Box524070(c, 0);
		if (c.getIsOpen() && c.getCASSYType() == c.getCASSYClassType()
				&& input.getSensorBoxValid()) {
			int max = 250, cE = 0;
			System.out
					.println("Sensor-Cassy mit USBox bei Eingang A gefunden.");
			CASSYTimerQuantity q = (CASSYTimerQuantity) input.getQuantityS();
			((IUltrasonic) q).setSmallBeam(true);
			c.resetTimer(0, TimerModes.RecorderUS, false, 0.1, max,
					TimerEdges.Off, null);
			System.out
					.println("Timer-Status nach Reset: " + c.getTimerStatus());
			c.startTimer(true);
			System.out
					.println("Timer-Status nach Start: " + c.getTimerStatus());
			TimerRecord[] times = new TimerRecord[max];
			int n;
			double dt;
			int stop = -100;
			do {
				TimerRecorder tr = c.getTimerRecorder(0);
				// System.out.println("Timer-Status nach TimerRecorder E("+nE[0]+") und F("+nF[0]+"): "+c.getTimerStatus());
				n = Math.min(tr.getECounts(), tr.getFCounts());
				TimerRecord[] newtimes = c.getTimerArray(0, 0, (short) cE,
						(short) (n - cE));
				// System.out.println("Timer-Status nach fill E("+neuE+"): "+c.getTimerStatus());
				if (newtimes.length > 0) {
					for (int i = 0; i < times.length; i++) {
						// Es sind neue Werte vorhanden.
						times[cE + i] = newtimes[i];
					}
					newtimes = c.getTimerArray(0, 1, (short) cE,
							(short) (n - cE));
					for (int i = 0; i < newtimes.length; i++) {
						dt = newtimes[i].getTime() - times[cE].getTime();
						System.out
								.printf("ZeitpunktE = %f s, ZeitpunktF = %f, Differenz = %f s, Position = %3.3f m\n",
										times[cE].getTime(),
										newtimes[i].getTime(), dt, q.getValue());
						cE++;
					}
					Thread.sleep(100);
				}
				stop++;
			} while (stop < 0);
			c.stopTimer(true);
		} else
			System.out.println("Kein Sensor-Cassy mit USBox gefunden.");
		System.exit(0);
	}

}
