package test;

import ghmessen.adapter.EAdapterException;

import java.io.IOException;

import ld.api.SensorCASSY;
import ld.api.TimerEdges;
import ld.api.TimerModes;
import ld.api.TimerStates;
import ld.api.ios.Box524070;
import ld.api.ios.CASSYIOs;
import ld.api.ios.CASSYTimerQuantity;
import ld.api.ios.CASSYTimerTime;
import ld.api.ios.IUltrasonic;
import ld.api.ios.ScanMode;

public class USBoxMessung {
	public static void main(String[] args) throws InterruptedException,
			EAdapterException, IOException {
		SensorCASSY c = new SensorCASSY();
		c.open();
		try (CASSYIOs ios = new CASSYIOs()) {
			ios.setAutoDefaults(true);
			Box524070 box;
			ios.add(box = new Box524070(c, 0));
			ios.scan(ScanMode.ScanOnly);
			if (c != null && box.getSensorBoxValid()) {
				CASSYTimerTime t = (CASSYTimerTime) box.getQuantityTime();
				CASSYTimerQuantity s = (CASSYTimerQuantity) box.getQuantityS();
				s.setSelected(true);
				int max = 2500;
				System.out
						.println("Sensor-Cassy mit USBox bei Eingang A gefunden.");
				((IUltrasonic) s).setSmallBeam(true);
				c.resetTimer(0, TimerModes.RecorderUS, false, 0.1, max,
						TimerEdges.Off, null);
				System.out.println("Timer-Status nach Reset: "
						+ c.getTimerStatus());
				c.startTimer(true);
				System.out.println("Timer-Status nach Start: "
						+ c.getTimerStatus());
				int stop = -100;
				do {
					TimerStates ts = c.getTimerStatus();
					if (ts == TimerStates.Stopped || ts == TimerStates.EStopped) {
						System.out.printf(
								"Zeitpunkt = %f s, Position = %3.3f m\n",
								t.getValue(), s.getValue());
					}
					Thread.sleep(100);
					stop++;
				} while (stop < 0);
				c.stopTimer(true);
			} else
				System.out.println("Kein Sensor-Cassy mit USBox gefunden.");
		}
		System.exit(0);
	}

}
